2008-11-19  Andy Stewart  <lazycat.manatee@gmail.com>

	* erc.el (erc-header-line-uses-tabbar-p): New option that makes
	tabbar mode usable with ERC if set to non-nil.
	(erc-update-mode-line-buffer): Use it.

2008-11-19  Glenn Morris  <rgm@gnu.org>

	* erc-compat.el (help-function-arglist): Autoload it.

2008-10-03  Michael Olson  <mwolson@gnu.org>

	* erc-dcc.el (english): Increase size heading by two places.
	(erc-dcc-byte-count): Move higher.
	(erc-dcc-do-LIST-command): Use erc-dcc-byte-count to get accurate
	count.  Coerce byte total to floating point before performing
	computation, otherwise division will truncate to 0.
	(erc-dcc-append-contents): Update erc-dcc-byte-count.
	(erc-dcc-get-filter): Don't update erc-dcc-byte-count, because
	that will give incorrect size totals.  Instead, figure out how
	much we have by summing byte count and current buffer size.
	(erc-dcc-get-sentinel): Don't update erc-dcc-byte-count.

2008-10-01  Michael Olson  <mwolson@gnu.org>

	* erc-dcc.el (erc-pack-int): Make sure returned string is within 4
	bytes.  Always return a 4-byte string, so that we conform to the
	CTCP spec.
	(erc-most-positive-int-bytes): New constant representing the
	number of bytes that most-positive-fixnum can be stored in.
	(erc-most-positive-int-msb): New constant representing the
	contents of the most significant byte of most-positive-fixnum.
	(erc-unpack-int): Make sure that the integer we get back can be
	represented in Emacs.
	(erc-dcc-do-CLOSE-command): Update docstring.  Don't use the line
	variable.  Try to disambiguate between type and nick when only one
	is provided.  Validate both type and nick arguments.  Allow
	matching by just nick.
	(erc-dcc-append-contents): Set inhibit-read-only to t.  Prevent
	auto-compression from triggering when we write the contents to a
	file.
	(erc-dcc-get-file): Prevent auto-compression from triggering when
	we truncate a file.

2008-07-27  Dan Nicolaescu  <dann@ics.uci.edu>

	* erc.el: Remove code for Carbon.

2008-06-07  Glenn Morris  <rgm@gnu.org>

	* erc-autoaway.el, erc-ibuffer.el, erc-menu.el:
	* erc-stamp.el, erc.el: Remove unnecessary eval-when-compiles.

2008-05-30  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (328): New response handler.

	* erc.el (english): Add 328 to catalog.

2008-05-29  Diane Murray  <disumu@x3y2z1.net>

	* erc-services.el (erc-nickserv-alist): Update REGEXP and
	SUCCESS-REGEXP for freenode.

2008-05-05  Juanma Barranquero  <lekktu@gmail.com>

	* erc-goodies.el (erc-noncommands-list, noncommands)
	(erc-control-characters, erc-interpret-controls-p)
	(erc-interpret-mirc-color): Fix typos in docstrings.
	(erc-controls-highlight): Reflow docstring.

2008-04-26  Johan Bockgård  <bojohan@gnu.org>

	* erc.el (erc-put-text-properties): Don't use mapcar*.
	(erc-display-line-1): Fix argument order in call to
	erc-put-text-properties.

2008-04-14  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-remove-text-properties-region): Disable this command
	by default.  Thanks to e1f for the suggestion.

2008-02-20  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-notice-face): Fix this face for Emacs 21 users.

2008-02-05  Juanma Barranquero  <lekktu@gmail.com>

	* erc.el (erc-valid-nick-regexp):
	* erc-button.el (erc-button-syntax-table):
	* erc-match.el (erc-match-syntax-table): Replace `legal' with `valid'.

2008-02-04  Jeremy Maitin-Shepard  <jbms@cmu.edu>

	* erc.el (erc-cmd-QUERY): Bind the value of `erc-auto-query' to
	`erc-query-display' rather than `erc-join-buffer'.  This fixes a
	bug where the value of erc-auto-query was being ignored.

2008-01-31  Michael Olson  <mwolson@gnu.org>

	* erc-dcc.el (erc-dcc-do-GET-command, erc-dcc-do-SEND-command):
	Improve docstring.  If FILE argument is split into multiple
	arguments, re-join them into a single string, separated by a
	space.  This fixes an issue where the user wants to send or
	receive a file with spaces in its name.  It is assumed that no one
	will try sending or receiving a file with multiple consecutive
	spaces in its name, otherwise this fix will fail.

	* erc.el (erc-mode-map): Add binding for C-c C-x to
	erc-quit-server, since rcirc.el binds its quit command in a
	similar manner.  Thanks to Jari Aalto for the suggestion.

2008-01-28  Diane Murray  <disumu@x3y2z1.net>

	* erc-list-old.el (list-old): Define module as list-old, not list.
	This fixes a bug where an unknown module error would occur when
	starting ERC and using the list-old module.

	* erc-track.el (erc-track-find-face): If no choice was found
	return nil to use the default mode-line faces.

2008-01-26  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-version-string): Release ERC 5.3.

	* Makefile (VERSION): Update.
	(EXTRAS): Remove erc-list.el after all, because this is mainly for
	users of the version that comes with Emacs, and they will have
	erc-list.el by Emacs 23.
	(MISC): Add ChangeLog.07.
	(elpa): Fix build issue.  Add proper version to erc-pkg.el.

	* README.extras: Mention Emacs 23.

	* erc-pkg.el: Make the version string a template.

	* erc.texi (Obtaining ERC): Update extras URLs for 5.3.
	(Development): Write instructions for git, and remove those for Arch.
	(History): Mention the switch to git.

2008-01-25  Michael Olson  <mwolson@gnu.org>

	* NEWS: Update.

	* erc-goodies.el (keep-place): New module which keeps your place
	in unvisited ERC buffers when new messages arrive.  This is mostly
	taken from Johan Bockgård's init file.
	(erc-noncommands-list): Move to correct place.

	* erc-networks.el: Add a module definition.

	* erc-services.el (erc-nickserv-identify-mode): Force-enable the
	networks module, because we need it to set erc-network for us.

	* erc-track.el (erc-track-faces-normal-list): Indicate in the
	docstring that this variable can be set to nil.

	* erc.el: On second thought, don't load erc-networks.  Just enable
	the networks module by default.
	(erc-modules): Add option for keep-place and networks.  Enable
	networks by default.
	(erc-version-string): Make release candidate 1 available.

2008-01-24  Michael Olson  <mwolson@gnu.org>

	* erc.el: Load erc-networks.el so that functions get access to the
	`erc-network-name' function.

	* erc-track.el (erc-track-faces-normal-list): Add
	erc-dangerous-host-face.
	(erc-track-exclude-types): Add 333 and 353 to the default list of
	things to ignore, and explain what they are in the docstring.

2008-01-23  Michael Olson  <mwolson@gnu.org>

	* erc-track.el (erc-track-faces-priority-list): Move
	erc-nick-default-face higher, so that it can be used for the
	activity indication effect.  Add erc-current-nick-face,
	erc-pal-face, erc-dangerous-host-face, and erc-fool-face by
	themselves.
	(erc-track-faces-normal-list): New option that contains a list of
	faces to consider "normal".
	(erc-track-position-in-mode-line): Minor docfix.
	(erc-track-find-face): Use erc-track-faces-normal-list to produce
	a sort of blinking activity effect.

2008-01-22  Michael Olson  <mwolson@gnu.org>

	* erc-button.el (erc-button-add-nickname-buttons): When in a
	channel buffer, only look at nicks from the current channel.
	Thanks to e1f for the report.

2008-01-21  Michael Olson  <mwolson@gnu.org>

	* erc-compat.el (erc-const-expr-p, erc-list*, erc-assert): Remove,
	since we can use the default `assert' function without it causing
	us any problems, even in Emacs 21.  Thanks to bojohan for the
	suggestion.

	* erc-goodies.el (move-to-prompt): Use the "XEmacs" method
	instead, because the [remap ...] method interferes with
	delete-selection-mode.
	(erc-move-to-prompt): Rename from erc-move-to-prompt-xemacs.
	Deactivate mark and call push-mark before moving point.  Thanks to
	bojohan for the suggestion.
	(erc-move-to-prompt-setup): Rename from
	erc-move-to-prompt-init-xemacs.

	* erc-track.el (erc-track-faces-priority-list): Replace erc-button
	with '(erc-button erc-default-face) so that we only care about
	buttons that are part of normal text.  Adjust customization type
	to handle this case.  Make erc-nick-default-face a list.  Handle
	pals, fools, current nick, and dangerous hosts.
	(erc-track-find-face): Simplify.  Adapt for list of faces case.
	(erc-faces-in): Don't deflate lists of faces.  Add them as-is.
	(erc-track-face-priority): Use equal instead of eq.

2008-01-20  Michael Olson  <mwolson@gnu.org>

	* erc-goodies.el (erc-move-to-prompt, erc-move-to-prompt-xemacs):
	Fix off-by-one error that caused the point to move when placed at
	the beginning of some already-typed text.  Thanks to e1f for the
	report.

	* erc-dcc.el, erc-xdcc.el: Add simple module definitions.

	* erc.el (erc-modules): Add dcc and xdcc.

2008-01-19  Michael Olson  <mwolson@gnu.org>

	* erc-bbdb.el (erc-bbdb-insinuate-and-show-entry): Work around bug
	in XEmacs 21.4 that throws an error when the first argument to
	run-at-time is nil.

	* erc-button.el (button): Undo XEmacs-specific change to all ERC
	buffers when module is removed.
	(erc-button-setup): Rename from erc-button-add-keys, and move
	XEmacs-specific stuff here.

	* erc-goodies.el (erc-unmorse): Improve regexp for detecting
	morse.  Deal with the morse style that has "/ " at the end of
	every letter.
	(erc-imenu-setup): New function that sets up Imenu support.  Add
	it instead of a lambda form to erc-mode-hook.
	(scrolltobottom): Remove erc-scroll-to-bottom from all ERC buffers
	when module is removed.  Activate the functionality in all ERC
	buffers when the module is activated, rather than leaving it up to
	the user.
	(move-to-prompt): New module that moves to the ERC prompt if a
	user tries to type elsewhere in the buffer, and then inserts their
	keystrokes there.  This is mostly taken from Johan Bockgård's init
	file.
	(erc-move-to-prompt): New function that implements this.
	(erc-move-to-prompt-xemacs): New function that implements this for
	XEmacs.
	(erc-move-to-prompt-init-xemacs): New function to perform the
	extra initialization step needed for XEmacs.

	* erc-page.el, erc-replace.el: Fix header and footer.

	* erc-track.el (erc-track-minor-mode-maybe): Take an optional
	buffer arg so that we can put this in erc-connect-pre-hook.  If
	given this argument, include it in the check to determine whether
	to activate erc-track-minor-mode.
	(track): Add erc-track-minor-mode-maybe to erc-connect-pre-hook,
	so that we can use it as soon as a connection is attempted.

	* erc.el (erc-format-network, erc-format-target-and/or-network):
	Use erc-network-name function instead, and check to see whether
	that function is bound.  This fixes an error in process filter for
	people who did not have erc-services or erc-networks loaded.
	(erc-modules): Add move-to-prompt module and enable it by
	default.  Thanks to e1f for the suggestion.

2008-01-18  Michael Olson  <mwolson@gnu.org>

	* Makefile (EXTRAS): Include erc-list-old.el.

	* erc-dcc.el (erc-dcc-verbose): Rename from erc-verbose-dcc.
	(erc-pack-int): Rewrite to not depend on a count argument.
	(erc-unpack-int): Rewrite to remove 4-character limitation.
	(erc-dcc-server): Call set-process-coding-system and
	set-process-filter-multibyte so that the contents get sent out
	without modification.
	(erc-dcc-send-filter): Don't take a substring -- just pass the
	whole string to erc-unpack-int.
	(erc-dcc-receive-cache): New option that indicates the number of
	bytes to let the receive buffer grow before flushing it.
	(erc-dcc-file-name): New buffer-local variable to keep track of
	the filename of the currently-received file.
	(erc-dcc-get-file): Disable undo for a speed increase.  Set
	erc-dcc-file-name.  Truncate the file before writing to it.
	(erc-dcc-append-contents): New function to append the contents of
	a buffer to a file and then erase the contents of the buffer.
	(erc-dcc-get-filter): Flush buffer contents after exceeding
	erc-dcc-receive-cache.  This allows large files to be downloaded
	without storing the whole thing in memory.
	(erc-dcc-get-sentinel): Flush any remaining contents before
	closing.  No need to save buffer.
	(erc-dcc-listen-host): New option that determines which IP address
	to listen on.
	(erc-dcc-public-host): New option that determines which IP address
	to advertise when sending a file.  This is useful for people who
	are on a local subnet.  Together, these two options replace
	erc-dcc-host.

	* erc.el (erc-mode-line-format): Add %N and %S.  %N is the name of
	the network, and %S is much like %s but with the network name
	trumping the server name.  Default to "%S %a".  Thanks to e1f for
	the suggestion.
	(erc-format-network): New function that formats the network name.
	(erc-format-target-and/or-network): New function that formats both
	the network name and target, falling back on the server name if
	the network name is not available.
	(erc-update-mode-line-buffer): Add the new format spec items.

2008-01-17  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-join-buffer): Improve documentation.
	(erc-query-display): New option indicating how to display a query
	buffer that is made by using the /QUERY command.  The default is
	to display the query in a new window.
	(erc-cmd-QUERY): Use it.  Improve docstring.
	(erc-auto-query): Default this to 'window-noselect instead,
	because I've already seen bug reports about new users thinking
	that ERC didn't display their test messages.  Improve
	customization type.
	(erc-notice-face): Make this work with XEmacs.
	(erc-join-buffer): Mention 'buffer in docstring.  Improve
	customization type.

	* erc-dcc.el (erc-dcc-send-sentinel): Better handle case where elt
	is nil, in order to avoid an error.  Thanks to Brent Goodrick for
	the initial patch.
	(erc-dcc-display-send): New function split from erc-dcc-send-hook.
	(erc-dcc-send-connect-hook): Use it -- we don't like lambda forms
	in hooks.
	(erc-dcc-send-filter): Display byte count if the client confirmed
	too much, and kill the buffer.  Otherwise a DoS might be possible
	by making Emacs run out of RAM.

	* erc-backend.el (erc-server-connect): Detect early on whether the
	connection attempt has failed in order to avoid confusing error
	messages.

	* erc-networks.el (erc-server-alist): Add Rizon network.

	* erc-services.el (erc-nickserv-passwords): Add Rizon to options.
	(erc-nickserv-alist): Add support for Rizon.

	* erc-track.el (erc-track-find-face): Don't let buttons in notices
	trump default text.  Use catch/throw.  Default to first element of
	FACES is nothing is found.

	* erc-xdcc.el: Add local variables for proper indentation setup.

2008-01-15  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-server-coding-system): Docfix.
	(erc-coding-system-for-target): Pass the `target' argument along
	as the first and only argument.  It's not good to just depend on a
	dynamic binding.

2008-01-10  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (321, 322): Split message-displaying parts into
	new functions, which are added to each response's respective
	hook.  This makes them easier to disable.

	* erc-list.el: New file from Tom Tromey.  Use erc-propertize
	instead of propertize.  Require 'erc.
	(list): New module definition.  Remove message-displaying
	functions for 321 and 322 response handlers when enabling the
	module, and restore them when disabling.  As a sanity check,
	remove the erc-list-handle-322 function when disabling the module.
	(erc-list-handle-322): Handle the case where we run the LIST
	command, but do not go through the normal steps.
	(erc-cmd-LIST): Add docstring.  Strip initial space from line if
	it is non-nil.  Use make-local-variable to silence compiler
	warning.  Capture current buffer and pass it to
	erc-list-install-322-handler.
	(erc-list-install-322-handler): Take server-buffer argument, so
	that we are certain of being in the right buffer.  Use 4th
	argument to add-hook, so that erc-server-322-functions is only
	modified in one buffer.

	* erc-list-old.el: Renamed from old erc-list.el.

	* erc.el (erc-modules): Add list-old.
	(erc-set-topic): Handle case where there are no newlines in the
	existing topic, which happens when /LIST is run.
	(erc-notice-face): If we have less than 88 colors, make this
	blue.  Otherwise the text will be pink in a tty, which looks
	dreadful.  Thanks to e1f for the report.
	(erc-remove-parsed-property): New option that determines whether
	to remove the erc-parsed property after displaying a message.
	This should have the effect of making ERC take up less memory.
	(erc-display-line-1): Use it.

2008-01-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* erc-ibuffer.el (erc-channel-modes):
	Pass mode-name through format-mode-line

2007-12-16  Diane Murray  <disumu@x3y2z1.net>

	* erc-services.el (erc-nickserv-alist): Removed autodetect regexp,
	added identified regexp for OFTC.
	(erc-nickserv-identification-autodetect): Make sure success-regex
	is non-nil.
	(erc-nickserv-identify-autodetect): Make sure identify-regex is
	non-nil.  Doc fix.

2007-12-13  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (PRIVMSG, QUIT, TOPIC, WALLOPS, 376, 004, 221)
	(312, 315, 319, 330, 331, 333, 367, 368, 391, 405, 406, 412)
	(421, 432, 433, 437, 442, 461, 474, 477, 482, 431): Doc fix.

2007-12-09  Michael Olson  <mwolson@gnu.org>

	* erc-services.el (erc-nickserv-alist): Fix regexps for GRnet.

2007-12-09  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* erc-backend.el, erc.el:
	Parse 275 (secure connection) responses.

	* erc-services.el: Add identification hooks for GRnet, the Greek
	IRC network <http://www.irc.gr>.

2007-12-08  David Kastrup  <dak@gnu.org>

	* erc-stamp.el (erc-echo-timestamp):
	* erc-lang.el (language):
	* erc-backend.el (erc-server-connect): Fix buggy call to `message'.

2007-12-07  Theresa O'Connor  <ted@oconnor.cx>

	* erc-services.el: Provide a hook that runs when nickserv confirms
	that the user has successfully identified.
	(services, erc-nickserv-identify-mode): Add and remove
	erc-nickserv-identification-autodetect from
	erc-server-NOTICE-functions.
	(erc-nickserv-alist): Add SUCCESS-REGEXP to each entry.
	(erc-nickserv-alist-identified-regexp)
	(erc-nickserv-identification-autodetect): New functions.
	(erc-nickserv-identified-hook): New hook.

2007-12-06  Deepak Goel  <deego3@gmail.com>

	* erc-match.el (erc-add-entry-to-list): Fix buggy call to `error'.

2007-12-01  Glenn Morris  <rgm@gnu.org>

	* erc-backend.el (erc-server-send-ping): Move after definition of
	erc-server-send.

2007-11-29  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* erc-backend.el, erc.el:
	Parse 307 (nick has identified) responses.

2007-11-15  Juanma Barranquero  <lekktu@gmail.com>

	* erc.el (erc-open):
	* erc-backend.el (define-erc-response-handler):
	* erc-log.el (log):
	* erc-match.el (erc-log-matches): Fix typos in docstrings.

2007-11-11  Michael Olson  <mwolson@gnu.org>

	* erc-autoaway.el (erc-autoaway-possibly-set-away):
	* erc-netsplit.el (erc-netsplit-timer):
	* erc-notify.el (erc-notify-timer):
	* erc-track.el (erc-user-is-active): Only run if we have
	successfully established a connection to the server and have
	logged in.  I suspect that sending messages too soon may make some
	IRC servers not respond well, particularly when the network
	connection is iffy or subject to traffic-shaping.

2007-11-01  Michael Olson  <mwolson@gnu.org>

	* erc-compat.el (erc-set-write-file-functions): New compatibility
	function to set the write hooks appropriately.

	* erc-log.el (erc-log-setup-logging): Use
	erc-set-write-file-functions.  This fixes a byte-compiler warning.

	* erc-stamp.el: Silence byte-compiler warning about
	erc-fill-column.

	* erc.el (erc-with-all-buffers-of-server): Bind the result of
	mapcar to a variable in order to silence a byte-compiler warning.

2007-10-29  Michael Olson  <mwolson@gnu.org>

	* erc-ibuffer.el (erc-modified-channels-alist): Use
	eval-when-compile, and explain why we are doing this.

2007-10-25  Dan Nicolaescu  <dann@ics.uci.edu>

	* erc-ibuffer.el (erc-modified-channels-alist): Pacify
	byte-compiler.

2007-10-13  Glenn Morris  <rgm@gnu.org>

	* erc-track.el (erc-modified-channels-update): Use mapc rather
	than mapcar.

2007-10-12  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-join-channel): Prompt for channel key if C-u or
	another prefix-arg was typed.

	* NEWS: Noted this change.

2007-10-07  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-cmd-ME'S): New command that handles the case where
	someone types "/me's".  It concatenates the text " 's" to the
	beginning of the input and then sends the result like a normal
	"/me" command.
	(erc-command-regexp): Permit single-quote character.

2007-09-30  Aidan Kehoe  <kehoea@parhasard.net>  (tiny change)

	* erc-log.el (erc-save-buffer-in-logs): Prevent spurious warnings
	when looking at a log file and concurrently saving to it.

2007-09-18  Exal de Jesus Garcia Carrillo  <exal@gnu.org>  (tiny change)

	* erc.texi (Special-Features): Fix small typo.

2007-09-16  Michael Olson  <mwolson@gnu.org>

	* erc-track.el (erc-track-switch-direction): Mention
	erc-track-faces-priority-list.  Thanks to Leo for the suggestion.

2007-09-11  Exal de Jesus Garcia Carrillo  <exal@gnu.org>  (tiny change)

	* erc-sound.el: Fix typo in setting up instructions.

2007-09-10  Michael Olson  <mwolson@gnu.org>

	* Makefile (elpa): Copy dir template rather than echoing a few
	lines.  The reason for this is that the ELPA package for ERC was
	getting a corrupt dir entry.

	* dir-template: Template for the ELPA dir file.

2007-09-08  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (erc-log-filter-function): New option that specifies
	the function to call for filtering text before writing it to a log
	file.  Thanks to David O'Toole for the suggestion.
	(erc-save-buffer-in-logs): Use erc-log-filter-function.  Make sure
	we carry along the value of coding-system-for-write, because this
	could potentially be shadowed by the temporary buffer.

	* erc.el (erc-version-string): Update to 5.3, development version.

2007-09-07  Glenn Morris  <rgm@gnu.org>

	* erc.el (erc-toggle-debug-irc-protocol): Fix call to
	erc-view-mode-enter.

2007-08-08  Glenn Morris  <rgm@gnu.org>

	* erc-log.el, erc.el: Replace `iff' in doc-strings and comments.

2007-09-03  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-default-port): Make this an integer value rather
	than a string.  Thanks to Luca Capello for the report.

2007-08-27  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-cmd-GQUIT): If erc-kill-queries-on-quit is non-nil,
	kill all query buffers after 4 seconds.

2007-08-16  Michael Olson  <mwolson@gnu.org>

	* NEWS: Add ERC 5.3 changes section, and mention jbms' erc-track
	compatibility note.

	* erc-track.el (erc-track-list-changed-hook): Turn this into a
	customizable option.
	(erc-track-switch-direction): Add 'importance option.
	(erc-modified-channels-display): If erc-track-switch-direction is
	'importance, call erc-track-sort-by-importance.
	(erc-track-face-priority): New function that returns a number
	indicating the position of a face in erc-track-faces-priority-list.
	(erc-track-sort-by-importance): New function that sorts
	erc-modified-channels-list according to erc-track-face-priority.
	(erc-track-get-active-buffer): Make 'oldest a rough opposite of
	'importance.

2007-08-14  Jeremy Maitin-Shepard  <jbms@cmu.edu>

	* erc-track.el (erc-track-remove-disconnected-buffers): New
	variable which controls whether buffers associated with a server
	that is disconnected should be removed from
	`erc-modified-channels-alist'.  Existing behavior is to
	unconditionally remove such buffers, which is achieved by setting
	`erc-track-removed-disconnected-buffers' to t.  When set to t,
	which is the new default value, such buffers remain in the list,
	which I think is often the desired behavior, since the user may
	likely wish to find out about activity that occurred in a channel
	prior to it being disconnected.
	(erc-track-list-changed-hook): New hook that is run whenever the
	contents of `erc-modified-channels-alist' changes; it is useful
	for users such as myself that don't use the default mode-line
	notification but instead use a separate mechanism (which is tied
	to my window manager) to provide notification of channel activity.
	(erc-track-get-buffer-window): New function that acts as a wrapper
	around `get-buffer-window' that handles the `selected-visible'
	option of `erc-track-visibility'; previously, the value of
	`erc-track-visibility' was passed directly to `get-buffer-window',
	which does not support `selected-visible'; consequently,
	`selected-visible' was not properly supported.
	(erc-track-modified-channels): Fix a bug in the logic for removing
	buffers from the list in certain cases.
	(erc-track-position-in-mode-line): Add a supported value that
	specifies that the tracking information should not be added to the
	mode line at all.  The value of nil is used to indicate that the
	information should not be added at all to the mode line.
	(erc-track-add-to-mode-line): Check for position eq to t, rather
	than non-nil.
	(erc-buffer-visible): Use erc-track-get-buffer-window.
	(erc-modified-channels-update): Take
	erc-track-remove-disconnected-buffers into account.
	(erc-modified-channels-display): Run `erc-track-list-changed-hook'.

	* erc.el (erc-reuse-frames): New option that determines whether
	new frames are always created.  Defaults to t.  This only has an
	effect when erc-join-buffer is set to 'frame.
	(erc-setup-buffer): Use it.

2007-08-14  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-server-reconnect): If the server buffer has
	been killed, use the current buffer instead.  If the current
	buffer is not an ERC buffer, give an error.  This fixes a bug when
	/reconnect is run from a channel buffer whose server buffer has
	been deleted.  Thanks to jbms for the report.
	(erc-process-sentinel-1): Take server buffer as an argument, so
	that we can make sure that it is current.
	(erc-process-sentinel): Pass buffer to erc-process-sentinel-1.
	(erc-process-sentinel-2): New function split from
	erc-process-sentinel-1.  If server buffer is deleted during a
	reconnect attempt, stop trying to reconnect.  Fix bug where
	reconnect was not happening when erc-server-reconnect-attempts was
	t.  Call erc-server-reconnect-p only once each time.  If we are
	instructed to try connecting indefinitely, tell the user that they
	can stop this by killing the server buffer.  Call the process
	sentinel by means of run-at-time, so that there is time to kill
	the buffer if need be; this also removes the need for a while
	loop.  Refuse to reconnect again if erc-server-reconnect-timeout
	is not an number.

	* erc.el (erc-command-no-process-p): Fix bug: the return value of
	erc-extract-command-from-line is a list rather than a single
	symbol.  Thanks to jbms for the report.
	(erc-cmd-RECONNECT): Use simpler logic, and use buffer-live-p
	rather than bufferp.
	(erc-send-current-line, erc-display-command, erc-display-msg):
	Handle case where erc-server-process is nil, so that /reconnect
	works.

2007-08-12  Michael Olson  <mwolson@gnu.org>

	* erc-identd.el (erc-identd-filter): Instead of sending an EOF
	character, which now confuses freenode, stop the server process,
	so that no new connections are accepted, and kill the current
	client process.

2007-07-29  Michael Olson  <mwolson@gnu.org>

	* erc-list.el: Relicense to GPLv3.  Since the file was already
	licensed under version 2 or later, it turns out that we do not
	need the permission of all of the authors in order to proceed.

2007-07-13  Michael Olson  <mwolson@gnu.org>

	* erc-goodies.el (erc-get-bg-color-face, erc-get-fg-color-face):
	Use erc-error rather than message and beep.

	* erc-sound.el: Indentation fix.

	* erc.el (erc-command-no-process-p): New function that determines
	if its argument is an ERC command that can be run when the server
	process is not alive.
	(erc-cmd-SET, erc-cmd-CLEAR, erc-cmd-COUNTRY, erc-cmd-HELP)
	(erc-cmd-LASTLOG, erc-cmd-QUIT, erc-cmd-GQUIT)
	(erc-cmd-RECONNECT, erc-cmd-SERVER): Denote that these commands
	can be run even when the server process is not alive.
	(erc-send-current-line): Call erc-command-no-process-p if the
	server process is not alive, to determine if we have a command
	that can be run anyway.  Thanks to Tom Tromey for the bug report.
	(erc-error): New function that either displays a message or throws
	an error, depending on whether debug-on-error is non-nil.
	(erc-cmd-SERVER, erc-send-current-line): Use it.

2007-07-10  Michael Olson  <mwolson@gnu.org>

	* Relicense all FSF-assigned code to GPLv3.

2007-06-25  Michael Olson  <mwolson@gnu.org>

	* erc.texi (Options): Fix typo.
	(Getting Help and Reporting Bugs): Update webpage URL.  Make Gmane
	part more readable.

2007-06-20  Michael Olson  <mwolson@gnu.org>

	* erc-stamp.el (erc-timestamp-format-left): New option that
	specifies the left timestamp to use for
	erc-insert-timestamp-left-and-right.
	(erc-timestamp-format-right): New option that specifies the right
	timestamp to use for erc-insert-timestamp-left-and-right.
	(erc-insert-timestamp-function): Change default to
	erc-insert-timestamp-left-and-right.
	(erc-insert-away-timestamp-function): Ditto.
	(erc-timestamp-last-inserted-left)
	(erc-timestamp-last-inserted-right): New variables to keep track
	of data for erc-insert-timestamp-left-and-right.
	(erc-insert-timestamp-left-and-right): New function that places
	timestamps on both the left and right sides of the screen, but
	only if each timestamp has changed since it was last computed.
	Thanks to offby1 for urging me to merge this.

	* erc.el (erc-open-ssl-stream): Display informative error when
	ssl.el not found.
	(erc-tls): New function to connect using tls.el.
	(erc-open-tls-stream): New function to initiate tls connection.
	Display informative error when tls.el not found.

2007-06-19  Michael Olson  <mwolson@gnu.org>

	* erc-log.el: Update header with accurate instructions.

2007-06-17  Michael Olson  <mwolson@gnu.org>

	* erc-pkg.el: Update description to match what is currently in ELPA.

2007-06-14  Juanma Barranquero  <lekktu@gmail.com>

	* erc-goodies.el (erc-scroll-to-bottom): Remove redundant check.

2007-06-13  Michael Olson  <mwolson@gnu.org>

	* erc-compat.el (erc-with-selected-window): New compatibility
	macro that implements `with-selected-window'.

	* erc-goodies.el (erc-scroll-to-bottom): Use it.  This fixes a bug
	with buffer ordering where ERC buffers would move to the top.
	Thanks to Ivan Kanis for the patch.

2007-06-10  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (erc-logging-enabled): Fix a bug that occurred when
	`erc-log-channels-directory' had the name of a function.

2007-06-06  Juanma Barranquero  <lekktu@gmail.com>

	* erc.el (erc-show-channel-key-p, erc-startup-file-list):
	Fix typo in docstring.

2007-06-03  Michael Olson  <mwolson@gnu.org>

	* erc-compat.el (erc-view-mode-enter): Make this its own function,
	in order to document what we do, and provide sane fallback
	behavior.

	* erc.el (erc-toggle-debug-irc-protocol): Don't pass any arguments
	to erc-view-mode-enter, since we don't do anything special with
	the exit function.  This fixes a bug with Emacs 21 and Emacs 22.
	Thanks to Leo for noticing.

2007-05-30  Michael Olson  <mwolson@gnu.org>

	* erc-compat.el (erc-user-emacs-directory): New variable that
	determines where to find user-specific Emacs settings.  For Emacs,
	this is usually ~/.emacs.d, and for XEmacs this is usually
	~/.xemacs.

	* erc.el (erc-startup-file-list): Use erc-user-emacs-directory.

2007-05-28  Michael Olson  <mwolson@gnu.org>

	* erc-button.el (erc-button-url-regexp): Recognize parentheses as
	part of URLs.  Thanks to Lawrence Mitchell for the fix.

2007-05-26  Michael Olson  <mwolson@gnu.org>

	* erc.texi (Modules): Fix references to completion modules.

2007-05-21  Michael Olson  <mwolson@gnu.org>

	* Makefile (SOURCE): Remove erc-pkg.el.
	(debclean): New rule to clean old Debian packages of ERC.
	(debprepare): Don't modify the released tarball, but copy it as
	the .orig.tar.gz file.
	(debrelease, debrevision): Remove.
	(debinstall): New target that copies the generated Debian file to
	a distro-specific location.
	(deb): New rule that chains together the stages in building a
	Debian package.
	(EXTRAS): Add erc-nicklist.el, since it is not release-quality.
	(extras): Copy images directory.

	* erc-nicklist.el (erc-nicklist-icons-directory): Use
	locate-library to find the "images" directory.  This should be
	more failsafe.  Thanks to Tom Tromey for the idea.

2007-05-19  Michael Olson  <mwolson@gnu.org>

	* Makefile (ELPA): New variable that contains the location of my
	local ELPA repository.
	(elpa): New rule that makes an ELPA package for ERC.

2007-04-19  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-parse-prefix): New function that retrieves the
	PREFIX server parameter from the current server and returns an
	alist of prefix type to prefix character.
	(erc-channel-receive-names): Use `erc-parse-prefix' to determine
	whether the first character of a nick is a prefix character or
	not.  This should fix a bug reported by bromine about needing to
	type "%" first to complete nicks of people who are "hops" on
	Slashnet.  This should also support for very exotic IRC server
	setups, if any exist.
	(erc-update-current-channel-member): Indentation.

2007-04-15  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (erc-generate-log-file-name-function): Docfix.
	Mention how to deal with the case for putting log files in
	different directories.  Change a customization type from `symbol'
	to `function'.
	(erc-log-channels-directory): Allow this to contain a function
	name, which is called with the same args as in
	`erc-generate-log-file-name-function'.  Thanks to andrewy for the
	report and use case.
	(erc-current-logfile): Detect if `erc-log-channels-directory' is a
	function and call it with arguments if so.

2007-04-12  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (define-erc-response-handler): Mention that hook
	processing stops when the function returns non-nil.  This should
	help avoid a nasty "gotcha" when making custom functions.  Thanks
	to John Sullivan for the report.

2007-04-08  Diane Murray  <disumu@x3y2z1.net>

	* erc-nicklist.el (erc-nicklist-voiced-position): Fixed
	customization mismatch.

2007-04-01  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-version-string): Release ERC 5.2.

	* erc-auto.in, erc-chess.el, erc-list.el, erc-speak.el:
	* erc-viper.el: Update copyright notices.

	* erc.texi: Make Emacs Lisp source code in this document
	essentially public domain.  Update version to 5.2.
	(Obtaining ERC): Mention extras tarball.
	(Releases): Mention local GNU mirror.
	(Sample Configuration): Remove notice.

	* FOR-RELEASE (5.3): Add item for erc-nicklist.
	Mark NEWS as done.  Mark extras tarball as done.

	* Makefile (VERSION): Increment to 5.2.
	(TESTING): Remove.
	(EXTRAS): New variable containing the contents of our "Emacs 22
	extras" tarball.
	(SOURCE): Remove $(TESTING).
	(MISC): Add COPYING and ChangeLog.06.  Fix ChangeLog.NNNN ->
	ChangeLog.NN.
	(release): Use $(SNAPDIR) instead of erc-$(VERSION).
	(extras): New rule which implements the building of the extras
	tarball.
	(upload-extras): New rule to upload the extras tarball.  It's
	yucky to replicate upload, but oh well.
	(DISTRIBUTOR): New variable used to differentiate between building
	packages for Ubuntu and Debian.
	(debrelease, debrevision): Use it.
	(debbuild): Run linda in addition to lintian.

	* NEWS: Mention extras tarball.  Note which files have been
	renamed.  Note that erc-list is enabled by default, except in
	Emacs 22.

	* README.extras: New file which serves as a README for the extras
	tarball.

2007-03-31  Michael Olson  <mwolson@gnu.org>

	* NEWS: Update for the 5.2 release.

	* FOR-RELEASE: Finish up 5.2 manual item.  Add documentation item
	for 5.3.

	* erc.texi (Sample Session): Flesh out.  Mention #erc.
	(Modules): Defer to 5.3 release.
	(Advanced Usage): Move Sample Configuration chapter ahead of
	unfinished chapters.
	(Sample Configuration): Write.
	(Options): Mention how to see available ERC options.  Defer to 5.3
	release.
	(Tips and Tricks): Remove, since it seems better to just include
	tips and tricks in the sample configuration, commented out.

	* erc-bbdb.el (erc-bbdb-search-name-and-create): Make prompt more
	informative about how to skip merging.
	(erc-bbdb-insinuate-and-show-entry-1): Move contents of
	erc-bbdb-insinuate-and-show-entry here.
	(erc-bbdb-insinuate-and-show-entry): Run
	erc-bbdb-insinuate-and-show-entry-1 "outside" of the calling
	function, so that we can avoid triggering a process-filter error
	if the user hits C-g.

2007-03-30  Michael Olson  <mwolson@gnu.org>

	* FOR-RELEASE: Solve C-c C-SPC keybinding dilemma.

	* erc-autoaway.el (erc-autoaway-idle-method): Use `if' rather than
	`cond' and `set' rather than `set-default'.

	* erc-log.el: Avoid compiler warning by requiring erc-network
	during compilation.
	(erc-generate-log-file-name-function): Add tag to each option.
	Add erc-generate-log-file-name-network.
	(erc-generate-log-file-name-network): New function which generates
	a log file name that uses network name rather than server name,
	when possible.

	* erc-track.el (track): Assimilate track-when-inactive module,
	since there's no need to have two modules in one file -- an option
	will do.  Remove track-modified-channels alias.  Call
	erc-track-minor-mode-maybe, and tear down the minor mode when
	disabling.
	(erc-track-when-inactive): New option which determines whether to
	track visible buffers when inactive.  The default is not to do so.
	(erc-track-visibility): Mention erc-track-when-inactive.
	(erc-buffer-visible): Use erc-track-when-inactive.
	(erc-track-enable-keybindings): New option which determines
	whether to enable the global-level tracking keybindings.  The
	default is to do so, unless they would override another binding,
	in which case we prompt the user about it.
	(erc-track-minor-mode-map): Move global keybindings here.
	(erc-track-minor-mode): New minor mode which only enables the
	keybindings and does nothing else.
	(erc-track-minor-mode-maybe): New function which starts
	erc-track-minor-mode, but only if it hasn't already been started,
	an ERC buffer exists, and the user OK's it, depending on the value
	of `erc-track-enable-keybindings'.
	(erc-track-switch-buffer): Display a message if someone calls this
	without first enabling erc-track-mode.

2007-03-17  Michael Olson  <mwolson@gnu.org>

	* erc.texi (Development): Mention ErcDevelopment page on
	emacswiki.
	(Getting Started): Mention ~/.emacs.d/.ercrc.el and the Customize
	interface.
	(Sample Session): New section that has a very rough draft for a
	sample ERC session.
	(Special Features): New section that explains some of the special
	features of ERC.  Taken from ErcFeatures on emacswiki, with
	enhancements.

2007-03-12  Diane Murray  <disumu@x3y2z1.net>

	* erc-autoaway.el (erc-autoaway-idle-method): When setting the new
	value, disable and re-enable `erc-autoaway-mode' only if it was
	already enabled.  This fixes a bug where autoaway was enabled just
	by loading the file.

2007-03-10  Diane Murray  <disumu@x3y2z1.net>

	* erc-capab.el: Added more information to the Usage section.
	(erc-capab-identify-prefix): Doc fix.
	(erc-capab-identify-unidentified): New face.
	(290): Removed.  Definition moved to erc-backend.el.
	(erc-capab-identify-send-messages): Renamed from
	`erc-capab-send-identify-messages'.
	(erc-capab-identify-setup): Use it.
	(erc-capab-identify-get-unidentified-nickname): Renamed from
	`erc-capab-get-unidentified-nickname'.
	(erc-capab-identify-add-prefix): Use it.  Use
	`erc-capab-identify-unidentified' as the face.

	* erc-backend.el (290): Moved here from erc-capab.el.

	* erc.el (erc-select): Added an autoload cookie.
	(erc-message-type-member, erc-restore-text-properties): Use
	`erc-get-parsed-vector'.
	(erc-auto-query): Set the default to 'bury since many new users
	expect private messages from others to be in dedicated query
	buffers, not the server buffer.
	(erc-common-server-suffixes): Use "freenode" for freenode.net, not
	"OPN".  Added oftc.net.

	* NEWS: Added note about erc-auto-query's new default setting.

2007-03-03  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-open, erc): Docfixes.

2007-03-02  Michael Olson  <mwolson@gnu.org>

	* FOR-RELEASE: Make section for 5.3 release and move erc-backend
	cleanup there.  Awaiting discussion before doing other things.
	Add tasks for merging filename changes from the 5.2 release
	branch, and for making a tarball of modules not in Emacs 22.  Add
	item to remind me to update NEWS.  Mark backtab entry as done.

	* erc-button.el (button): Add call to `erc-button-add-keys'.
	(erc-button-keys-added): New variable tracking whether we've added
	the keys yet.
	(erc-button-add-keys): New function that adds the <backtab> key to
	erc-mode-map.

	* erc.texi: Change version to 5.2 (pre-release).

2007-02-15  Michael Olson  <mwolson@gnu.org>

	* CREDITS: Update.

	* erc-backend.el (erc-server-send-ping-interval): Change to use a
	default of 30 seconds.  Improve customize interface.
	(erc-server-send-ping-timeout): New option that determines when to
	consider a connection stalled and restart it.  The default is
	after 120 seconds.
	(erc-server-send-ping): Use erc-server-send-ping-timeout instead
	of erc-server-send-ping-interval.  If
	erc-server-send-ping-timeout is nil, do not ever kill and restart
	a hung IRC process.

	* erc.el (erc-modules): Include the name of the module in its
	description.  This should make it easier for people to find and
	enable a particular module.

2007-02-15  Vivek Dasmohapatra  <vivek@etla.org>

	* erc.el (erc-cmd-RECONNECT): Kill old process if it is still
	alive.
	(erc-message-english-PART): Properly escape "%" characters in
	reason.

	* erc-backend.el (erc-server-reconnecting): New variable that is
	set when the user requests a reconnect, but the old process is
	still alive.  This forces the reconnect to work even though the
	process is killed manually during reconnect.
	(erc-server-connect): Initialize it.
	(erc-server-reconnect-p): Use it.
	(erc-process-sentinel-1): Set it to nil after the first reconnect
	attempt.

2007-02-07  Diane Murray  <disumu@x3y2z1.net>

	* erc-menu.el (erc-menu-definition): Fixed so that the separator
	is between "Current channel" and "Pals, fools and other keywords",
	not at the bottom of the "Current channel" submenu.

2007-01-25  Diane Murray  <disumu@x3y2z1.net>

	* erc-networks.el (erc-server-alist): Removed SSL server for now
	since `erc-server-select' doesn't know to use `erc-ssl'.

	* erc-networks.el (erc-server-alist, erc-networks-alist): Added
	definitions for oftc.net.

	* erc-services.el (erc-nickserv-alist): Fixed OFTC message regexp.

2007-01-22  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-server-error-occurred): New variable that
	indicates when an error has been signaled by the server.  This
	should fix an infinite reconnect bug when giving some servers a
	bogus :full-name.  Thanks to Angelina Carlton for the report.
	(erc-server-connect): Initialize erc-server-error-occurred.
	(erc-server-reconnect-p): Use it.
	(ERROR): Set it.

	* erc-services.el (erc-nickserv-alist): Alphabetize and add Ars
	and QuakeNet.  Standardize look of entries.  Fix type mismatch
	error in customize interface.
	(erc-nickserv-passwords): Alphabetize and add missing entries from
	erc-nickserv-alist.

2007-01-21  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-header-line-format): Document how to disable the
	header line, and add a customization type for it.  Also, make the
	changes take effect immediately.

2007-01-19  Michael Olson  <mwolson@gnu.org>

	* erc.texi (Modules): Document new menu module.  Thanks to Leo
	for noticing.

2007-01-16  Diane Murray  <disumu@x3y2z1.net>

	* erc-stamp.el (erc-insert-timestamp-left): Fixed so that the
	whitespace string filler is hidden correctly when timestamps are
	hidden.
	(erc-toggle-timestamps): New function to use instead of
	`erc-show-timestamps' and `erc-hide-timestamps'.

	* erc.el (erc-restore-text-properties): Moved here from
	erc-fill.el since it could be useful in general.

	* erc-fill.el (erc-restore-text-properties): Removed.

2007-01-13  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-command-regexp): New variable that is used to match
	a command.
	(erc-send-input): Use it.  This fixes a bug where paths --
	"/usr/bin/foo", for example -- were being displayed as commands,
	but still sent correctly.
	(erc-extract-command-from-line): Use it.

	* erc.texi (Modules): Document erc-capab-identify.

2007-01-11  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-find-parsed-property): Moved here from erc-track.el
	since it can be useful in general.

	* erc-track.el (erc-find-parsed-property): Removed.

	* erc-capab.el (erc-capab-find-parsed): Removed.
	(erc-capab-identify-add-prefix): Use `erc-find-parsed-property'.

	* erc.el (erc-open): Run `erc-before-connect' hook here.  This
	makes sure the hook always gets called before a connection is
	made, as some functions, like `erc-handle-irc-url', use `erc-open'
	instead of `erc'.
	(erc): Removed `erc-before-connect' hook.

	* erc-menu.el (erc-menu-definition): Put items specific to
	channels in a "Current channel" submenu.

	* erc-backend.el (321, 323): Display channel list in server buffer
	when not using the channel list module.

	* erc.el: Updated copyright years.
	(erc-version-string): Set to 5.2 (devel).
	(erc-format-lag-time): Fixed to work when `erc-server-lag' is nil.
	(erc-update-mode-line-buffer): Set the header face.

2007-01-11  Michael Olson  <mwolson@gnu.org>

	* erc-bbdb.el (erc-bbdb-popup-type): Fix customization type and
	documentation.

	* erc-services.el (erc-nickserv-identify-mode): Improve
	documentation for nick-change option and move higher to fix
	compiler warning.  Avoid a recursive load error.
	(erc-nickserv-alist): Add simple entry for BitlBee, to avoid
	"NickServ is AWAY: User is offline" error.  Oddly enough, bitlbee
	was smart enough to recognize that as an authentication request
	and log in regardless, which is why I didn't notice this earlier.
	(erc-nickserv-alist-sender, erc-nickserv-alist-regexp)
	(erc-nickserv-alist-nickserv, erc-nickserv-alist-ident-keyword)
	(erc-nickserv-alist-use-nick-p)
	(erc-nickserv-alist-ident-command): New accessors for
	erc-nickserv-alist.  Using nth is unwieldy.
	(erc-nickserv-identify-autodetect)
	(erc-nickserv-identify-on-connect)
	(erc-nickserv-identify-on-nick-change, erc-nickserv-identify): Use
	the new accessors.

2007-01-11  Diane Murray  <disumu@x3y2z1.net>

	* NEWS: Added note for `erc-my-nick-face'.  Fixed capab-identify
	wording.

2007-01-10  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-mode-line-format): Added %l to documentation.
	(erc-header-line-format): Removed "[IRC]".  Use the new %l
	replacement character.  Doc fix.
	(erc-format-channel-modes): Removed lag code.  Removed parentheses
	from mode string.
	(erc-format-lag-time): New function.
	(erc-update-mode-line-buffer): Use it.

2007-01-10  Michael Olson  <mwolson@gnu.org>

	* erc.el: Fix typo in url-irc-function instructions.

2007-01-09  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-system-name): New option that determines the system
	name to use when logging in.  The default is to figure this out by
	calling `system-name'.
	(erc-login): Use it.

2007-01-07  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-modules): Add the menu module.  This should fix a
	bug with incorrect ERC submenus being displayed.

	* erc-menu.el: Turn this into a module.
	(erc-menu-add, erc-menu-remove): New functions that add and remove
	the ERC menu.

2006-12-28  Michael Olson  <mwolson@gnu.org>

	* erc-list.el: Change header to mention that this is part of ERC,
	rather than GNU Emacs.

	* erc-networks.el (erc-server-alist): Add Ars OpenIRC and
	LinuxChix networks.  Thanks to Angelina Carlton for mentioning
	them.  Properly escape periods in Konfido.Net and Kewl.Org.
	(erc-networks-alist): Add entries for Ars and LinuxChix, though
	the latter does not actually provide an announced network name.

	* erc-services.el (erc-nickserv-identify-mode): Add 'both method,
	which waits for a NickServ message if the network supports it,
	otherwise sends the password after connecting.
	(erc-nickserv-identify-mode): Default to 'both.
	(erc-nickserv-passwords): Add OFTC and Azzurra to custom options.
	(erc-nickserv-alist): Indentation fix.
	(erc-nickserv-identify-on-connect)
	(erc-nickserv-identify-on-nick-change): Handle 'both method.

2006-12-28  Leo Liu  <sdl.web@gmail.com>  (tiny change)

	* erc.el (erc-iswitchb): Wrap body in unwind-protect so that
	hitting C-g does not leave iswitchb-mode on.

2006-12-27  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-cmd-RECONNECT): New command that calls
	erc-server-reconnect.

	* erc-backend.el (erc-server-reconnect-count): New server variable
	that keeps track of reconnection attempts.
	(erc-server-reconnect-attempts): New option that determines the
	number of reconnection attempts that ERC will make per server.
	(erc-server-reconnect-timeout): New option that determines the
	amount of time, in seconds, that ERC will wait between successive
	reconnect attempts.
	(erc-server-reconnect): New function that reestablishes the
	current IRC connection.  Move some commands from
	erc-process-sentinel-1 here.
	(erc-process-sentinel-1): If we have been disconnected, loop until
	we either reconnect or run out of attempts.
	(erc-server-reconnect-p): Move higher and make this a defsubst,
	since I'm worried about the current buffer changing from
	underneath us.  Implement limit of number of reconnect attempts..

	* erc.texi (Getting Started): Update for /RECONNECT command.

2006-12-26  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-open): Restore old point correctly, or at least get
	closer to doing so than before.

2006-12-13  Leo Liu  <sdl.web@gmail.com>  (tiny change)

	* erc.el (erc-iswitchb): Temporarily enable iswitchb mode if it
	isn't active already, instead of leaving it on.

2006-12-10  Juanma Barranquero  <lekktu@gmail.com>

	* erc-ezbounce.el (erc-ezb-init-session-list): Doc fix.

2006-12-08  Michael Olson  <mwolson@gnu.org>

	* erc.el: Re-evaluate contributions from a contributor, and found
	them under 15 lines of non-obvious code, so it is safe to remove
	the copyright notice.
	(erc-modules): Remove list module.

	* erc-list.el: Remove, since a contributor who has not completed
	their assignment has contributed significantly more than 15 lines
	of code to this file.

2006-11-28  Juanma Barranquero  <lekktu@gmail.com>

	* erc.el (erc-cmd-BANLIST, erc-cmd-MASSUNBAN): Simplify.
	(erc-prompt-for-channel-key, erc-ignore-reply-list, erc-send-post-hook)
	(erc-active-buffer, erc-join-buffer, erc-frame-alist, erc-with-buffer)
	(erc-modules, erc-display-message-highlight, erc-process-input-line)
	(erc-cmd-HELP, erc-server-hooks, erc-echo-notice-in-user-buffers)
	(erc-format-my-nick, erc-echo-notice-in-user-and-target-buffers)
	(erc-echo-notice-in-first-user-buffer, erc-connection-established)
	(erc-update-user-nick, erc-update-channel-member, erc-highlight-notice)
	(erc-command-symbol, erc-add-query, erc-process-script-line)
	(erc-determine-parameters, erc-client-info, erc-popup-input-buffer):
	(erc-script-echo): Fix typos in docstrings.
	(erc-channel-user-op-p, erc-channel-user-voice-p, erc-startup-file-list)
	(define-erc-module, erc-once-with-server-event)
	(erc-once-with-server-event-global, erc-debug-irc-protocol)
	(erc-log-irc-protocol, erc-cmd-LOAD, erc-update-user)
	(erc-update-current-channel-member, erc-load-script):
	(erc-mode-line-away-status-format): Doc fixes.

2006-11-20  Andrea Russo  <rastandy@inventati.org>  (tiny change)

	* erc-dcc.el (erc-dcc-chat-setup): Initialize `erc-input-marker'
	before calling `erc-display-prompt'.

2006-11-24  Juanma Barranquero  <lekktu@gmail.com>

	* erc.el (erc-after-connect, erc-open-ssl-stream)
	(erc-display-line-1, erc-display-line):
	* erc-backend.el (005): Fix space/tab mixup in docstrings.

2006-11-20  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-version-string): Call this Version 5.2 stable
	pre-release, since it diverges slightly from our 5.2 branch, in
	that unstable features are not included.
	(erc-update-modules): Display better error message when module not
	found.

2006-11-12  Michael Olson  <mwolson@gnu.org>

	* erc-log.el: Save all log buffers when Emacs exits, in case
	someone ignores the warning about open processes.  Remove the
	advice code in the commentary.
	(erc-save-query-buffers): Docfix.
	(erc-log-save-all-buffers): New function that saves all ERC
	buffers to logs.
	(erc-current-logfile): Fix bug in filename selection, where the
	current buffer was erroneously being preferred over the given
	buffer.

2006-11-08  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-string-to-port): Avoid error when a numerical port
	is passed.  Thanks to Zekeriya KOÇ for the report.

2006-11-08  Łukasz Demianiuk  <ldemianiuk@gmail.com>  (tiny change)

	* erc.el (erc-header-line): Fix typo.

2006-11-06  Juanma Barranquero  <lekktu@gmail.com>

	* erc-dcc.el (erc-dcc-send-file): Fix typo in error message.

	* erc.el (read-passwd):
	* erc-autoaway.el (erc-autoaway-reestablish-idletimer):
	* erc-truncate.el (truncate): Fix typo in docstring.

2006-10-21  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-iswitchb): Fix bug when hitting C-c C-b without
	first loading iswitchb.  Thanks to Leo for the report.

2006-10-10  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-default-port): Make the default be 6667 instead of
	ircd. since Mac OS X apparently has problems with looking up that
	port name.

	* erc-backend.el (353): Receive names after displaying the initial
	message, instead of before.

2006-10-05  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-my-nick-face): New face.
	(erc): Use FULL-NAME argument, not `erc-user-full-name'.  This
	fixes a bug where the :full-name argument passed to the function
	was not respected.
	(erc-format-my-nick): Use `erc-my-nick-face'.  This should help
	make it easier to find messages you sent in conversations when
	`erc-show-my-nick' is non-nil.
	(erc-compute-server): Doc fix.

2006-10-01  John J Foerch  <jjfoerch@earthlink.net>  (tiny change)

	* erc-stamp.el (erc-insert-timestamp-right): Exclude the newline
	from the erc-timestamp field.

2006-09-11  Michael Olson  <mwolson@gnu.org>

	* erc-nicklist.el (erc-nicklist-insert-contents): Add missing
	parenthesis.  Thanks to Stephan Stahl for the report.

2006-09-10  Eric Hanchrow  <offby1@blarg.net>

	* erc.el (erc-cmd-IGNORE): Prompt user if this might be a regexp
	instead of a single user.

2006-09-10  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-generate-new-buffer-name): If this is a server
	buffer and a process exists already, create a new buffer.
	(erc-open): If the IRC session was continued, restore the old
	point.  Thanks to Stephan Stahl for the report.
	(erc-member-ignore-case): Coding style tweak.
	(erc-cmd-UNIGNORE): Quote the user before comparison.  If we don't
	find the user listed verbatim, try to match them against the list
	using string-match.  In this case, prompt as to whether the regexp
	should be removed.
	(erc-ignored-user-p): Remove CL-ism.

	* erc-autoaway.el (erc-autoaway-possibly-set-away): Check to see
	whether we are already away.

	* erc-menu.el: Fix potential compiler warning.

2006-09-07  Diane Murray  <disumu@x3y2z1.net>

	* erc.el: Updated Commentary and URL.
	(erc-iswitchb, erc-display-line, erc-set-modes, erc-update-modes)
	(erc-arrange-session-in-multiple-windows): No need to check if
	`erc-server-process' is bound.
	(erc-server-buffer-live-p): Doc fix.
	(erc-part-from-channel): Don't use any initial contents at prompt.
	(erc-format-nick, erc-format-@nick): Doc fix.  Use `when'.
	(s367): Fixed to support only banmask and channel which is the
	standard.  Also, there's no reason to add a message to each banned
	user entry trying to persuade the user to use /banlist instead of
	/mode #channel +b.  That part of the message was a little
	confusing, anyways.
	(s367-set-by): New catalog entry.  The user who set the ban and
	the time of ban seem to be specific to only certain servers such
	as freenode.

	* erc-autoaway.el (erc-autoaway-idletimer): Doc fix.

	* erc-backend.el (erc-server-process-alive): No need to check if
	`erc-server-process' is bound.
	(367): Use s367 or s367-set-by where appropriate.

	* erc-compat.el: Fixed URL.

	* erc-dcc.el: Updated copyright years.  Added Usage section.
	Changed supported Emacs version number from 21.3.50 to 22 in
	Commentary.

	* erc-ibuffer.el (erc-server-name, erc-target, erc-away): No need
	to check if `erc-server-process' is bound.

	* erc-nicklist.el: Added to the Commentary section an explanation
	that `erc-nicklist-quit' should be called from within the nicklist
	buffer.  Set file coding to utf-8 so a contributor's name is
	displayed correctly.
	(erc-nicklist-icons-directory): Use customize type directory
	instead of string.
	(erc-nicklist-insert-contents): Set bbdb-nick to an empty string
	if it wasn't found.  This fixes a bug where an error would occur
	when using `string=' on bbdb-nick if it was nil.

	* erc-replace.el: Removed URL from file information since it
	doesn't exist.

	* erc-sound.el: Updated copyright years.  Fixed Commentary and
	added Usage section.
	(define-erc-module): Add and remove `erc-ctcp-query-SOUND' to
	`erc-ctcp-query-SOUND-hook' here.  Removed the keybinding
	definitions.
	(erc-play-sound, erc-default-sound, erc-cmd-SOUND)
	(erc-ctcp-query-SOUND): Doc fix.
	(erc-play-command): Removed, not necessary anymore.
	(erc-ctcp-query-SOUND-hook): Set to nil as default.  Moved up
	higher in code, added docstring.
	(erc-play-sound): Use `play-sound-file'.  It exists in GNU Emacs
	as well since version 21 or earlier.  Removed commented-out older
	version of function.

	* NEWS: Fixed formatting, added channel tracking change.

2006-09-03  Diane Murray  <disumu@x3y2z1.net>

	* erc.el: M-x erc RET can now be used to start ERC.
	(erc-open): Renamed from `erc'.
	(erc-before-connect): Change erc-select to erc.
	(erc): Renamed from `erc-select'.  Use `erc-open'.
	(erc-select): Defined as alias of `erc'.
	(erc-ssl): Renamed from `erc-select-ssl'.  Use `erc'.
	(erc-select-ssl): Defined as alias of `erc-ssl'.
	(erc-cmd-SERVER): Use `erc'.
	(erc-query, erc-handle-irc-url): Use `erc-open'.

	* erc-backend.el (erc-process-sentinel-1, JOIN): Use `erc-open'.

	* erc-menu.el (erc-menu-definition): Use `erc'.

	* erc-networks.el: Updated copyright years.
	(erc-server-select): Use keyword arguments when calling `erc'.

	* erc.texi (Getting Started, Connecting): Changed erc-select to
	erc.

	* README: Changed erc-select to erc.

	* NEWS: Added note about these changes.

	* FOR-RELEASE: Marked this item as done.

2006-08-21  Diane Murray  <disumu@x3y2z1.net>

	* erc-track.el (erc-track-mode-line-mouse-face): New variable.
	(erc-make-mode-line-buffer-name): Add help-echo and mouse-face
	properties to channel name.

2006-08-20  Michael Olson  <mwolson@gnu.org>

	* erc-identd.el (erc-identd): New customization group.
	(erc-identd-port): New option that specifies the port to use if
	none is given as an argument to erc-identd-start.
	(identd): Place erc-identd-quickstart in erc-connect-pre-hook
	instead of erc-identd-start so that we deal with the different
	meaning of the first argument.
	(erc-identd-start): Use erc-identd-port.
	(erc-identd-quickstart): New function that ignores any arguments
	and calls erc-identd-start.

	* erc.el (erc-with-server-buffer): New macro that switches to the
	current ERC server buffer and runs some code.  If no server buffer
	is available, return nil.  This is a useful way to access
	variables in the server buffer.
	(erc-get-server-user, erc-add-server-user)
	(erc-remove-server-user, erc-change-user-nickname)
	(erc-get-server-nickname-list, erc-get-server-nickname-alist)
	(erc-ison-p, erc-active-buffer, erc-cmd-IGNORE)
	(erc-cmd-UNIGNORE, erc-cmd-IDLE, erc-cmd-NICK, erc-cmd-BANLIST)
	(erc-cmd-MASSUNBAN, erc-nickname-in-use, erc-ignored-user-p)
	(erc-format-channel-modes): Use it.
	(erc-once-with-server-event, erc-once-with-server-event-global)
	(erc-with-buffer, erc-with-all-buffers-of-server): Use make-symbol
	instead of gensym.
	(erc-open-server-buffer-p): New function that returns non-nil if
	the given buffer is an ERC server buffer that has an open IRC
	process.
	(erc-with-buffer): Use buffer-live-p here to set a good example,
	though it isn't really needed here.
	(erc-away): Mention erc-away-time.
	(erc): Don't propagate the erc-away setting, since it makes more
	sense to access it from the server buffer.  Set up the prompt
	before connecting rather than after.  Run erc-connect-pre-hook
	with the buffer as an argument, instead of no arguments.
	(erc-cmd-GAWAY): Use erc-open-server-buffer-p instead of
	erc-server-buffer-p so that only open connections are set away.
	(erc-cmd-GQUIT): Use erc-open-server-buffer-p.
	(erc-process-away): Docfix.  Don't set erc-away in channel
	buffers.
	(erc-set-current-nick): Make this uniform with the style used in
	erc-current-nick.
	(erc-away-time): Rename from erc-away-p, since this is no longer a
	boolean-style predicate.
	(erc-format-away-status): Use it.
	(erc-initialize-log-marker): Accept a `buffer' argument.
	(erc-connect-pre-hook): Docfix.
	(erc-connection-established): Make sure this runs in the correct
	buffer.
	(erc-set-initial-user-mode): Accept a `buffer' argument.

	* erc-stamp.el (erc-add-timestamp): Use erc-away-time.

	* erc-spelling.el (erc-spelling-init): Use
	erc-with-server-buffer.  Accept `buffer' argument.
	(spelling): Call erc-spelling-init with the `buffer' argument.

	* erc-speedbar.el (erc-speedbar-buttons): Use erc-server-buffer-p.

	* erc-pcomplete.el (pcomplete/erc-mode/UNIGNORE)
	(pcomplete-erc-all-nicks): Use erc-with-server-buffer.

	* erc-notify.el (erc-notify-timer, erc-cmd-NOTIFY): Use
	erc-with-server-buffer.

	* erc-networks.el (erc-network, erc-current-network)
	(erc-network-name): Use erc-with-server-buffer.

	* erc-netsplit.el (erc-cmd-WHOLEFT): Use erc-with-server-buffer.

	* erc-match.el (erc-log-matches, erc-log-matches-come-back): Use
	erc-away-time.

	* erc-log.el (log): Use erc-away-time.  Remove unnecessary check.
	Pass `buffer' argument to erc-log-setup-logging instead of setting
	the current buffer.  Ditto for erc-log-disable-logging.
	(erc-log-setup-logging, erc-log-disable-logging): Accept a `buffer'
	argument.

	* erc-list.el (erc-chanlist): Use erc-with-server-buffer.

	* erc-ibuffer.el (erc-away): Use erc-away-time.

	* erc-dcc.el (erc-dcc-get-filter): Temporarily make the buffer
	read only instead of permanently doing so.

	* erc-compat.el (erc-gensym, *erc-sym-counter*): Remove, since
	Emacs Lisp has make-symbol, which is better.

	* erc-chess.el (erc-chess-handler, erc-cmd-CHESS): Use
	erc-with-server-buffer.

	* erc-capab.el (capab-identify): Only deal with server buffers
	that have an open IRC process.
	(erc-capab-identify-add-prefix): Use erc-with-server-buffer.

	* erc-backend.el (erc-server-connected): Docfix.  Recommend the
	`erc-server-process-alive' function.
	(erc-coding-system-for-target): Supply a default target if one is
	not given.
	(erc-server-send): Simplify slightly.
	(erc-call-hooks): Use erc-with-server-buffer.
	(erc-server-connect, erc-server-setup-periodical-ping): Accept
	`buffer' argument.

	* erc-autoaway.el (erc-autoaway-reestablish-idletimer): Move
	higher to avoid an automatic load snafu.
	(erc-autoaway-some-server-buffer): New function that returns an
	ERC server buffer with a live connection, or nil otherwise.
	(erc-autoaway-insinuate-maybe): New function that adds the
	autoaway reset function to post-command-hook if at least one ERC
	process is alive.
	(erc-autoaway-remove-maybe): New function that removes the
	autoaway reset function from post-command-hook if no ERC process
	is alive.
	(autoaway): Don't touch post-command-hook unless an IRC process is
	already open.  Remove our addition to post-command-hook as soon as
	there are no more IRC processes open.  Reset the indicators before
	connecting to an IRC server, which fixes a bug when re-connecting.
	(erc-autoaway-reset-idle-user): Call erc-autoaway-remove-maybe if
	there are no more IRC processes open.
	(erc-autoaway-set-back): Pick an open IRC process.  Accept an
	argument which is a function call if we can't find one.
	(erc-autoaway-some-open-server-buffer): New function which returns
	an ERC server buffer with an open connection and a user that is
	not away.
	(erc-autoaway-possibly-set-away, erc-autoaway-set-away): Use it.
	(erc-autoaway-set-away): Accept a `notest' argument which is used
	to avoid testing the same thing twice.
	(erc-autoaway-last-sent-time, erc-autoaway-caused-away): Move
	higher in file to fix byte-compile warning.

2006-08-20  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (erc-process-sentinel-1): Doc fix.  Let
	`erc-server-reconnect-p' check all condition cases.
	(erc-server-reconnect-p): Moved rest of checks from
	`erc-process-sentinel-1' to here.  Now takes an argument, EVENT.

2006-08-14  Diane Murray  <disumu@x3y2z1.net>

	* erc-menu.el: Updated copyright years.  Removed EmacsWiki URL.
	(erc-menu-definition): Name the menu "ERC" instead of "IRC" to
	avoid confusion with rcirc and other clients.

	* erc-backend.el (erc-server-banned): New variable.
	(erc-server-connect): Set `erc-server-banned' to nil.
	(erc-process-sentinel-1): Use `erc-server-reconnect-p'.
	(erc-server-reconnect-p): New function.  Return non-nil if the
	user wants automatic reconnects and if the user has not been
	banned from the server.  This should fix a bug where ERC gets into
	a loop trying to reconnect with no way to stop it when the user is
	denied access to the server due to a server ban.  It might also
	help when Tor users are blocked from freenode if freenode servers
	send the 465 message before disconnecting.
	(465): Handle "banned from server" error notices.

2006-08-13  Romain Francoise  <romain@orebokech.com>

	* erc-match.el (erc-log-matches-make-buffer): End `y-or-n-p'
	prompt with a space.

2006-08-13  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-server-timed-out): New variable that
	indicates whether the current connection has timed out due to
	failure to respond to a ping.
	(erc-server-send-ping): Set erc-server-timed-out to t.
	(erc-server-connect): Initialize erc-server-timed-out to nil.
	(erc-process-sentinel-1): Consult erc-server-timed-out.

2006-08-11  Michael Olson  <mwolson@gnu.org>

	* erc-fill.el (erc-fill): Skip any initial empty lines so that we
	avoid errors when inserting disconnect messages and other messages
	that begin with newlines.

2006-08-07  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-process-sentinel-1): Use erc-display-message
	in several places instead of inserting text.
	(erc-process-sentinel): Move to the input-marker before removing
	the prompt.

	* erc.el (erc-port): Fix customization options.
	(erc-display-message): Handle null type explicitly.  Previously,
	this was relying on a chance side-effect.  Cosmetic indentation
	tweak.
	(english): Add 'finished and 'terminated entries to the catalog.
	Add initial and terminal newlines to 'disconnected and
	'disconnected-noreconnect entries.  Avoid long lines.
	(erc-cmd-QUIT): Bind the current erc-server-process to
	server-proc.  If the IRC server responds quickly, it is possible
	for the connection to close, and hence server buffer to be killed,
	if erc-kill-server-buffer-on-quit is non-nil.  This avoids that
	problem.

2006-08-06  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-server-send-queue): Update from Circe
	version of this function.
	(erc-server-ping-timer-alist): New variable that keeps track of
	ping timers according to their associated server.
	(erc-server-last-received-time): New variable that specifies the
	time of the last message we received from the server.  This is
	used to detect hung processes.
	(erc-server-send-ping): New function that sends a ping to the IRC
	process corresponding with the given buffer.  Split from
	erc-server-setup-periodical-ping.  If the server buffer no longer
	exists, cancel the timer.  If the server process has not given us
	a message, including PING responses, since the last PING, kill it.
	This is necessary to deal with some aberrant freenode behavior.
	Idea taken from rcirc.
	(erc-server-setup-periodical-ping): Rename from
	erc-server-setup-periodical-server-ping.
	(erc-server-filter-function): Use erc-current-time instead of
	current-time.

	* erc.el (erc-arrange-session-in-multiple-windows): Fix bug with
	multi-tty Emacs.
	(erc-select-startup-file): Fix bug introduced by recent change.
	(erc-cmd-QUIT): If the IRC process has not terminated itself
	within 4 seconds of completing our quit-hook, kill it manually.
	Freenode in particular needs this.
	(erc-connection-established): Use erc-server-setup-periodical-ping
	instead of erc-server-setup-periodical-server-ping.

2006-08-05  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (erc-log-standardize-name): New function that returns
	a filename that is safe for use for a log file.
	(erc-current-logfile): Use it.

	* erc.el (erc-startup-file-list): Search in ~/.emacs.d first,
	since that is a fairly standard directory.
	(erc-select-startup-file): Re-write to use
	convert-standard-filename, which will ensure that MS-DOS systems
	look for the _ercrc.el file.

2006-08-02  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-version-string): Release ERC 5.1.4.

	* Makefile, NEWS, erc.texi: Update for the 5.1.4 release.

	* erc.el (erc-active-buffer): Fix bug that caused messages to go
	to the wrong buffer.  Thanks to offby1 for the report.

	* erc-backend.el (erc-coding-system-for-target): Handle case where
	target is nil.  Thanks to Kai Fan for the patch.

2006-07-29  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (erc-log-setup-logging): Don't offer to save the
	buffer.  It will be saved automatically killed.  Thanks to Johan
	Bockgård and Tassilo Horn for pointing this out.

2006-07-27  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el (define-erc-module): Make find-function and find-variable
	find the names constructed by `define-erc-module' in Emacs 22.

2006-07-14  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (log): Make sure that we enable logging on
	already-opened buffers as well, in case the user toggles this
	module after loading ERC.  Also be sure to remove logging ability
	from all ERC buffers when the module is disabled.
	(erc-log-setup-logging): Set buffer-file-name to nil rather than
	the empty string.  This should fix some errors that occur when
	quitting Emacs without first killing all ERC buffers.
	(erc-log-disable-logging): New function that removes the logging
	ability from the current buffer.

	* erc-spelling.el (spelling): Use dolist and buffer-live-p.

2006-07-12  Michael Olson  <mwolson@gnu.org>

	* erc-match.el (erc-log-matches): Bind inhibit-read-only rather
	than call toggle-read-only.

	* erc.el (erc-handle-irc-url): Move here from erc-goodies.el and
	add autoload cookie.

2006-07-09  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-version-string): Release ERC 5.1.3.

	* erc.texi: Update for the 5.1.3 release.

	* erc-autoaway.el (erc-autoaway-set-back): Fix bug after returning
	from being set automatically away and current buffer is not an ERC
	buffer.

	* erc-identd.el: Fix compiler error.

	* erc.texi (Development): Use @subheading instead of @subsection.
	(Advanced Usage): Add menu.
	(Connecting): Fully document how to connect to an IRC server.
	(Options, Tips and Tricks, Sample Configuration): New unwritten
	sections.

	* erc.el (erc-server, erc-port, erc-nick, erc-nick-uniquifier)
	(erc-user-full-name, erc-password): Docfixes and customization
	interface tweaks.
	(erc-try-new-nick-p): Rename from
	`erc-manual-set-nick-on-bad-nick-p' and invert meaning.
	(erc-nickname-in-use): Use `erc-try-new-nick-p'.  Check the length
	of `erc-nick-uniquifier', in case someone wants multiple
	characters.
	(erc-compute-server, erc-compute-nick, erc-compute-full-name)
	(erc-compute-port): Docfixes.

	* erc-log.el (log): Move all add-hook calls here, rather than
	executing them immediately, and also cause them to be un-hooked
	when the module is removed.
	(erc-save-buffer-on-part): Move next to
	`erc-save-queries-on-quit'.
	(erc-save-buffer-on-quit, erc-save-queries-on-quit): Default to t.
	(erc-log-write-after-send, erc-log-write-after-insert): Default to
	nil.  This makes things fast, but reasonably failsafe, by default.

2006-07-08  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (erc-log-insert-log-on-open): Make this nil by
	default, since most IRC clients don't do this.
	(erc-log-write-after-send): New option that determines whether the
	log file will be written to after every sent message.
	(erc-log-write-after-insert): New option that determines whether
	the log file will be written to when new text is added to a logged
	ERC buffer.
	(log): Use the aforementioned options.

	* erc.texi (Modules): Document the "completion" module.

	* erc-pcomplete.el (pcomplete-erc-nicks): Make sure that we don't
	have a nil element in the list when ignore-self is non-nil.

2006-07-05  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-modules): Use `set' instead of `set-default', since
	this setting should never be buffer-local.  Add the `page' module
	to the list.

	* erc.texi (Modules): Add entries for `list' and `page' modules.
	Change "spell" to "spelling".
	(History): Use past tense throughout.

2006-07-02  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-call-hooks): Fix (stringp nil) error that
	can happen when doing /PART.

	* erc.el (erc-quit-reason-various-alist)
	(erc-part-reason-various-alist): In the example, use "^$" as an
	example, since "" matches anything.
	(erc-quit-reason-various, erc-part-reason-various): If no argument
	is given, and no matches are found, use our default reason instead
	of "nil".

2006-06-30  Michael Olson  <mwolson@gnu.org>

	* erc.texi (Modules): Mention identd.
	(Releases): Update mailing list address and download location.
	(Development): Refactor.  Provide updated directions for Arch.
	Make URLs clickable.
	(Keystroke Summary): Typo fix.  Use more Texinfo syntax.
	(Getting Started): Give simpler example.  We do not need to
	explicitly load every module.
	(History): Update.

	* erc-autoaway.el, erc-join.el, erc-backend.el, erc-bbdb.el:
	erc-button.el, erc-chess.el, erc-compat.el, erc-hecomplete.el:
	erc-dcc.el, erc-ezbounce.el, erc-fill.el, erc-ibuffer.el:
	erc-imenu.el, erc-list.el, erc-log.el, erc-match.el, erc-menu.el:
	erc-networks.el, erc-netsplit.el, erc-nicklist.el:
	erc-services.el, erc-pcomplete.el, erc-replace.el, erc-ring.el:
	erc-speedbar.el, erc-spelling.el, erc-stamp.el, erc-track.el:
	erc.el: Remove version strings.

	* erc.el (erc-cmd-SMV): Remove, since we do not have meaningful
	module versions anymore.
	(erc-version-modules): Remove, since we do not use this function
	anymore.
	(erc-latest-version, erc-ediff-latest-version): Remove, since this
	was only useful back when ERC consisted of one file.
	(erc-modules): Add line for identd.
	(erc-get-channel-mode-from-keypress): Typo fix.

	* erc-imenu.el: Remove unnecessary lines in header.

	* erc-goodies.el (erc-handle-irc-url): Docfix.

	* erc-identd.el: Define an ERC module for this.
	(erc-identd-start): Don't create a process buffer if possible.
	Otherwise, use conventional hidden names for process buffers.

2006-06-29  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-coding-system-for-target): Match
	case-insensitively.  Use a pattern match instead of `assoc', as
	per the documentation for `erc-encoding-coding-alist'.

	* erc-track.el (erc-track-shorten-aggressively): Fix typo.

2006-06-27  Michael Olson  <mwolson@gnu.org>

	* erc.el: Update maintainer information and URLs.

2006-06-14  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-active-buffer): If the active buffer has been
	deleted, default to the server buffer.
	(erc-toggle-flood-control): When the user hits C-c C-f, make flood
	control really toggle, not unconditionally turn off.

2006-06-12  Michael Olson  <mwolson@gnu.org>

	* NEWS: Add items since the 5.1.2 release.

	* erc-autoaway.el (erc-autoaway-caused-away): New variable that
	indicates whether the current away status was caused by this
	module.
	(erc-autoaway-set-back): Only set back if this module set the user
	away.
	(erc-autoaway-set-away): Update `erc-autoaway-caused-away'.
	(erc-autoaway-reset-indicators): New function that resets some
	indicators when the user is no longer away.
	(autoaway): Add the above function to the 305 hook.

2006-06-05  Romain Francoise  <romain@orebokech.com>

	* erc.texi (History): Fix various typos.

2006-06-04  Michael Olson  <mwolson@gnu.org>

	* erc-autoaway.el (erc-autoaway-idle-method): Move after the
	definition of the autoaway module.
	(autoaway): Don't do anything if erc-autoaway-idle-method is
	unbound.  This prevents an error on startup.

2006-06-03  Michael Olson  <mwolson@gnu.org>

	* erc-autoaway.el: Thanks to Mark Plaksin for the ideas and patch.
	(erc-autoaway-idle-method): Renamed from
	`erc-autoaway-use-emacs-idle'.  We have more than two choices for
	how to do this, so it's best to make this take symbol values.
	Improve documentation.  Remove warning against Emacs idle-time;
	the point is moot now that we get user idle time via a different
	method.  Make sure we disable and re-enable the module when
	changing this value.
	(autoaway): Conditionalize on the above option.  If using the idle
	timer or user idle methods, don't add anything to the
	send-completed or server-001 hooks, since it is unnecessary.
	(erc-autoaway-reestablish-idletimer, erc-autoaway-message):
	Docfix.
	(erc-autoaway-idle-seconds): Use erc-autoaway-idle-method.
	(erc-autoaway-reset-idle-irc): Renamed from
	`erc-autoaway-reset-idle'.  Don't pass line to
	`erc-autoaway-set-away', since it is not used.
	(erc-autoaway-reset-idle-user): New function that resets the idle
	state for user idle time.
	(erc-autoaway-set-back): Remove line argument, since it is not
	used.

2006-06-01  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-buffer-filter): Make sure all buffers returned from
	this are live.

2006-05-01  Theresa O'Connor  <ted@oconnor.cx>

	* erc-goodies.el (erc-handle-irc-url): New function, suitable as
	a value for `url-irc-function'.

2006-04-18  Diane Murray  <disumu@x3y2z1.net>

	* erc-pcomplete.el (pcomplete-erc-nicks): Added new optional
	argument IGNORE-SELF.  If this is non-nil, don't return the user's
	current nickname.  Doc fix.
	(pcomplete/erc-mode/complete-command): Don't complete the current
	nickname.

2006-04-05  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-cmd-SV): Removed the exclamation point.  Show the
	build date as it's shown in `emacs-version'.

	* erc-capab.el (erc-capab-identify-add-prefix): Insert the prefix
	with the same face property as the previous character.

2006-04-02  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el, erc-ezbounce.el, erc-join.el, erc-netsplit.el,
	erc.el: Make sure to include a newline inside of negated classes,
	so that a newline is not matched.

2006-04-01  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-server-connect-function): Don't try to
	detect the existence of the `open-network-stream-nowait' function,
	since I can't find it in Emacs21, XEmacs21, or Emacs22.

2006-03-27  Michael Olson  <mwolson@gnu.org>

	* erc.texi: Update direntry.  Remove unneeded local variables.

2006-03-26  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-header-line): New face that will be used to colorize
	the text of the header-line, provided that
	`erc-header-line-face-method' is non-nil.
	(erc-prompt-face): Fix formatting.
	(erc-header-line-face-method): New option that determines the
	method used for colorizing header-line text.  This may be a
	function, nil, or non-nil.
	(erc-update-mode-line-buffer): Use the aforementioned option and
	face to colorize the header-line text, if that is what the user
	wants.
	(erc-send-input): If flood control is not activated, don't split
	the input line.

2006-03-25  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-cmd-QUOTE): Install patch from Aravind Gottipati
	that fixes the case where there is no leading whitespace.  Only
	remove the first space character, though.

	* erc-identd.el (erc-identd-start): Fix a bug by making sure that
	erc-identd-process is set properly.
	(erc-identd-start, erc-identd-stop): Add autoload cookies.
	(erc-identd-start): Pass :host parameter so this works with Emacs
	22.

2006-03-09  Diane Murray  <disumu@x3y2z1.net>

	* erc-button.el (erc-button-keymap): Use <backtab> rather than
	<C-tab> for `erc-button-previous' as it is a more standard key
	binding for this type of function.

2006-02-28  Diane Murray  <disumu@x3y2z1.net>

	* erc-capab.el: Removed things that were accidentally committed on
	2006-02-20.  Removed Todo section.
	(erc-capab-unidentified): Removed.

2006-02-26  Michael Olson  <mwolson@gnu.org>

	* erc-capab.el: Use (eval-when-compile (require 'cl)).
	(erc-capab-unidentified): Fix compiler warning by specifying
	group.

2006-02-20  Diane Murray  <disumu@x3y2z1.net>

	* erc-capab.el (erc-capab-send-identify-messages): Fixed comment
	to explain thoughts better.  `erc-server-parameters' is an
	associated list when it's set, not a string.

2006-02-19  Michael Olson  <mwolson@gnu.org>

	* erc-capab.el (erc-capab-send-identify-messages): Make sure some
	parameters are strings before using them.  Thanks to Alejandro
	Benitez for the report.

	* erc.el (erc-version-string): Release ERC 5.1.2.

2006-02-19  Diane Murray  <disumu@x3y2z1.net>

	* erc-button.el (erc-button-keymap): Bind `erc-button-previous' to
	<C-tab>.
	(erc-button-previous): New function.

2006-02-15  Michael Olson  <mwolson@gnu.org>

	* NEWS: Add category for ERC 5.2.

	* erc.el (erc): Move to the end of the buffer when a continued
	session is detected.  Thanks to e1f and indio for the report and
	testing a potential fix.

2006-02-14  Michael Olson  <mwolson@gnu.org>

	* debian/changelog: Prepare a new Debian package.

	* Makefile (debprepare): New rule that creates an ERC snapshot
	directory for use in both new Debian releases and revisions for
	Debian packages.
	(debrelease, debrevision-mwolson): Use debprepare.

	* NEWS: Bring up-to-date.

	* erc-stamp.el (erc-insert-timestamp-right): For now, put
	timestamps before rather than after erc-fill-column when
	erc-timestamp-right-column is nil.  This way we won't surprise
	anyone unpleasantly, or so it is hoped.

2006-02-13  Michael Olson  <mwolson@gnu.org>

	* erc-dcc.el: Use (eval-when-compile (require 'cl)).

2006-02-12  Michael Olson  <mwolson@gnu.org>

	* erc-autoaway.el, erc-dcc.el, erc-ezbounce.el, erc-fill.el
	* erc-goodies.el, erc-hecomplete.el, erc-ibuffer.el, erc-identd.el
	* erc-imenu.el, erc-join.el, erc-lang.el, erc-list.el, erc-log.el
	* erc-match.el, erc-menu.el, erc-netsplit.el, erc-networks.el
	* erc-notify.el, erc-page.el, erc-pcomplete.el, erc-replace.el
	* erc-ring.el, erc-services.el, erc-sound.el, erc-speedbar.el
	* erc-spelling.el, erc-track.el, erc-truncate.el, erc-xdcc.el:
	Add 2006 to copyright years, to comply with the changed guidelines.

2006-02-11  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-update-modules): Handle erc-capab-identify
	correctly.  Make some requirements shorter, so that it's easier to
	see why they are needed.

	* erc-capab.el: Add autoload cookie for capab-identify.
	(erc-capab-send-identify-messages, erc-capab-identify-activate):
	Minor whitespace fix in code.

	* erc-stamp.el (erc-timestamp-use-align-to): Renamed from
	`erc-timestamp-right-align-by-pixel'.  Set the default based on
	whether we are in Emacs 22, and using X.  Improve documentation.
	(erc-insert-aligned): Remove calculation of offset, since
	:align-to pos works after all.  Unlike the previous solution, this
	one works when erc-stamp.el is compiled.
	(erc-insert-timestamp-right): Don't add length of string, and then
	later remove its displayed width.  This puts timestamps after
	erc-fill-column when erc-timestamp-right-column is nil, rather
	than before it.  It also fixes a subtle bug.  Remove use of
	`current-window', since there is no variable by that name in
	Emacs21, Emacs22, or XEmacs21 beta.  Check to see whether
	`erc-fill-column' is non-nil before using it.

2006-02-11  Diane Murray  <disumu@x3y2z1.net>

	* erc-list.el: Define `list' module which sets the alias
	`erc-cmd-LIST' to `erc-list-channels' when enabled and
	`erc-list-channels-simple' when disabled.
	(erc-list-channels): Was `erc-cmd-LIST', renamed.
	(erc-list-channels-simple): New function.

	* erc.el (erc-modules): Added `list' to enabled modules.  Changed
	`capab-identify' description.  Moved customization options left in
	source code.

	* erc-menu.el (erc-menu-definition): Use `erc-list-channels'.

	* erc-capab.el: Put a little more detail into Usage section.
	(define-erc-module): Run `erc-capab-identify-setup' in all open
	server buffers when enabling.
	(erc-capab-identify-setup): Make PROC and PARSED optional
	arguments.
	(erc-capab-identify-add-prefix): Simplified nickname regexp.  This
	should now also match nicknames that are formatted differently
	than the default.

	* erc-spelling.el (define-erc-module): Make sure there's a buffer
	before calling `with-current-buffer'.

2006-02-10  Michael Olson  <mwolson@gnu.org>

	* Makefile (debbuild): Split from debrelease.
	(debrevision-mwolson): New rule that causes a Debian revision to
	be built.

	* erc.el (erc-migrate-modules): Use a better algorithm.  Thanks to
	Johan Bockgård.
	(erc-modules): Change use of 'pcomplete to 'completion.

2006-02-09  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-get-parsed-vector, erc-get-parsed-vector-nick)
	* erc-capab.el: Require erc.
	(erc-capab-send-identify-messages): Use `erc-server-send'.
	(erc-capab-identify-remove/set-identified-flag): Use 1 and 0 as
	the flags so we can also check whether the `erc-identified' text
	property is there at all.
	(erc-capab-identify-add-prefix): Use `erc-capab-find-parsed'.
	This fixes a bug where the prefix wasn't inserted when timestamps
	are inserted on the right.  Tweaked nickname regexp.
	(erc-capab-find-parsed): New function.
	(erc-capab-get-unidentified-nickname): Updated to check for 0
	flag.  Only get nickname if there's a nickuserhost associated with
	this message.

	* erc-capab.el: New file.  Adds the new module
	`erc-capab-identify', which allows flagging of unidentified users
	on servers running an ircd based on dancer - irc.freenode.net, for
	example.

	* erc.el (erc-modules): Added `capab-identify' to options.
	(erc-get-parsed-vector, erc-get-parsed-vector-nick)
	(erc-get-parsed-vector-type): Moved here from erc-match.el.

	* erc-match.el (erc-get-parsed-vector, erc-get-parsed-vector-nick)
	(erc-get-parsed-vector-type): Moved these functions to erc.el
	since they can be useful outside of the text matching module.

	* NEWS: Added erc-capab.el.

	* erc-dcc.el, erc-stamp.el, erc-xdcc.el: Changed "Emacs IRC Client"
	to "ERC".

2006-02-07  Michael Olson  <mwolson@gnu.org>

	* ChangeLog.01, ChangeLog.02, ChangeLog.03, ChangeLog.04,
	ChangeLog.05: Rename from ChangeLog.NNNN in order to disambiguate
	the filenames in DOS.

	* erc-goodies.el: Comment fix.

	* erc-hecomplete.el: Rename from erc-complete.el.  Update
	commentary.  Use define-erc-module so that it's possible to
	actually use this.
	(erc-hecomplete): Rename function from `erc-complete'.
	(erc-hecomplete): Rename group from `erc-old-complete'.  Docfix.

	* erc-join.el: Rename from erc-autojoin.el.

	* erc-networks.el: Rename from erc-nets.el.

	* erc-services.el: Rename from erc-nickserv.el.

	* erc-stamp.el (erc-insert-aligned): Don't take 3rd argument.  Use
	the simpler `indent-to' function when
	`erc-timestamp-right-align-by-pixel' is nil.
	(erc-insert-timestamp-right): If the timestamp goes on the
	following line, don't add timestamp properties to the spaces in
	front of it.

	* erc.el (erc-migrate-modules): New function that eases migration
	of module names.
	(erc-modules): Call erc-migrate-modules in the :get accessor.
	(erc-modules, erc-update-modules): Update for new modules names.
	(erc-cmd-SMV): Remove, since this does not give useful output due
	to the version strings being removed from ERC modules.

2006-02-05  Michael Olson  <mwolson@gnu.org>

	* erc-spelling.el (erc-spelling-init): If
	`erc-spelling-dictionaries' is nil, do not set
	ispell-local-dictionary.  Before, it was being set to nil, which
	was causing a long delay while the ispell process restarted.
	(erc-spelling-unhighlight-word): New function that removes
	flyspell properties from a spell-checked word.
	(erc-spelling-flyspell-verify): Don't spell-check nicks or words
	that have '/' before them.

2006-02-04  Michael Olson  <mwolson@gnu.org>

	* erc-autojoin.el: Use (eval-when-compile (require 'cl)).

	* erc-complete.el (erc-nick-completion-exclude-myself)
	(erc-try-complete-nick): Use better function for getting list of
	channel users.

	* erc-goodies.el: Docfix.

	* erc-stamp.el: Use new arch tagline, since the other one wasn't
	being treated properly.

	* erc.el (erc-version-string): Release ERC 5.1.1.

2006-02-03  Zhang Wei  <id.brep@gmail.com>

	* erc.el (erc-version-string): Don't hard-code Emacs version.
	(erc-version): Use emacs-version.

2006-01-31  Michael Olson  <mwolson@gnu.org>

	* erc-stamp.el: Update copyright years.

2006-01-30  Simon Josefsson  <jas@extundo.com>

	* erc.el (erc-open-ssl-stream): Use tls.el.

2006-01-30  Michael Olson  <mwolson@gnu.org>

	* erc-stamp.el (erc-timestamp-right-align-by-pixel): New option
	that determines whether to use pixel values to align right
	timestamps.  The default is not to do so, since it only works with
	Emacs22 on X, and even then some people have trouble.
	(erc-insert-aligned): Use `erc-timestamp-right-align-by-pixel'.

2006-01-29  Michael Olson  <mwolson@gnu.org>

	* ChangeLog, ChangeLog.2005, ChangeLog.2004, ChangeLog.2003,
	ChangeLog.2002, ChangeLog.2001: Add "See ChangeLog.NNNN" line for
	earlier changes.  Use utf-8 encoding.  Fix some accent typos.

	* erc-speedbar.el (erc-speedbar-buttons): Fix reference to free
	variable.
	(erc-speedbar-goto-buffer): Fix compiler warning.

	* erc-ibuffer.el: Use `define-ibuffer-filter' instead of
	`ibuffer-define-limiter'.  Use `define-ibuffer-column' instead of
	`ibuffer-define-column'.  Require 'ibuf-ext so that the macros
	work without compiler warnings.

	* erc.texi (Obtaining ERC, Installation): Note that these
	sections may be skipped if using the version of ERC that comes
	with Emacs.

2006-01-29  Theresa O'Connor  <ted@oconnor.cx>

	* erc-viper.el: Remove.  Now that ERC is included in Emacs, these
	work-arounds live in Viper itself.

2006-01-28  Michael Olson  <mwolson@gnu.org>

	* erc-*.el, erc.texi, NEWS: Add Arch taglines as per Emacs
	guidelines.

	* erc-*.el: Space out copyright years like the rest of Emacs.  Use
	the Emacs copyright statement.  Refer to ourselves as ERC rather
	than "Emacs IRC Client", since there are now several IRC clients
	for Emacs.

	* erc-compat.el (erc-emacs-build-time): Define as a variable.

	* erc-log.el (erc-log-setup-logging): Use write-file-functions.

	* erc-ibuffer.el: Require 'erc.

	* erc-stamp.el (erc-insert-aligned): Only use the special text
	property when window-system is X.

	* erc.texi: Adapt for inclusion in Emacs.

2006-01-28  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el (erc-format-message): More `cl' breakage; don't use
	`oddp'.

2006-01-27  Michael Olson  <mwolson@gnu.org>

	* debian/changelog: Update for new release.

	* debian/control (Description): Update.

	* debian/rules: Concatenate ChangeLog for 2005.

	* Makefile (MISC): Include ChangeLog.2005 and erc.texi.
	(debrelease, release): Copy images directory.

	* NEWS: Spelling fixes.  Add items for recent changes.

	* erc.el (erc): Move call to erc-update-modules before the call to
	erc-mode.  This should fix a timestamp display issue.
	(erc-version-string): Release ERC 5.1.

2006-01-26  Michael Olson  <mwolson@gnu.org>

	* erc-stamp.el (erc-insert-aligned): New function that inserts
	text in an perfectly-aligned way relative to the right margin.  It
	only works well with Emacs22.  A sane fallback is provided for
	other versions of Emacs.
	(erc-insert-timestamp-right): Use the new function.

2006-01-25  Theresa O'Connor  <ted@oconnor.cx>

	* erc.el (erc-modules): Ensure that `erc-button-mode' gets enabled
	before `erc-match-mode'.

	* erc-match.el (match): Append `erc-match-message' to
	`erc-insert-modify-hook'.

2006-01-25  Michael Olson  <mwolson@gnu.org>

	* FOR-RELEASE: Mark last release requirement as done.

	* Makefile (realclean, distclean): Remove docs.

	* erc.texi: Take care of all pre-5.1 items.

	* erc-backend.el (erc-server-send, erc-server-send-queue): Wrap
	`process-send-string' in `condition-case' to avoid an error when
	quitting ERC.

	* erc-stamp.el (erc-insert-timestamp-right): Try to deal with
	variable-width characters in the timestamp and on the same line.
	The latter is a kludge, but it seems to work with most of the
	input I've thrown at it so far.  It's certainly better than going
	past the end of line consistently when we have variable-width
	characters on the same line.  When `erc-timestamp-intangible' is
	non-nil, add intangible properties to the whitespace as well, so
	that hitting <end> does what you'd expect.

	* erc.el (erc-flood-protect, erc-toggle-flood-control): Update
	this to only use boolean values for `erc-flood-protect'.  Update
	documentation.
	(erc-cmd-QUIT): Set the active buffer to be the server buffer, so
	that any QUIT-related messages go there.
	(erc): Try to be more clever about re-using channel buffers when
	automatically re-connecting.  Thanks to e1f for noticing.

2006-01-23  Michael Olson  <mwolson@gnu.org>

	* ChangeLog.2005: Remove erroneous line.

	* FOR-RELEASE: Make that the Makefile tweaking is complete.
	(NEWS): Mark as done.

	* Makefile (MANUAL): New option indicating the name of the manual.
	(PREFIX, ELISPDIR, INFODIR): New options that specify the
	directories to install lisp code and info manuals to.  PREFIX is
	used only by ELISPDIR and INFODIR.
	(all): Call `lisp' and create the manual.
	(lisp): Compile lisp code.
	(%.info, %.html): New rules that make Info files and HTML files,
	respectively, from a TexInfo source.
	(doc): Create both the Info and HTML versions of the manual.  This
	is for the user -- we never call it automatically.
	(install-info): Install Info files.
	(install-bin): Install compiled and source Lisp files.
	(todo): Remove, since it seems pointless.

	* NEWS: Update.

	* README: Add Installation instructions.  Tweak layout.

	* erc.texi: Work on some pre-5.1 items.

	* erc-stamp.el, erc-track.el: Move some functions and options in
	order to get rid of a few compiler warnings.

	* erc.el (erc-modules): Enable readonly by default.  This will
	prevent new users from accidentally removing old messages, which
	could be disconcerting.  Also enable stamp by default, since
	timestamps are a fairly standard feature among IRC clients.

	* erc-button.el: Munge whitespace.

	* erc-identd.el (erc-identd-start): Instead of throwing an error,
	just try to use the obsolete function.

2006-01-22  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-decode-string-from-target): Make sure that
	we have a string as an argument.  If not, coerce it to the empty
	string.  Hopefully, this will work painlessly around an edge case
	related to quitting ERC around the same time a message comes in.

2006-01-22  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-track.el: Use `(eval-when-compile (require 'cl))' (for
	`case').  Doc fixes.
	(erc-find-parsed-property): Simplify.
	(erc-track-get-active-buffer): Fix logic.  Simplify.
	(erc-track-switch-buffer): Remove unused variable `dir'.  Simplify.

	* erc-speak.el: Doc fixes.
	(erc-speak-region): `propertize' --> `erc-propertize'.

	* erc-dcc.el (erc-dcc-chat-parse-output): `propertize' -->
	`erc-propertize'.

	* erc-button.el (erc-button-add-button): Take erc-fill-prefix into
	account when wrapping URLs.

	* erc-bbdb.el (erc-bbdb-elide-display): Doc fix.

	* erc-backend.el (define-erc-response-handler): Doc fix.

2006-01-22  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-update-modules): Use `require' instead of `load',
	but prevent it from causing errors, in order to preserve the
	previous behavior.

2006-01-21  Michael Olson  <mwolson@gnu.org>

	* FOR-RELEASE (Source): Mark cl task as done.

	* Makefile (erc-auto.el): Call erc-generate-autoloads rather than
	generate-autoloads.
	(erc-auto.el, %.elc): Don't show command, just its output.

	* NEWS: Add items from 2005-01-01 to 2005-08-13.

	* debian/copyright (Copyright): Update.

	* erc-auto.in (erc-generate-autoloads): Rename from
	generate-autoloads.

	* erc.el, erc-autoaway.el, erc-backend.el: Use
	erc-server-process-alive instead of erc-process-alive.

	* erc.el, erc-backend.el, erc-ezbounce.el, erc-list.el,
	erc-log.el, erc-match.el, erc-nets.el, erc-netsplit.el,
	erc-nicklist.el, erc-nickserv.el, erc-notify.el, erc-pcomplete.el:
	Use (eval-when-compile (require 'cl)), so that compilation doesn't
	fail.

	* erc-fill.el, erc-truncate.el: Whitespace munging.

	* erc.el: Update copyright notice.  Remove eval-after-load code.
	(erc-with-buffer): Docfix.
	(erc-once-with-server-event, erc-once-with-server-event-global)
	(erc-with-buffer, erc-with-all-buffers-of-server): Use erc-gensym
	instead of gensym.
	(erc-banlist-update): Use erc-delete-if instead of delete-if.
	(erc): Call `erc-update-modules' here.

	* erc-backend.el: Require 'erc-compat to minimize compiler
	warnings.
	(erc-decode-parsed-server-response): Docfix.
	(erc-server-process-alive): Move here from erc.el and rename from
	`erc-process-alive'.
	(erc-server-send, erc-remove-channel-users): Make sure process is
	alive before sending data to it.

	* erc-bbdb.el: Update copyright years.
	(erc-bbdb-whois): Remove overexuberant comment.

	* erc-button.el: Require erc-fill, since we make liberal use of
	`erc-fill-column'.

	* erc-compat.el (erc-const-expr-p, erc-list*, erc-assert): New
	functions, the latter of which provides an `assert' equivalent.
	(erc-remove-if-not): New function that provides a simple
	implementation of `remove-if-not'.
	(erc-gensym): New function that provides a simple implementation
	of `gensym'.
	(erc-delete-if): New function that provides a simple
	implementation of `delete-if'.
	(erc-member-if): New function that provides a simple
	implementation of `member-if'.
	(field-end): Remove this, since it is unused, and later versions
	of XEmacs have this function already.
	(erc-function-arglist): Moved here from erc.el.
	(erc-delete-dups): New compatibility function for dealing with
	XEmacs.
	(erc-subseq): New function copied from cl-extra.el.

	* erc-dcc.el: Require pcomplete during compilation to avoid
	compiler warnings.
	(erc-unpack-int, erc-dcc-send-filter)
	(erc-dcc-get-filter): Use erc-assert instead of assert.
	(pcomplete/erc-mode/DCC): Use erc-remove-if-not instead of
	remove-if-not.

	* erc-match.el (erc-log-matches): Fix compiler warning.

	* erc-nicklist.el: Update copyright notice.
	(erc-nicklist-menu): Change use of caadr to (car (cadr ...)).
	(erc-nicklist-bitlbee-connected-p): Remove.
	(erc-nicklist-insert-medium-name-or-icon): Accept channel
	argument.  Use it to determine whether we are on bitlbee.  Now
	that bitlbee names its channel "&bitlbee", this is trivial.
	(erc-nicklist-insert-contents): Pass channel as specified above.
	Don't try to determine whether we are on bitlbee here.
	(erc-nicklist-channel-users-info): Use erc-remove-if-not instead
	of remove-if-not.
	(erc-nicklist-search-for-nick): Use erc-member-if instead of
	member-if.

	* erc-notify.el (erc-notify-QUIT): Use erc-delete-if with a
	partially-evaluated lambda expression instead of `delete' and
	`find'.

	* erc-track.el: Use erc-assert.
	(erc-track-modified-channels): Remove use of `return'.
	(erc-track-modified-channels): Use `cadr' instead of `second',
	since otherwise we would need yet another eval-when-compile line.

2006-01-19  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-process-sentinel-1): Remove attempt to
	detect SIGPIPE, since it doesn't work.

2006-01-10  Diane Murray  <disumu@x3y2z1.net>

	* erc-spelling.el: Updated copyright years.
	(define-erc-module): Enable/disable `flyspell-mode' for all open
	ERC buffers as well.
	(erc-spelling-dictionaries): Reworded customize description.

	* erc.el (erc-command-symbol): New function.
	(erc-extract-command-from-line): Use `erc-command-symbol'.  This
	fixes a bug where "Symbol's function definition is void:
	erc-cmd-LIST" would be shown after typing /list at the prompt (the
	command was interned because erc-menu.el uses it and is enabled by
	default whereas erc-list.el is not).

	* NEWS: Started a list of renamed variables.

	* erc.el: Reworded the message sent when defining variable
	aliases.
	(erc-command-indicator-face): Doc fix.
	(erc-modules): Enable the match module by default which makes
	current nickname highlighting on as the default.

	* erc-button.el: Updated copyright years.
	(erc-button): New face.
	(erc-button-face): Use `erc-button'.
	(erc-button-nickname-face): New customizable variable.
	(erc-button-add-nickname-buttons, erc-button-add-buttons-1): Send
	new argument to `erc-button-add-button'.
	(erc-button-add-button): Doc fix.  Added new argument to function
	definition, NICK-P.  If it's a nickname, use
	`erc-button-nickname-face', otherwise use `erc-button-face'.  This
	makes channel tracking and buttons work better together when
	`erc-button-buttonize-nicks' is enabled, since there is a nickname
	on just about every line.

	* erc-track.el (erc-track-use-faces): Doc fix.
	(erc-track-faces-priority-list): Added `erc-button' to list.
	(erc-track-priority-faces-only): Doc fix.

2006-01-09  Diane Murray  <disumu@x3y2z1.net>

	* erc-button.el (erc-button-url-regexp): Use `concat' so the
	regexp is not one long line.
	(erc-button-alist): Fixed so that customizing works correctly.
	Reorganized.  Removed lambda functions with more than two lines.
	Doc fix.
	(erc-button-describe-symbol, erc-button-beats-to-time): New
	functions.  Moved from `erc-button-alist'.

2006-01-07  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-process-sentinel-1): Don't try to re-open a
	process if a SIGPIPE occurs.  This happens when a new message
	comes in at the same time a /quit is requested.
	(erc-process-sentinel): Use string-match rather than string= to do
	these comparisons.  Matching literal newlines makes me nervous.

	* erc-track.el (erc-track-remove-from-mode-line): Handle case
	where global-mode-string is not a list.  Emacs22 permits this.

2005-11-23  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el (erc-cmd-SAY): Strip leading space in input line.

2005-10-29  Michael Olson  <mwolson@gnu.org>

	* FOR-RELEASE: Add stuff that needs to be done before the 5.1
	release.  Longer-term items can be added to the 5.2 section.

	* Makefile (SITEFLAG): New variable that indicates what variant of
	"--site-flag" to use.  XEmacs needs "-site-flag".
	(INSTALLINFO): New variable indicating how we should call
	install-info when installing documentation.
	(erc-auto.el, .elc.el): Use $(SITEFLAG).

	* NEWS: Note that last release was 5.0.4.

	* erc.texi: Initial and incomplete draft of ERC documentation.
	Commence collaborate-documentation-hack-mode :^) .

2005-10-29  Diane Murray  <disumu@x3y2z1.net>

	* erc-ring.el (erc-replace-current-command): Revert last change
	since it made the prompt disappear when using `erc-next-command'
	and `erc-previous-command'.

2005-10-28  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-input-marker): New variable that indicates the
	position where text from the user begins, after the prompt.
	(erc-mode-map): Bind <HOME> to erc-bol, just like C-a.
	(erc): Initialize erc-input-marker.
	(erc-display-prompt): Even in case where no prompt is desired by
	the user, clear the undo buffer and set the input marker.
	(erc-bol, erc-user-input): Simplify by using erc-input-marker.

	* erc-pcomplete.el (pcomplete-parse-erc-arguments): Use
	erc-insert-marker.

	* erc-ring.el (erc-previous-command)
	(erc-replace-current-command): Use erc-insert-marker.

	* erc-spelling.el (erc-spelling-init): Make sure that even Emacs21
	obeys erc-spelling-flyspell-verify.
	(erc-spelling-flyspell-verify): Use erc-input-marker.  This should
	make it considerably faster when switching to a buffer that has
	seen a lot of activity since last viewed.

2005-10-25  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (erc-server-version, 004): Re-added setting of
	`erc-server-version'.  It doesn't hurt to set, and it could be
	used in modules or users' settings.

	* NEWS: Added descriptions of some new features.

2005-10-20  Diane Murray  <disumu@x3y2z1.net>

	* erc-match.el (erc-current-nick-highlight-type): Set to `keyword'
	as default.
	(erc-beep-match-types): New variable.
	(erc-text-matched-hook): Doc fix.  Added `erc-beep-on-match' to
	customization options.
	(erc-beep-on-match): New function.  If the MATCH-TYPE is found in
	`erc-beep-match-types', beep.

	* erc-compat.el (erc-make-obsolete, erc-make-obsolete-variable):
	New functions to deal with the difference in the number of
	arguments accepted by `make-obsolete' and `make-obsolete-variable'
	in Emacs and XEmacs.

	* erc.el, erc-nets.el: Use `erc-make-obsolete' and
	`erc-make-obsolete-variable'.

	* erc-compat.el (erc-make-obsolete, erc-make-obsolete-variable):
	Handle `wrong-number-of-arguments' error instead of checking for
	xemacs feature as future versions of XEmacs might accept three
	arguments.

2005-10-18  Theresa O'Connor  <ted@oconnor.cx>

	* erc.el: Tell emacs-lisp-mode how to font-lock define-erc-module
	docstrings.

2005-10-08  Diane Murray  <disumu@x3y2z1.net>

	* AUTHORS, CREDITS, ChangeLog, ChangeLog.2002, ChangeLog.2004:
	Updated my email address.

2005-10-06  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-send-input-line, erc-cmd-KICK, erc-cmd-PART)
	(erc-cmd-QUIT, erc-cmd-TOPIC, erc-kill-server, erc-kill-channel):
	Adapt to new TARGET parameter of erc-server-send.

	* erc-backend.el (erc-server-connect): Don't specify encoding for
	erc-server-process, since we set this each time we send a line to
	the server.
	(erc-encode-string-for-target): Remove.
	(erc-server-send): Allow TARGET to be specified.  This was how it
	used to be before my more-backend work.  Set encoding of server
	process just before sending text to it.  Associate encoding with
	text if we are using the queue.
	(erc-server-send-queue): Pull encoding from queue.
	(erc-message, erc-send-ctcp-message, erc-send-ctcp-notice): Adapt
	to new TARGET parameter of erc-server-send.

2005-10-05  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-toggle-debug-irc-protocol): Use erc-view-mode-enter
	rather than view-mode.

	* erc-backend.el (erc-encode-string-for-target): If given a nil or
	empty string, return "".
	(erc-server-send-queue): XEmacs fix: Use erc-cancel-timer rather
	than cancel-timer.

	* erc-compat.el (erc-view-mode-enter): New function that is
	aliased to the correct way of entering view-mode.

	* erc-match.el (erc-log-matches-make-buffer): Use
	erc-view-mode-enter rather than view-mode-enter.

2005-10-05  Theresa O'Connor  <ted@oconnor.cx>

	* erc-backend.el (erc-encode-string-for-target): If str is nil,
	pass the empty string to erc-encode-coding-string instead, which
	allows one to /part and /quit without providing a reason again.

2005-10-03  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-message, erc-send-ctcp-message)
	(erc-send-ctcp-notice): Encode string for target before sending.

	* erc.el (erc-cmd-KICK, erc-cmd-PART, erc-cmd-QUIT, erc-cmd-TOPIC)
	(erc-kill-server, erc-kill-channel): Ditto.

2005-09-05  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-page.el (erc-ctcp-query-PAGE): (message text) -> (message
	"%s" text).
	(erc-cmd-PAGE): Simplify regexp. Put `do-not-parse-args' t.

2005-09-05  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-flood-limit, erc-flood-limit2): Remove since they
	are no longer needed.
	(erc-send-input): Detect whether we want flood control to be
	active.  The previous behavior was to always force the message.
	(erc-toggle-flood-control): Adapt to new flood control method.  No
	more 'strict.
	(erc-cmd-SV): Use concat rather than
	format-time-string.
	(erc-format-target, erc-format-target-and/or-server): Shorten
	logic statements.

	* erc-compat.el (erc-emacs-build-time): Use a string
	representation rather than trying to coerce a time out of a string
	on XEmacs.

	* erc-identd.el (erc-identd-start): Use make-network-process
	instead of open-network-stream.  Error out if this is not defined.

	* erc-backend.el (erc-send-line): New command that sends a line
	using flood control, using a callback for display.  It isn't used
	yet.

2005-09-04  Michael Olson  <mwolson@gnu.org>

	* erc.el: Add defvaralias and make-obsolete-variable for
	erc-default-coding-system.
	(channel-topic, channel-modes, channel-user-limit, channel-key,
	invitation, away, channel-list, bad-nick): Rename globally to
	erc-{name-of-variable}.

2005-09-03  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el (erc-message): Simplify regexp.
	(erc-cmd-DEOP, erc-cmd-OP): Simplify.

2005-08-29  Michael Olson  <mwolson@gnu.org>

	* erc.el: Alias erc-send-command to erc-server-send.  ErBot needs
	this to work without modification.  Add defvaralias for
	erc-process.  Make this and the other backwards-compatibility
	functions and variables be marked obsolete as of ERC 5.1.

	* erc-backend.el: Add autoload for erc-log macro.
	(erc-server-connect): Set some variables before defining process
	handlers.  It probably doesn't make any difference.

2005-08-26  Michael Olson  <mwolson@gnu.org>

	* erc.el: Add defvaralias for erc-announced-server-name, since
	this seems to be widely used.

2005-08-17  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc): Remove unnecessary boundp check.

	* erc-autoaway.el: Fix compiler warning.

	* erc-backend.el (erc-server-version): Since this isn't used by
	any code, and isn't generally useful, remove it.
	(erc-server-send-queue): Use erc-current-time rather than
	float-time.
	(004): Don't set erc-server-version.

	* erc-dcc.el (erc-dcc-chat-request, erc-dcc-get-parent): Move to
	fix a compiler warning.

	* erc-ibuffer.el (erc-server): Remove unnecessary boundp check.

	* erc-identd.el (erc-identd-start): Use read-string instead of
	read-input.

	* erc-imenu.el (erc-unfill-notice): Use a while loop instead of
	replace-regexp.

	* erc-nicklist.el: Add conditional dependency on erc-bbdb.
	(erc-nicklist-insert-contents): Tighten some regexps.

	* erc-notify.el (erc-notify-list): Docfix.

	* erc-spelling.el (erc-spelling-dictionaries): Add :type and
	:group to silence a compiler warning.

2005-08-14  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el (erc-session-server, erc-session-port)
	(erc-announced-server-name, erc-server-version)
	(erc-server-parameters): Moved here from erc.el.
	(erc-server-last-peers): Moved, renamed from last-peers.
	(erc-server-lag): Moved, renamed from erc-lag.
	(erc-server-duplicates): Moved, renamed from erc-duplicates.
	(erc-server-duplicate-timeout): Moved, renamed from
	erc-duplicate-timeout.
	(erc-server): New customization group hosting all options from
	this file.
	(erc-server-prevent-duplicates): Moved, renamed from
	erc-prevent-duplicates.
	(erc-server-duplicate-timeout): Moved, renamed from
	erc-duplicate-timeout.
	(erc-server-auto-reconnect, erc-split-line-length)
	(erc-server-coding-system, erc-encoding-coding-alist)
	(erc-server-connect-function, erc-server-flood-margin)
	(erc-server-flood-penalty): Change group to 'erc-server.
	(erc-server-send-ping-interval): Moved, renamed from
	erc-ping-interval.
	(erc-server-ping-handler): Moved, renamed from erc-ping-handler.
	(erc-server-setup-periodical-server-ping): Moved, renamed from
	erc-setup-periodical-server-ping.
	(erc-server-connect): Add to docstring.  Move more initialization
	here.
	(erc-server-processing-p): Docfix.
	(erc-server-connect): Use 'raw-text like in the original version.
	(erc-server-filter-function): Don't reset process coding system.

	* erc-stamp.el (erc-add-timestamp): If the text at point is
	invisible, don't insert a timestamp.  Thanks to Pascal
	J. Bourguignon for the suggestion.

	* erc-match.el (erc-text-matched-hook): Don't hide fools by
	default, but include it in the available options.

2005-08-13  Michael Olson  <mwolson@gnu.org>

	* erc-*.el: s/erc-send-command/erc-server-send/g.
	s/erc-process/erc-server-process/g (sort of).  Occasional
	whitespace and indentation fixes.

	* erc-backend.el: Specify a few local variables for indentation.
	Take one item off of the TODO list.
	(erc-server-filter-data): Renamed from erc-previous-read.  From
	circe.
	(erc-server-processing-p): New variable that indicates when we're
	currently processing a message.  From circe.
	(erc-split-line-length): New option that gives the maximum line
	length of a single message.  From circe.
	(erc-default-coding-system): Moved here from erc.el.
	(erc-split-line): Renamed from erc-split-command and taken from
	circe.
	(erc-connect-function, erc-connect, erc-process-sentinel-1)
	(erc-process-sentinel, erc-flood-exceeded-p, erc-send-command)
	(erc-message, erc-upcase-first-word, erc-send-ctcp-message)
	(erc-send-ctcp-notice): Moved here from erc.el.
	(erc-server-filter-function): Renamed from erc-process-filter.
	From circe.
	(erc-server-process): Renamed from `erc-process' and moved here
	from erc.el.
	(erc-server-coding-system): Renamed from
	`erc-default-coding-system'.
	(erc-encoding-coding-alist): Moved here from erc.el.
	(erc-server-flood-margin, erc-server-flood-penalty):
	(erc-server-flood-last-message, erc-server-flood-queue):
	(erc-server-flood-timer): New options from circe that allow
	tweaking of flood control.
	(erc-server-connect-function): Renamed from erc-connect-function.
	(erc-flood-exceeded-p): Removed.
	(erc-coding-system-for-target)
	(erc-encode-string-for-target, erc-decode-string-from-target):
	Moved here from erc.el
	(erc-server-send): Renamed from erc-send-command.  Adapted from
	the circe function by the same name.
	(erc-server-send-queue): New function from circe that implements
	handling of a flood queue.
	(erc-server-current-nick): Renamed from current-nick.
	(erc-server-quitting): Renamed from `quitting'.
	(erc-server-last-sent-time): Renamed from `last-sent-time'.
	(erc-server-last-ping-time): Renamed from `last-ping-time'.
	(erc-server-lines-sent): Renamed from `lines-sent'.
	(erc-server-auto-reconnect): Renamed from `erc-auto-reconnect'.
	(erc-server-coding-system): Docfix.
	(erc-server-connect): Renamed from `erc-connect'.  Require SERVER
	and PORT parameters.  Initialize several variables here.  Don't
	set `erc-insert-marker'.  Use a per-server coding system via
	erc-server-default-encoding.

	* erc.el (erc-version-string): Changed to indicate we are running
	the `more-backend' branch.
	(erc-send-single-line): Implement flood control using
	erc-split-line.
	(erc-send-input): Move functionality of erc-send-single-line in
	here.
	(erc-send-single-line): Assimilated!
	(erc-display-command, erc-display-msg): Handle display hooks.
	(erc-auto-reconnect, current-nick, last-sent-time)
	(last-ping-time, last-ctcp-time, erc-lines-sent, erc-bytes-sent)
	(quitting): Moved to erc-backend.el.
	(erc): Docfix.  Don't initialize quite so many things here.

2005-08-10  Michael Olson  <mwolson@gnu.org>

	* debian/copyright (Copyright): Remove notices for 4 people, since
	they didn't contribute legally-significant changes, or have had
	these changes overwritten.

	* erc-log.el: Remove copyright notice.

	* erc.el: Remove 3 copyright notices.

2005-08-09  Michael Olson  <mwolson@gnu.org>

	* debian/changelog: Create 5.0.4-3 package.  This doesn't serve
	any purpose other than to thank Romain Francoise for some advice.

	* Makefile (debrelease): Allow last upload and extra build options
	to be specified.

2005-08-08  Michael Olson  <mwolson@gnu.org>

	* debian/changelog: Create 5.0.4-2 package.

	* debian/control (Uploaders): Add Romain Francoise.
	(Standards-Version): Update to 3.6.2.
	(Depends): Add `emacsen'.

	* debian/scripts/startup.erc (load-path): Minor whitespace fixup.

	* Makefile (clean): Split target from realclean and make it remove
	files that aren't packaged in releases.
	(clean, release): Minor cleanups.
	(debrelease): Use debuild rather than dpkg-buildpackage since the
	former calls lintian.  Minor cleanups.
	(debrelease-mwolson): New target that removes old Debian packages,
	calls debrelease, and copies the resulting package to my dist dir.
	(upload): New target that automates the process of uploading an
	ERC release to sourceforge.

	* erc.el (erc-mode): Use `make-local-variable' instead of
	`make-variable-buffer-local'.

2005-07-12  Michael Olson  <mwolson@gnu.org>

	* debian/changelog: Build 5.0.4-1.

	* Makefile (release): Prepare zip file in addition to tarball.

	* NEWS: Add item for the undo fix.

2005-07-09  Michael Olson  <mwolson@gnu.org>

	* erc-nicklist.el (erc-nicklist-insert-contents): Check
	erc-announced-name before erc-session-server.  Make sure that we
	can never get a stringp (nil) error.
	(erc-nicklist-call-erc-command): If given no command, do nothing.
	This fixes an error that used to occur when a stray mouse click
	was made outside of the popup window, but on the erc-nicklist
	menu.

	* erc-bbdb.el (erc-bbdb-search-name-and-create): Get rid of the
	infinite input loop when you want to create a new record.  Replace
	most of that with a completing read of existing nicks.  If no nick
	is chosen, create a new John Doe record.  The net effect of this
	is that the old behavior is re-instated, with the addition of one
	completing read that happens when you do a /whois.

2005-07-09  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el (erc-process-input-line): Docfix.
	(erc-update-mode-line-buffer): Use `erc-propertize' instead of
	`propertize'.
	(erc-propertize): Move to erc-compat.el.

	* erc-compat.el (erc-propertize): Move here from erc.el. Always
	return a copy of the string (like `propertize' in GNU Emacs).

	* erc-nicklist.el (erc-nicklist-icons-directory)
	(erc-nicklist-voiced-position)
	(erc-nicklist-insert-medium-name-or-icon): Docfix.
	(erc-nicklist-insert-contents): Simplify.
	(erc-nicklist-mode-map): Bind RET instead of `return'. Bind
	`down-mouse-3' instead of `mouse-3'.
	(erc-nicklist-kbd-cmd-QUERY): Cleanup regexp.
	(erc-nicklist-channel-users-info): Docfix. Simplify.

2005-07-02  Michael Olson  <mwolson@gnu.org>

	* images: New directory containing the images that are used by
	erc-nicklist.el.  These are from Gaim, and are thought to be
	available under the terms of the GPL.

	* erc-bbdb.el: Add local variables section to preserve tabs, since
	that is the style used throughout this file.  Apply patch from
	Edgar Gonçalves as follows.
	(erc-bbdb-bitlbee-name-field): New variable that indicates the
	field name to use for annotating the "displayed name" of a bitlbee
	contact.
	(erc-bbdb-irc-highlight-field): Docfix.
	(erc-bbdb-search-name-and-create): Prompt the user for the name of
	a contact if none was found.  Merge the new entries into the
	specified contact.  If new arg SILENT is non-nil, do not prompt
	the user for a name or offer to merge the new entry.
	(erc-bbdb-insinuate-and-show-entry): New arg SILENT is accepted,
	which is passed on to erc-bbdb-search-name-and-create.
	(erc-bbdb-whois): Tell erc-bbdb-search-name-and-create to prompt
	for name if necessary.
	(erc-bbdb-JOIN, erb-bbdb-NICK): Forbid
	erc-bbdb-search-name-and-create from prompting for a name.

	* erc-nicklist.el: Add local variables section to preserve tabs,
	since that is the style used throughout this file.  Apply patch
	from Edgar Gonçalves as follows.
	(erc-nicklist-use-icons): New option; if non-nil, display an icon
	instead of the name of the chat medium.
	(erc-nicklist-icons-directory): New option indicating the path to
	the PNG files that are used for chat icons.
	(erc-nicklist-use-icons): New option indicating whether to put
	voiced nicks on top, bottom, or not to differentiate them.  The
	default is to put them on the bottom.
	(erc-nicklist-bitlbee-connected-p): New variable that indicates
	whether or not we are currently using bitlbee.  An attempt will be
	made to auto-detect the proper value.  This is bound in the
	`erc-nicklist-insert-contents' function.
	(erc-nicklist-nicklist-images-alist): New variable that maps a
	host type to its icon.  This is set by `erc-nicklist'.
	(erc-nicklist-insert-medium-name-or-icon): New function that
	inserts an icon or string that identifies the current host type.
	(erc-nicklist-search-for-nick): New function that attempts to find
	a BBDB record that corresponds with this contact given its
	finger-host.  If found, return its bitlbee-nick field.
	(erc-nicklist-insert-contents): New function that inserts the
	contents of the nick list, including text properties and images.
	(erc-nicklist): Populate `erc-nicklist-images-alist'.  Move
	nicklist content generation code to
	`erc-nicklist-insert-contents'.
	(erc-nicklist-mode-map): Map C-j to erc-nicklist-kbd-menu and RET
	to erc-nicklist-kbd-cmd-QUERY.
	(erc-nicklist-call-erc-command): Make use of
	`switch-to-buffer-other-window'.
	(erc-nicklist-cmd-QUERY): New function that opens a query buffer
	for the given contact.
	(erc-nicklist-kbd-cmd-QUERY): Ditto; contains most of the code.
	(erc-nicklist-kbd-menu): New function that shows the nicklist
	action menu.
	(erc-nicklist-channel-users-info): Renamed from
	`erc-nicklist-channel-nicks'.  Implement sorting voiced users.

2005-06-29  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc-nickserv.el (erc-nickserv-alist): Fix regexp for Azzurra.

2005-06-26  Michael Olson  <mwolson@gnu.org>

	* erc-autojoin.el (erc-autojoin-add, erc-autojoin-remove): Use
	`erc-session-server' if `erc-announced-server-name' is nil.  This
	happens when servers don't send a 004 message.

	* erc.el (erc-quit-server): Ditto.

	* erc-ibuffer.el (erc-server, erc-server-name): Ditto.

	* erc-notify.el (erc-notify-JOIN, erc-notify-NICK)
	(erc-notify-QUIT): Ditto.

2005-06-24  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc.el (erc-default-coding-system)
	(erc-handle-user-status-change): Docstring fix.
	(with-erc-channel-buffer): Removed.
	(erc-ignored-reply-p): Replace `with-erc-channel-buffer' with
	`erc-with-buffer'.
	(erc-display-line-1): Fix broken undo.

2005-06-23  Michael Olson  <mwolson@gnu.org>

	* CREDITS: Add entries for Luigi Panzeri and Andreas Schwab.

	* erc-nickserv.el (erc-nickserv-alist): Add entries for Azzurra
	and OFTC.  Thanks to Luigi Panzeri and Andreas Schwab for
	providing these.

2005-06-16  Michael Olson  <mwolson@gnu.org>

	* CREDITS: Add John Paul Wallington.

	* erc.el: Thanks to John Paul Wallington for the following.
	(erc-nickname-in-use): Use `string-to-number' instead of
	`string-to-int'.

	* erc-dcc.el (erc-dcc-handle-ctcp-send)
	(erc-dcc-handle-ctcp-chat, erc-dcc-get-file)
	(erc-dcc-chat-accept): Ditto.

	* erc-identd.el (erc-identd-start): Ditto.

2005-06-16  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc.el (erc-mode-map): Suppress `font-lock-fontify-block' key
	binding since it destroys face properties.

2005-06-08  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-cmd-UNIGNORE): Use `erc-member-ignore-case' instead
	of `member-ignore-case'.  Thanks to bpalmer for the heads up.

2005-06-06  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-modules): Fix a mistake I made when editing this a
	few days ago.  Modes should now be disabled properly.
	(erc-cmd-BANLIST, erc-cmd-MASSUNBAN): Remove unnecessary call to
	`format'.  Thanks to Andreas Schwab for reporting this.

	* debian/changelog: Close "README file missing" bug.

	* debian/rules (binary-erc): Install README file.

2005-06-03  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-with-buffer): Set `lisp-indent-function' so Emacs
	Lisp mode knows how to indent erc-with-buffer blocks.
	(with-erc-channel-buffer): Ditto.
	(erc-with-all-buffers-of-server): Ditto.
	(erc-modules): Use pcomplete by default, not completion, since
	erc-complete.el is deprecated.  Use `fboundp' instead of
	`symbol-value' to check for existence of a function before calling
	it.  This was causing an error when untoggling the `completion'
	option and trying to save via the customize interface.

	* erc-track.el (erc-modified-channels-update): If a buffer is not
	currently connected, remove it from the modified channels list.
	This should fix the problem where residue was left on the mode
	line after quitting ERC.

	* erc-list.el (erc-prettify-channel-list): Docfix; thanks to John
	Paul Wallington for reporting this.

2005-05-31  Michael Olson  <mwolson@gnu.org>

	* debian/changelog: First draft of entries for the 5.0.3 release.

	* debian/README.Debian: Note that ERC will now install correctly
	on versions of Emacs or XEmacs that do not have the `format-spec'
	library.  Correct some grammar and prune the content a bit.

	* debian/scripts/install (emacs20): Remove line since we no longer
	need to deal with format-spec.el.

	* NEWS: Add entries for the upcoming 5.0.3 release.

	* erc.el: Don't require format-spec since this is provided in
	erc-compat.el now.
	(erc-process-sentinel, erc-setup-periodical-server-ping): Use
	`erc-cancel-timer' instead of `cancel-timer'.
	(erc-version-string): Update to 5.0.3.

	* erc-autoaway.el (autoaway, erc-autoaway-reestablish-idletimer):
	Use `erc-cancel-timer' instead of `cancel-timer'.

	* erc-compat.el (format-spec, format-spec-make): If we cannot load
	the `format-spec' library, provide versions of these functions.
	This should keep problems from surfacing with Emacs21 Debian
	builds.
	(erc-cancel-timer): New function created to take the place of
	`cancel-timer' since XEmacs calls it something else.

	* erc-track.el (erc-modified-channels-update): Accept any number
	of arguments, which are ignored.  This allows it to be run from
	`erc-disconnected-hook' without extra bother.
	(track): Add `erc-modified-channels-update' to
	`erc-disconnected-hook' so that the indicators are removed
	correctly in some edge cases.
	(erc-modified-channels-display): Make sure that we never pass nil
	to the function in `erc-track-shorten-function'.  This happens
	when we have deleted buffers in `erc-modified-channels-alist'.
	Also, make sure that the buffer has a non-nil short-name before
	adding it to the string list.  This should fix some XEmacs
	warnings when running /quit with unchecked buffers, as well as get
	rid of a stray buffer problem (or so it is hoped).

2005-05-31  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc-replace.el, erc-speak.el: Clean up comment formatting.

	* erc-ring.el (ring, erc-input-ring-index, erc-clear-input-ring):
	Clean up docstring formatting.

2005-05-30  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc.el (erc-cmd-BANLIST, erc-cmd-MASSUNBAN): Delete superfluous
	arg to `format'.
	(erc-load-irc-script): Use `insert-file-contents' instead of
	`insert-file'. Simplify.

2005-05-29  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-version-string): Move this up so that it is
	evaluated before the `require' statements.  Not a major change.

2005-04-27  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc.el (erc-complete-word): Simplify.

2005-04-27  Michael Olson  <mwolson@gnu.org>

	* Makefile (debrelease): Use a slightly different approach when
	removing CVS and Arch cruft.

	* debian/changelog: Update for 5.0.2-1 package.

2005-04-25  Michael Olson  <mwolson@gnu.org>

	* erc-autoaway.el (erc-autoaway-reestablish-idletimer): Move code
	block higher in file to fix a load failure when using Emacs21.
	Thanks to Daniel Brockman for the report and fix.

2005-04-24  Adrian Aichner  <adrian@xemacs.org>

	* erc-backend.el (JOIN): save-excursion so that
	`erc-current-logfile' inserts into the correct channel buffers
	when using erc-log-insert-log-on-open in combination with autojoin
	to multiple channels.

2005-04-17  Adrian Aichner  <adrian@xemacs.org>

	* erc-log.el: Remove stray whitespace.
	* erc.el: Ditto.

2005-04-09  Aidan Kehoe  <kehoea@parhasard.net>

	* erc.el: autoload erc-select-read-args, which, because it parses
	erc-select's args, can be called before erc.el is loaded.

2005-04-07  Theresa O'Connor  <ted@oconnor.cx>

	* erc-viper.el: Remove final newlines from previously-existing ERC
	buffers. (Minor bug fix.)

2005-04-06  Michael Olson  <mwolson@gnu.org>

	* Makefile (debrelease): Ignore errors from deleting Arch and CVS
	metadata.

2005-04-05  Michael Olson  <mwolson@gnu.org>

	* ChangeLog, CREDITS, AUTHORS: Correct name and email address of
	Marcelo Toledo.

2005-04-04  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-modules): Add entry for spelling module.

	* erc-spelling.el: Add autoload line.

	* erc-backend.el: Apply latest non-ascii patch from Kai Fan.
	(erc-decode-parsed-server-response): Search
	erc-response.command-args for channel name.  Decode the
	erc-response struct using this channel name as key according to
	the `erc-encoding-coding-alist'.

	* erc-track.el: Apply patch from Henrik Enberg.
	(erc-modified-channels-object): Use optimal amount of whitespace
	around modified channels indicator.

2005-04-02  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc.el (define-erc-module, erc-with-buffer)
	(erc-with-all-buffers-of-server, with-erc-channel-buffer): Add
	edebug-form-spec.

	* erc-compat.el (erc-define-minor-mode): Ditto.

2005-03-29  Jorgen Schaefer  <forcer@forcix.cx>

	* erc-spelling.el: New file.

2005-03-24  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc-backend.el (define-erc-response-handler): Add
	`definition-name' property to constructed symbols so that
	find-function and find-variable will find them.

2005-03-21  Michael Olson  <mwolson@gnu.org>

	* erc-dcc.el, erc-goodies.el, erc-list.el, erc-notify.el,
	erc-ring.el, erc.el: Copyright assignment occurred.

	* debian/scripts/install: Make a shell wrapper around the original
	Makefile and inline the Makefile.  The problem is that Debian
	passes all the Emacs variants at once, rotating them at every
	invocation of the install script, which happens once per variant.
	This caused each installation to happen N-1 times more often than
	it should have.  As a result, we need to only deal with the first
	argument.
	(ELFILES): Only add format-spec.el if we are compiling for
	emacs21.  Don't filter out erc-compat.el.
	(SITEFLAG): New variable that indicates that the "nosite" option
	should look like.
	(.DEFAULT): Use $(FLAVOUR) instead of $@ for clarity.

	* debian/rules: Install NEWS file and compress it.

	* debian/maint/postinst: Be more cautious about configuration
	step.

	* debian/copyright (Copyright): Another assignment came in.

	* debian/control (Standards-Version): Update to a newer version as
	recommended by lintian.

	* debian/changelog: Changes made for the Debian package.

	* debian/README.Debian: Keep only the General Notes section.

	* NEWS: Move old history items here from debian/README.Debian.

	* Makefile (SNAPSHOTDATE): Deprecate this option since we hope to
	release more often.

2005-03-20  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-define-catalog, `ctcp-request-to'): Fix typo (%: ->
	%t:).

2005-03-01  Michael Olson  <mwolson@gnu.org>

	* erc-log.el (erc-save-buffer-in-logs): Replace tabs with spaces
	in code indentation.

2005-02-28  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-display-message): Apply corrected patch from Henrik
	Enberg.

2005-02-27  Michael Olson  <mwolson@gnu.org>

	* erc.el (erc-display-message): Apply patch from Henrik Enberg.
	Check here to see if a message should be hidden, rather than
	relying on code in each individual command.
	(erc-version-string): Add "(CVS)" to the version string for
	clarity.

	* erc-backend.el (JOIN, KICK, MODE, NICK, PART, QUIT, TOPIC):
	Don't check `erc-hide-list' here.

	* erc-list.el, erc-match.el, erc.el, debian/copyright: Update
	copyright information as a few more people have assignments
	registered.

2005-02-06  Michael Olson  <mwolson@gnu.org>

	* erc-backend.el: Apply patch from Kai Fan for non-ASCII character
	support.
	(erc-parse-server-response): Add call to
	`erc-decode-parsed-server-response'.
	(erc-decode-parsed-server-response): New function that decodes a
	pre-parsed server response before it can be handled.
	(PRIVMSG): Comment out call to `erc-decode-string-from-target'.
	(TOPIC): Ditto.

2005-02-01  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-process-sentinel-1): Don't reconnect on connection
	refused. This error is reported differently when using
	open-network-stream-nowait.

2005-01-26  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-cmd-APPENDTOPIC, erc-set-topic): The control
	character in `channel-topic' was changed to \C-o - replaced \C-c
	with \C-o so that these functions work as expected again.
	(erc-get-channel-mode-from-keypress): Doc fix.

2005-01-25  Diane Murray  <disumu@x3y2z1.net>

	* erc.el, erc-button.el, erc-compat.el, erc-goodies.el,
	erc-match.el, erc-nets.el, ChangeLog, NEWS: Merged bug fixes made
	on release_5_0_branch since 5.0.1 release.

2005-01-24  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc.el (erc-input-action): Quote `erc-action-history-list' so
	that input history actually works.
	(erc-process-ctcp-query): Fix and simplify logic.
	(erc-get-channel-mode-from-keypress): Use `C-' string syntax.
	(erc-load-irc-script-lines): Use `erc-command-indicator' instead
	of `erc-prompt'.

2005-01-23  Theresa O'Connor  <ted@oconnor.cx>

	* erc-viper.el: Ensure that `viper-comint-mode-hook' runs in
	buffers whose `erc-mode-hook' has already run when this file is
	loaded.
	Explicitly `require' erc.el.

2005-01-22  Theresa O'Connor  <ted@oconnor.cx>

	* erc.el (erc-mode): Remove frobbing of `require-final-newline'.

	* erc-log.el (erc-save-buffer-in-logs): Remove frobbing of
	`require-final-newline'.

	* erc-viper.el: New file. This is where all ERC/Viper
	compatibility code should live. When and if ERC is bundled with
	Emacs, some of the hacks in this file should be merged into Viper
	itself.

2005-01-21  Theresa O'Connor  <ted@oconnor.cx>

	* erc.el (erc-mode): Set `require-final-newline' to nil in ERC
	buffers. This prevents a Viper misfeature whereby extraneous
	newlines are inserted into the ERC buffer when switching between
	viper states.

	* erc-log.el (erc-save-buffer-in-logs): Bind `require-final-newline'
	to t when calling `write-region' to ensure that further log
	entries start on fresh lines.

2005-01-21  Diane Murray  <disumu@x3y2z1.net>

	* erc-button.el (erc-button-add-face): Reverted my change to the
	order faces since it had the unwanted effect of putting the button
	face after all others.
	(erc-button-face-has-priority): Removed this variable as it is not
	necessary anymore - it was used to compensate for the above
	mentioned change.

	* NEWS: Added the latest fixes.

2005-01-20  Diane Murray  <disumu@x3y2z1.net>

	* erc-button.el, erc-match.el:
	(erc-button-syntax-table, erc-match-syntax-table): Added \ as a
	legal character for nicknames.

	* erc-nets.el (erc-server-select): Fixed so that only networks
	with servers found in `erc-server-alist' are available as choices.

	* erc.el, erc-compat.el, erc-goodies.el:
	(erc-replace-match-subexpression-in-string): New function.  Needed
	because `replace-match' in XEmacs doesn't replace regular
	expression subexpressions in strings, only in buffers.
	(erc-seconds-to-string, erc-controls-interpret): Use the new
	function.

	* erc-button.el (erc-button-add-button): Use the `:button-face'
	key combined with an `erc-mode' local `widget-button-face' set to
	nil to get the widget overlay face suppressed in XEmacs.

2005-01-19  Francis Litterio  <franl@world.std.com>

	* erc-button.el (erc-button-add-face): The face added by this
	function is more important than the existing text's face, so we
	now prepend erc-button-face to the list of existing faces when
	adding a button.  To instead append erc-button-face to existing
	faces, set variable `erc-button-face-has-priority' to nil.
	(erc-button-face-has-priority): New variable to control how
	erc-button-add-face adds erc-button-face to existing faces.
	(erc-button-press-button): Silenced a byte-compiler warning about
	too few arguments in a call to `error'.

2005-01-19  Diane Murray  <disumu@x3y2z1.net>

	* NEWS: Added list of 5.0.1 fixes.

2005-01-19  Michael Olson  <mwolson@gnu.org>

	* AUTHORS: Move to format that cscvs can understand.  As an added
	perk, entries line up nicer.

	* erc.el, erc-fill.el, erc-pcomplete.el, debian/copyright: Merge a
	few more copyright lines thanks to Alex Schroeder's BBDB file.

	* Makefile: Change version to correspond with our new scheme.

2005-01-18  Diane Murray  <disumu@x3y2z1.net>

	* erc-list.el (erc-chanlist-channel-line-regexp): Now matches
	private channels, the channels `#' and `&', and channels with
	names including non-ascii characters.
	(erc-chanlist-join-channel): Don't attempt to join private
	channels since the channel name is unknown.

	* erc-goodies.el (erc-make-read-only): Add `rear-nonsticky'
	property to avoid `Text is read-only' errors during connection.
	`front-nonsticky' does not exist, changed to `front-sticky'.
	(erc-controls-interpret, erc-controls-strip): Just work on the
	string, don't open a temporary buffer.
	(erc-controls-propertize): Now accepts optional argument STR.

2005-01-17  Michael Olson  <mwolson@gnu.org>

	* Makefile: Version is 5.01, but only in the Makefile.  It has not
	been released yet.

	* erc-auto.in, erc-autojoin.el, erc-bbdb.el, erc-button.el,
	erc-chess.el, erc-complete.el, erc-dcc.el, erc-fill.el,
	erc-goodies.el, erc-ibuffer.el, erc-identd.el, erc-imenu.el,
	erc-list.el, erc-match.el, erc-menu.el, erc-nets.el,
	erc-netsplit.el, erc-nickserv.el, erc-notify.el, erc-pcomplete.el,
	erc-ring.el, erc-speak.el, erc-speedbar.el, erc-stamp.el,
	erc-track.el, erc-xdcc.el, erc.el, debian/copyright: Update
	copyright notices.  If anyone has signed papers for Emacs in
	general, merge them with the FSF's entry.

2005-01-16  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc): `erc-set-active-buffer' was being called before
	`erc-process' was set, so that channels weren't being marked
	active correctly upon join; fixed.

2005-01-15  Johan Bockgård  <bojohan+sf@dd.chalmers.se>

	* erc-backend.el (def-edebug-spec): This macro caused problems (in
	XEmacs). Use its expansion directly.

2005-01-15  Diane Murray  <disumu@x3y2z1.net>

	* erc-button.el (erc-button-add-button): Reverted previous change
	since `:suppress-face' doesn't seem to be checked for a certain
	face.
	(erc-button-add-face): FACE is now appended to the `old' face.
	This should fix the problem of faces being "covered" by
	`erc-button-face'.

2005-01-14  Diane Murray  <disumu@x3y2z1.net>

	* erc.el, erc-backend.el (erc-cmd-OPS, erc-cmd-COUNTRY,
	erc-cmd-NICK, erc-process-ctcp-query, ERROR, PONG, 311, 312, 313,
	314, 317, 319, 320, 321, 322, 330, 352): Use catalog entries
	instead of hard-coded text messages.
	(english): Added new catalog entries `country', `country-unknown',
	`ctcp-empty', `ctcp-request-to', `ctcp-too-many', `nick-too-long',
	`ops', `ops-none', `ERROR', `PONG', `s311', `s312', `s313',
	`s314', `s317', `s317-on-since', `s319', `s320', `s321', `s322',
	`s330', and `s352'.
	(erc-send-current-line): Use `erc-set-active-buffer' (change was
	lost in previous bug fix).

2005-01-14  Francis Litterio  <franl@world.std.com>

	* erc-button.el (erc-button-add-button): Fixed a bug where the
	overlay created by widget-convert-button has a `face' property
	that hides the `face' property set on the underlying button text.

	* erc-goodies.el: Docstring fix.

	* erc-button.el: Improved docstring for variable erc-button-face.

2005-01-13  Diane Murray  <disumu@x3y2z1.net>

	* erc-menu.el (erc-menu-definition): "Topic set by channel
	operator": Small word change.  "Identify to NickServ...": Check
	that we're connected to the server.  Added "Save buffer in log"
	and "Truncate buffer".

2005-01-13  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-display-line-1): Widen before we try to insert
	anything, this makes sure input isn't broken when the buffer is
	narrowed by the user.
	(erc-beg-of-input-line): Simplify, just return the position of
	`erc-insert-marker' or error if does not exist.
	(erc-send-current-line): Widen before trying to send anything.

2005-01-13  Diane Murray  <disumu@x3y2z1.net>

	* erc.el, erc-backend.el, erc-list.el:
	(erc-update-mode-line-buffer): Strip controls characters from
	`channel-topic' since we add our own control character to it.
	(TOPIC, 332): Use \C-o instead of \C-c to force an end of IRC
	control characters as it also ends bold, underline, and inverse -
	\C-c only ends colors.
	(erc-chanlist-322): Strip control characters from channel and
	topic.  No need to interpret controls when we're applying overlays
	to the lines.

	* erc.el, erc-backend.el, erc-button.el, erc-netsplit.el,
	erc-nicklist.el: Fixed so that each server has an active buffer.
	(erc-active-buffer): Now a buffer-local variable.
	(erc-active-buffer, erc-set-active-buffer): New functions.
	(erc-display-line, erc-echo-notice-in-active-non-server-buffer,
	erc-process-away, MODE): Call `erc-active-buffer' to get the
	active buffer for the current server.
	(erc, erc-process-sentinel-1, erc-grab-region, erc-input-action,
	erc-send-current-line, erc-invite-only-mode,
	erc-toggle-channel-mode, erc-channel-names, MODE, erc-nick-popup,
	erc-nicklist-call-erc-command): Use `erc-set-active-buffer' to set
	the active buffer for the current server.
	(erc-cmd-WHOLEFT): Use 'active as BUFFER in `erc-display-message'.

	* erc-track.el (erc-track-modified-channels): Server buffers are
	now treated the same as channels and queries.  This means that
	`erc-track-priority-faces-only', `erc-track-exclude', and
	`erc-track-exclude-types' now work with server buffers.

2005-01-12  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (475): Prompt for the channel's key if
	`erc-prompt-for-channel-key' is non-nil.  Send a new JOIN message
	with the key if a key is provided.

	* erc.el (erc-command-indicator): Fixed customization choices so
	that there's no `mismatch' message when nil is the value.

2005-01-11  Michael Olson  <mwolson@gnu.org>

	* erc-bbdb.el (bbdb): Lowercase the name of the module.  This
	fixes a bug which caused an error to occur when trying to enable
	the module using the customization interface.

2005-01-08  Theresa O'Connor  <ted@oconnor.cx>

	* erc-track.el: Support using faces to indicate channel activity
	in the modeline under XEmacs.
	(erc-modified-channels-object): New function.
	(erc-modified-channels-display): Use it.
	`erc-modified-channels-string' renamed to
	`erc-modified-channels-object' (because it's no longer a string on
	XEmacs). The new function `erc-modified-channels-object' is used
	to generate updated values for the same-named variable.

2005-01-08  Diane Murray  <disumu@x3y2z1.net>

	* ChangeLog.2002: Changed instances of my sourceforge username and
	email address to real name and email.

	* erc.el (erc-modules): Changed customization tag descriptions, so
	that they all start with a verb; added new modules to choices.

2005-01-08  Mario Lang  <mlang@delysid.org>

	* debian/rules: Introduce new variable DOCDIR to simplify stuff a
	bit.

2005-01-08  Michael Olson  <mwolson@gnu.org>

	* AUTHORS, ChangeLog.2004: Change bpalmer's email address as
	requested.

	* CREDITS: Add everyone who is mentioned in the ChangeLogs.

	* debian/copyright (Copyright): Add last few people.  This can now
	be considered a complete list, as far as CVS entries are
	concerned.  If people have assigned copyright to the FSF, merge
	them with the entry for the FSF.

	* debian/README.Debian: Add entry for XEmacs-related change in
	`erc-track.el'.

	* erc.el (erc-cmd-MODE): New command that changes or displays the
	mode for a channel or user.  The functionality was present before
	this change, but there was no documentation for it.

	* erc-auto.in, erc-*.el: Fully investigate copyright headers and
	change them appropriately.  If a file has been pulled off of
	erc.el at one time, keep track of copyright from the time of
	separation, but not before.  If a file has been derived from a
	work outside of erc, keep copyright statements in place.

	* Makefile (VERSION): Change to 5.0! :^) Congrats on all the great
	work.  I'll wait until hober commits his XEmacs compatibility
	patch to erc-track.el, and then release.
	(distclean): Alias for `realclean' target.

2005-01-07  Michael Olson  <mwolson@gnu.org>

	* AUTHORS: Add Marcelo Toledo, who has CVS access to this project.

	* ChangeLog.2004: Add my name to my one contribution to erc last
	year.

	* CREDITS: Add people that were discovered while scouring
	ChangeLogs.

	* debian/copyright: Add everyone from `AUTHORS' to Upstream
	Authors.  Anyone who has contributed 15 or more lines of
	code (according to ChangeLogs) is listed in Copyright section.
	Accurate years are included.

	* debian/README.Debian: Paste content of NEWS and reformat
	slightly.

	* debian/rules: Concatenate the ChangeLogs during the Debian
	install process and then gzip them.

	* Makefile (MISC): Add ChangeLog.yyyy files to list.
	(ChangeLog): Remove rule since we do not dynamically generate the
	ChangeLog anymore.

	* MkChangeLog: Removed since we do not use it to generate the
	ChangeLog anymore.  cvs2cl does a much better job anyway.

	* NEWS: Use 3rd level heading instead of bullets for lists that
	contain descriptions.

2005-01-07  Diane Murray  <disumu@x3y2z1.net>

	* erc-list.el: Require 'sort.
	(erc-chanlist): Disable undo in the channel list buffer.

	* erc.el, erc-menu.el: The `IRC' menu is now automatically added
	to the menu-bar.  Add the call to `easy-menu-add' to
	`erc-mode-hook' when running in XEmacs (without this the menu
	doesn't appear).

	* NEWS: Added the information from
	https://emacswiki.org/cgi-bin/wiki/ErcCvsFeatures and the newer
	changes which weren't yet documented on that page.

2005-01-06  Hoan Ton-That  <hoan@ton-that.org>

	* erc-log.el (erc-current-logfile): Only downcase the logfile
	name, not the whole filename.  Also expand relative to
	`erc-log-channels-directory'.
	(erc-generate-log-file-name-with-date)
	(erc-generate-log-file-name-short)
	(erc-generate-log-file-name-long): Don't expand filename, done in
	`erc-current-logfile'.

2005-01-06  Lawrence Mitchell  <wence@gmx.li>

	* NEWS: New file, details user visible changes from version to
	version.

	* HACKING (NEWS entries): Mention NEWS file, and what its purpose
	is.

2005-01-05  Michael Olson  <mwolson@gnu.org>

	* FOR-RELEASE: New file containing the list of release-critical
	tasks.  Feel free to add to it.

	* debian/rules (binary-erc): Add ChangeLog files.

2005-01-04  Michael Olson  <mwolson@gnu.org>

	* ChangeLog.2001, ChangeLog.2002, ChangeLog.2003, ChangeLog.2004:
	ChangeLog entries from previous years.

	* ChangeLog: New file containing ChangeLog entries for the current
	year.  Please update this file manually whenever a change is
	committed.  This is a new policy.

	* AUTHORS: Add myself to list.  Some entries were space-delimited
	instead of TAB-delimited, and since the latter seemed to be the
	default, make the other entries conform.

	* HACKING (ChangeLog Entries): Update section to reflect new
	policy toward ChangeLog entries, which is that they should be
	manually updated whenever a change is committed.

2005-01-04  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-connection-established, erc-login): Update the
	mode-line.
	(erc-update-mode-line-buffer): If `erc-current-nick' returns nil,
	use an empty string for ?n character in format spec.  Set
	`mode-line-process' to ":connecting" while the connection is being
	established.

2005-01-04  Lawrence Mitchell  <wence@gmx.li>

	* AUTHORS: Update list of authors.

2005-01-02  Diane Murray  <disumu@x3y2z1.net>

	* erc-goodies.el (erc-control-characters): New customization
	group.
	(erc-interpret-controls-p): Small fix, addition to
	documentation. Updated customization to allow 'remove as a value.
	Use 'erc-control-characters as `:group'.
	(erc-interpret-mirc-color): Use 'erc-control-characters as
	`:group'.
	(erc-beep-p): Updated documentation.  Use 'erc-control-characters
	as `:group'.
	(define-erc-module irccontrols): Add `erc-controls-highlight' to
	`erc-insert-modify-hook' and `erc-send-modify-hook' since it
	changes the text's appearance.
	(erc-controls-remove-regexp, erc-controls-interpret-regexp): New
	variables.
	(erc-controls-highlight): Fixed so that highlighting works even if
	there is no following control character.  Fixed mirc color
	highlighting; now respecting `erc-interpret-mirc-color'.  Fixed a
	bug where emacs would get stuck in a loop when \C-g was in a
	message and `erc-beep-p' was set to nil (default setting).

2004-12-29  Francis Litterio  <franl@users.sourceforge.net>

	* erc-goodies.el (erc-interpret-controls-p): Changed docstring to
	reflect the new meaning if this is set to 'remove.
	(erc-controls-interpret): Rephrased docstring to be more accurate.
	(erc-controls-strip): New function that behaves like the
	recently-removed erc-strip-controls -- it removes all IRC color
	and highlighting control characters.
	(erc-controls-highlight): Changed to support the new 'remove value
	that variable erc-interpret-controls-p might have.

2004-12-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc-ibuffer.el, erc-list.el, erc-page.el, erc-speedbar.el:
	Changed all calls to erc-interpret-controls (which no longer
	exists) to call erc-controls-interpret (the new name of the same
	function).

2004-12-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc-goodies.el (erc-controls-interpret): Added this function to
	replace the recently-removed erc-interpret-controls.  Also added
	a (require 'erc) to solve a byte-compile problem.

2004-12-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-controls-interpret): Added this function to replace
	the recently-removed erc-interpret-controls.

2004-12-27  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-truncate.el (erc-truncate-buffer-to-size): Check for
	logging even better (via lawrence).

2004-12-26  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-truncate.el (erc-truncate-buffer-to-size): Much saner
	logging detection (via lawrence).

2004-12-25  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-goodies.el (erc-controls-highlight): Treat single C-c
	correctly.

2004-12-24  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-goodies.el, erc.el: Deleted IRC control character processing
	and implemented a sane version in erc-goodies.el as a module.

	* erc.el (erc-merge-controls, erc-interpret-controls,
	erc-decode-controls, erc-strip-controls, erc-make-property-list,
	erc-prepend-properties): Removed.

	(erc-interpret-controls-p, erc-interpret-mirc-color, erc-bold-face
	erc-inverse-face, erc-underline-face, fg:erc-color-face0,
	fg:erc-color-face1, fg:erc-color-face2, fg:erc-color-face3,
	fg:erc-color-face4, fg:erc-color-face5, fg:erc-color-face6,
	fg:erc-color-face7, fg:erc-color-face8, fg:erc-color-face9,
	fg:erc-color-face10, fg:erc-color-face11, fg:erc-color-face2,
	fg:erc-color-face13, fg:erc-color-face14, fg:erc-color-face15,
	bg:erc-color-face1, bg:erc-color-face2, bg:erc-color-face3,
	bg:erc-color-face4, bg:erc-color-face5, bg:erc-color-face6,
	bg:erc-color-face7, bg:erc-color-face8, bg:erc-color-face9,
	bg:erc-color-face10, bg:erc-color-face11, bg:erc-color-face2,
	bg:erc-color-face13, bg:erc-color-face14, bg:erc-color-face15,
	erc-get-bg-color-face, erc-get-fg-color-face,
	erc-toggle-interpret-controls): Moved.

	* erc-goodies.el (erc-beep-p, irccontrols, erc-controls-highlight,
	erc-controls-propertize): New.

2004-12-24  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-goodies.el, erc.el: The Small Extraction of Stuff[tm] commit.
	Moved some functions from erc.el to erc-goodies.el, and
	transformed them to erc modules in the process.
	- imenu autoload stuff moved.  I don't know why it is here at all.
	- Moved: scroll-to-bottom, make-read-only, distinguish-noncommands,
	smiley, unmorse, erc-occur (the last isn't a module, but still
	moved)
	(erc-input-line-position, erc-add-scroll-to-bottom,
	erc-scroll-to-bottom, erc-make-read-only, erc-noncommands-list,
	erc-send-distinguish-noncommands, erc-smiley, erc-unmorse,
	erc-occur): Moved from erc.el to erc-goodies.el.
	(smiley): Module moved from erc.el to erc-goodies.el.
	(scrolltobottom, readonly, noncommands, unmorse): New modules.

2004-12-20  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-format-away-status): Use `a', not `away' - that's
	why it's there.
	(erc-update-mode-line-buffer): The values of `mode-line-process'
	and `mode-line-buffer-identification' are normally lists.
	Conform.

2004-12-18  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-process-ctcp-query, erc-process-ctcp-reply): Display
	message in the active window, not the server window.

2004-12-16  Theresa O'Connor  <ted@oconnor.cx>

	* erc-track.el (erc-track-position-in-mode-line): Check for
	'erc-track-mode variable with boundp.  From Adrian Aichner
	<adrian@xemacs.org>.

2004-12-16  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-upcase-first-word): New function.  The old way used
	in erc-send-ctcp-message would eat consecutive whitespace etc.
	(erc-send-ctcp-message, erc-send-ctcp-notice): Use it.

2004-12-15  Theresa O'Connor  <ted@oconnor.cx>

	* erc.el (erc-send-ctcp-message): Fix braino with my previous
	patch.  It always helps to C-x C-s before `cvs commit'.

2004-12-15  Theresa O'Connor  <ted@oconnor.cx>

	* erc.el (erc-send-ctcp-message): Only upcase the ctcp command,
	and not the entire message.  Brian Palmer's change of 2004-12-12 had broken /me.
	Shouting is bad! :)

2004-12-14  Diane Murray  <disumu@x3y2z1.net>

	* erc-nets.el (erc-networks-alist): Change undernet to Undernet as
	is used in `erc-server-alist', so that completion works when using
	`erc-server-select'.  This should fix Debian bug #282003 (erc:
	cannot connect to Undernet).

2004-12-14  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (def-edebug-spec): Only run this if 'edebug is
	available.

2004-12-14  Diane Murray  <disumu@x3y2z1.net>

	* erc.el: The last change to `erc-mode-line-format' introduced a
	bug in XEmacs - it can't handle the #(" "...) strings at all.  The
	following changes fix the bug and simplify the mode-line handling
	considerably.  (erc-mode-line-format): Now defined as a string
	which will be formatted using `format-spec' and take the place of
	`mode-line-buffer-identification' in the mode line.
	(erc-header-line-format): Now defined as a string to be formatted
	using `format-spec'.
	(erc-prepare-mode-line-format): Removed.
	(erc-format-target, erc-format-target-and/or-server,
	erc-format-away-status, erc-format-channel-modes): New functions.
	Basically the old `erc-prepare-mode-line-format' split apart.
	(erc-update-mode-line-buffer): Set
	`mode-line-buffer-identification' to the formatted
	`erc-mode-line-format', set `mode-line-process' to ": CLOSED" if
	the connection has been terminated, and set `header-line-format'
	(if it is bound) to the formatted `erc-header-line-format', then
	do a `force-mode-line-update'.

2004-12-12  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-modules): Disable modules removed with `customize'.
	(erc-update-modules): Try to give a more descriptive error
	message.

2004-12-12  Diane Murray  <disumu@x3y2z1.net>

	* erc-complete.el, erc.el, erc-list.el, erc-nets.el,
	* erc-nicklist.el, erc-pcomplete.el, erc-replace.el, erc-speak.el,
	* erc-truncate.el (erc-buffers, erc-coding-systems, erc-display,
	erc-mode-line-and-header, erc-ignore, erc-query,
	erc-quit-and-part, erc-paranoia, erc-scripts, erc-old-complete,
	erc-list, erc-networks, erc-nicklist, erc-pcomplete, erc-replace,
	erc-truncate): New customization groups.
	(erc-join-buffer, erc-frame-alist, erc-frame-dedicated-flag,
	erc-reuse-buffers): Use 'erc-buffers as `:group'.
	(erc-default-coding-system, erc-encoding-coding-alist):
	Use 'erc-coding-systems as `:group'.
	(erc-hide-prompt, erc-show-my-nick, erc-prompt,
	erc-input-line-position, erc-command-indicator, erc-notice-prefix,
	erc-notice-highlight-type, erc-interpret-controls-p,
	erc-interpret-mirc-color, erc-minibuffer-notice,
	erc-format-nick-function): Use 'erc-display as `:group'.
	(erc-mode-line-format, erc-header-line-format,
	erc-header-line-uses-help-echo-p, erc-common-server-suffixes,
	erc-mode-line-away-status-format): Use 'erc-mode-line-and-header
	as `:group'.
	(erc-hide-list, erc-ignore-list, erc-ignore-reply-list,
	erc-minibuffer-ignored): Use 'erc-ignore as `:group'.
	(erc-auto-query, erc-query-on-unjoined-chan-privmsg,
	erc-format-query-as-channel-p): Use 'erc-query as `:group'.
	(erc-kill-buffer-on-part, erc-kill-queries-on-quit,
	erc-kill-server-buffer-on-quit, erc-quit-reason-various-alist,
	erc-part-reason-various-alist, erc-quit-reason, erc-part-reason):
	Use 'erc-quit-and-part as `:group'.
	(erc-verbose-server-ping, erc-paranoid, erc-disable-ctcp-replies,
	erc-anonymous-login, erc-show-channel-key-p): Use 'erc-paranoia as
	`:group'.
	(erc-startup-file-list, erc-script-path, erc-script-echo): Use
	'erc-scripts as `:group'.
	(erc-nick-completion, erc-nick-completion-ignore-case,
	erc-nick-completion-postfix): Use 'erc-old-complete as `:group'.
	(erc-chanlist-progress-message, erc-no-list-networks,
	erc-chanlist-frame-parameters, erc-chanlist-hide-modeline,
	erc-chanlist-mode-hook): Use 'erc-list as `:group'.
	(erc-server-alist, erc-networks-alist): Use 'erc-networks as
	`:group'.
	(erc-settings): Use `defvar' instead of `defcustom' since this is
	only a draft which doesn't work.
	(erc-nicklist-window-size): Use 'erc-nicklist as `:group'.
	(erc-pcomplete-nick-postfix,
	erc-pcomplete-order-nickname-completions): Use 'erc-pcomplete as
	`:group'.
	(erc-replace-alist): Use 'erc-replace as `:group'.
	(erc-speak-filter-timestamp): Use 'erc-speak as `:group'.
	(erc-max-buffer-size): Use 'erc-truncate as `:group'.

2004-12-12  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-scroll-to-bottom): Go to the end of the buffer
	before recentering.  This allows editing multiple lines more
	conveniently in CVS Emacs.  This also undos a change by antifuchs
	who said this goto-char would mess up redisplay.  Extensive testing
	couldn't reproduce that problem.

2004-12-12  Brian Palmer  <bpalmer@gmail.com>

	* erc.el (erc-send-ctcp-message): upcase the ctcp message (so that
	version becomes VERSION, for example).
	(erc-iswitchb): Make the argument optional in non-interactive
	invocation, so erc-iswitchb can be substituted directly for
	iswitchb in code.

2004-12-11  Diane Murray  <disumu@x3y2z1.net>

	* erc-track.el (erc-track-position-in-mode-line): Allow for the
	fact that `erc-track-mode' isn't bound when file is loaded.

2004-12-11  Diane Murray  <disumu@x3y2z1.net>

	* erc-track.el (erc-track-position-in-mode-line): New customizable
	variable.  (erc-track-remove-from-mode-line): New function.
	Remove `erc-modified-channels-string' from the mode-line.
	(erc-track-add-to-mode-line): New function.  Add
	`erc-modified-channels-string' to the mode-line using the value of
	`erc-track-position-in-mode-line' to determine whether to add it
	to the beginning or the end of `mode-line-modes' (only available
	with GNU Emacs versions above 21.3) or to the end of
	`global-mode-string'.
	(erc-track-mode, erc-track-when-inactive-mode): Use the new
	functions.

2004-12-11  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-cmd-BANLIST): Use (buffer-name) and not
	(erc-default-target) for the buffer name - buffer names are case
	sensitive.

2004-12-11  Brian Palmer  <bpalmer@gmail.com>

	* erc.el (erc-message-type): Added the message "MODE" to the known
	erc-message-type widget, so that (for example) people can tell
	erc-track-exclude-types to ignore mode changes.  The others tag
	also needed to be made an inline list, so that it's merged with
	the given constants, instead of being inserted as a list.

2004-12-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-track.el, erc.el: Update to get ERC look nicely in CVS Emacs.

	* erc.el (erc-mode-line-format): When on CVS emacs, use the new
	format.

	* erc-track.el (track module): When on CVS emacs, modify
	mode-line-modes instead of global-mode-string.  The latter is way
	to far too the right.

2004-11-18  Mario Lang  <mlang@delysid.org>

	* Makefile, debian/changelog: debian release 20041118-1

2004-11-03  Diane Murray  <disumu@x3y2z1.net>

	* erc-button.el (erc-button-buttonize-nicks): Set default value to
	`t'.  Updated documentation and customization `:type' to reflect
	usage.

2004-10-29  Johan Bockgård  <bojohan@users.sourceforge.net>

	* AUTHORS: Added self.

2004-10-17  Diane Murray  <disumu@x3y2z1.net>

	* erc-list.el: Added local variables for this file.
	(erc-list-version): New.
	(erc-cmd-LIST): Take &rest rather than &optional arguments, as was
	done in revision 1.21.  Allow for input when called interactively.
	(erc-prettify-channel-list, erc-chanlist-toggle-sort-state): Use
	`unless' instead of when not.

2004-10-17  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (erc-handle-unknown-server-response): Fixed so
	that the contents are only shown once.
	(MOTD): Display lines in the server buffer if it's the first MOTD
	sent upon connection.  This is to avoid the problem of having the
	MOTD of one server showing up in another server's buffer if it took
	a while to get connected.
	(004): Fixed to show the user modes and channel modes correctly.
	(303): Now displays the nicknames returned by ISON instead of the
	user's nickname.
	(367, 368): Moved up into 300's section of the code.  Added
	documentation.  Use `multiple-value-bind' to set variables in 367.
	(391): Fixed so that the server name is shown correctly.

2004-10-17  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-process-sentinel): Use CPROC instead of
	`erc-process' in debug message.  Should fix a bug where an error
	saying "Buffer *scratch* has no process" would occur when
	disconnected.
	(erc-cmd-SV): Check for X toolkit after checking for more specific
	features.  (erc--kill-server): Set `quitting' to non-nil so that
	we don't automatically reconnect.

2004-10-05  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-ignored-user-p): Don't require regexes to match the
	beginning.

2004-09-11  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el: group erc: Moved to 'applications (patch by bojohan)

2004-09-08  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-button.el (erc-button-remove-old-buttons): Remove 'keymap
	not 'local-map.

2004-09-03  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-backend.el: JOIN response handler: Typo fix of the last
	commit.

2004-09-03  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-backend.el: JOIN response handler: Run `erc-join-hook'
	without arguments as specified in the docstring.

2004-08-27  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-send-current-line): Removed unused variable SENTP.

2004-08-19  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el: ERC-SEND-COMPLETED-HOOK used to be run when the prompt
	was already displayed.  We restore this behavior (thanks to bojohan
	and TerryP for noticing).  We also fix the docstring of
	ERC-SEND-COMPLETED-HOOK, since the hook is (and used to be) called
	even if nothing was sent to the server.
	(erc-send-completed-hook): Fixed docstring.
	(erc-send-current-line): Add incantation for
	erc-send-completed-hook.
	(erc-send-input): Remove incantation for erc-send-completed-hook.

2004-08-18  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-backend.el: response-handler 368: Use s368, not s367.

2004-08-17  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-scroll-to-bottom): Don't scroll when we're not
	connected anymore.

2004-08-17  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-backend.el, erc.el: Handle /mode #emacs b output without
	errors and such.  First, handle unknown format specs gracefully
	(that is, give a useful error).  Then, provide handlers for the
	banlist replies.

	* erc-backend.el: New handler for 367 and 368.  Removed from default
	handler.

	* erc.el: Provide english catalog for s367 and s368.
	(erc-format-message): Give an error message when we don't find an
	entry.

2004-08-17  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-fill.el: erc-fill-variable could be confused about really
	long nicks.  We put an upper limit on the length of the fill prefix.
	(erc-fill-variable): Adjust fill-prefix.
	erc-fill-variable-maximum-indentation: New variable.

2004-08-17  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-send-input): Fixed a bug where this function
	referenced variable "input" instead of variable "str".

2004-08-16  Francis Litterio  <franl@users.sourceforge.net>

	* erc-list.el (erc-chanlist-highlight-line): Fixed a bug where
	this function failed to set the correct face for highlighting the
	current line.

2004-08-14  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-fill.el (erc-fill-variable): Don't fuck up when the
	looking-at didn't work.

2004-08-14  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-send-single-line): Call the hooks to change the
	appearance for something only if we actually inserted something,
	doh.
	(erc-display-command): Display the prompt outside of the area that
	set the text properties on.

2004-08-14  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el: Refactored erc-send-current-line.  This should fix some
	dormant bugs, and make the whole thing actually readable.  Yay.
	Some changes in behavior were made.  Whitespace at the end of lines
	sent is not removed anymore, but that shouldn't bother anyone.
	Additionally, errors in commands or hooks shouldn't prevent the
	prompt from showing up again now.
	(erc-parse-current-line): Removed.
	(erc-send-current-line): Refactored.
	(erc-send-input): New function.
	(erc-send-single-line): New function.
	(erc-display-command): New function.
	(erc-display-msg): New function.
	(erc-user-input): New function.

2004-08-13  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-cmd-SERVER): Use newer keyword call interface to
	erc-select, and handle the error if it can't resolve the host.

2004-08-11  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-backend.el, erc.el: erc-backend.el (404 response handler):
	New function.  We now support "cannot send to channel".

	* erc.el (erc-define-catalog call): Added s404.
	(erc-ctcp-ECHO-reply, erc-ctcp-CLIENTINFO-reply,
	erc-ctcp-FINGER-reply, erc-ctcp-PING-reply, erc-ctcp-TIME-reply,
	erc-ctcp-VERSION-reply): Display reply in the active window, not
	the server window.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-with-all-buffers-of-server): Actually make it left
	to right, doh.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-with-all-buffers-of-server): Evaluate left-to-right
	so we don't surprise a user.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-process-input-line): Parentophobia! Another
	paren-fix.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-backend.el: PRIVMSG NOTICE response handler: Killed one paren
	too much.  Poor paren.  Got resurrected.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-track.el: Make server buffers showing up in the mode line
	optional.  Thanks to Daniel Knapp on the EmacsWiki for this patch.

	erc-track-exclude-server-buffer: New variable.
	(erc-track-modified-channels): Return a server buffer only if
	erc-track-exclude-server-buffer is nil.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-cmd-DESCRIBE): Don't parse arguments.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-truncate.el (erc-truncate-buffer-to-size): Use
	erc-insert-marker, not (point-max), to decide the length of the
	buffer.  A long input line shouldn't make the buffer smaller.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-macs.el, erc-members.el: The change to hashes for channel
	members has been made some time ago.  Clean up the various tries to
	do this in the past.

	* erc-macs.el, erc-members.el: Removed.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-backend.el, erc-ibuffer.el, erc-members.el, erc.el: Nothing
	big changed here.  Really.  Uhm, maybe the info-buffers are gone or
	so.  Can't really remember.  Don't worry, nothing important is
	missing.

	erc-speedbar.el looks nice btw, did you know?

	Adjusted various places in erc.el, erc-backend.el, erc-ibuffer.el
	and erc-members.el - too numerous to list here, sorry.

	* erc.el: erc-use-info-buffers: Removed.  erc-info-mode-map:
	Removed.
	(erc-info-mode): Removed.
	(erc-find-channel-info-buffer): Removed.
	(erc-update-channel-info-buffer): Removed.
	(erc-update-channel-info-buffers): Removed.

	* erc-members.el: erc-update-member renamed to
	erc-update-channel-member for better clarity.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el: This change improves the help output on a bogus command
	invocation.  We display the command as it would be typed by the
	user, not as it is seen by Emacs.

	(erc-get-arglist): Is now called erc-function-arglist, and returns
	now an arglist without the enclosing parens.
	(erc-command-name): New function.
	(erc-process-input-line): Pass the command name, not the function
	name.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-process-input-line): Fix bug when the command
	doesn't have an arglist or no documentation.  Thanks bojohan again
	:)

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-match.el (erc-add-entry-to-list),
	(erc-remove-entry-from-list): Update docstring, a TEST argument is
	not given.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-with-buffer): Really fix this docstring.

2004-08-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-with-buffer): Fix double evaluation in macro, and
	fix docstring.

2004-08-10  Brian Palmer  <bpalmer@gmail.com>

	* erc.el (erc-cmd-JOIN): Use erc-member-ignore-case instead of
	member-ignore-case.

2004-08-09  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-backend.el: Define an "Edebug specification" for the
	`define-erc-response-handler' macro.  This means that one can step
	through response handlers defined by this macro with edebug.  Maybe
	more macros would benefit from this?

2004-08-09  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-pcomplete.el (pcomplete/erc-mode/CTCP): New function.
	Completion for the /CTCP command.  (erc-pcomplete-ctcp-commands):
	New variable.  List of ctcp commands.

2004-08-09  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-list.el: Clean up docstrings.
	(erc-prettify-channel-list): Extend properties to cover the entire
	line, including the newline, to make it look
	better.
	(erc-chanlist-highlight-line): Ditto.
	(erc-chanlist-mode-hook): Make it a defcustom.

2004-08-09  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-compute-full-name): Typo fix, should be full-name,
	not name.

2004-08-09  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc): Setup the buffer to be shown in a window at the
	end of this function.  This enables 'window-noselect to work
	properly.
	(erc, erc-send-current-line): Fix some
	goto-char/open-line/goto-char to goto-char/insert.

2004-08-08  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-parse-user): Live with bogus info from bouncers.

2004-07-31  Brian Palmer  <bpalmer@gmail.com>

	* erc.el (erc-select): Change the docstring to reflect the new
	arguments; include the arguments in the docstring for non-cvs
	emacs.  Change the parameters to call erc-compute-* instead of
	using the erc-* variables directly.
	(erc-compute-server): Made argument optional.
	(erc-compute-nick): ditto.
	(erc-compute-full-name): ditto.  (erc-compute-port): ditto.

2004-07-30  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-cmd-BANLIST): Fixed a bug where channel-banlist was
	not reset to nil before fetching an updated banlist from the
	server.

2004-07-30  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-cmd-BANLIST): Fixed a bug where the
	'received-from-server property on variable channel-banlist was not
	being reset to nil.  This fixes the symptom where one types
	/BANLIST and sees "No bans for channel: #whatever" when you know
	there are bans.

2004-07-23  Brian Palmer  <bpalmer@gmail.com>

	* erc.el (erc-select-read-args): Use erc-compute-nick to
	calculate the default nickname

2004-07-20  Brian Palmer  <bpalmer@gmail.com>

	* erc.el (erc-process-sentinel-1): New function.  This is an
	auxiliary function refactored out of erc-process-sentinel to
	decide a server buffer's fate (whether it should be killed, and
	whether erc should attempt to auto-reconnect).  Michael Olson
	<mwolson@gnu.org> helped with this.
	(erc-kill-server-buffer-on-quit): New variable.  Used in
	erc-process-sentinel-1 to decide whether to kill a server buffer
	when the user quit normally.
	(erc-process-sentinel): Auxiliary function erc-process-sentinel-1
	split out.  The function body has `with-current-buffer' wrapped
	around it, to ensure separation of messages if multiple
	connections were being made.  Use `if' instead of `cond' in places
	where the decision is binary.  The last (useless, since the server
	connection is closed) prompt in the server buffer is removed.
	Color "erc terminated" and "erc finished" messages with
	erc-error-face.  Mark the buffer unmodified so that, if not killed
	automatically, the user is not prompted to save it.

2004-07-16  Brian Palmer  <bpalmer@gmail.com>

	* erc.el (erc-select-read-args): New function.  Prompts the user
	for arguments to pass to erc-select and erc-select-ssl.
	(erc-select): Use (erc-select-read-args) when called interactively
	to get its arguments.  When non-interactively, use keyword
	arguments.
	(erc-select-ssl): Ditto.
	(erc-compute-port): New function.  Parallel to erc-compute-server,
	but comes up with a default value for an IRC server's port.

2004-07-16  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-match.el (erc-match-message): Quote the current nickname.

2004-07-12  Brian Palmer  <bpalmer@gmail.com>

	* erc-list.el (erc-chanlist-mode): Remove explicit invocation of
	erc-chanlist-mode-hook, since it's automatically invoked by
	define-derived-mode

2004-07-03  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-match.el (erc-match-current-nick-p): Quote current nick for
	regexp parsing.

2004-06-27  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-nickserv.el (erc-nickserv-identify-mode): Fix erroneous
	parentheses in call to `completing-read'.

2004-06-23  Alex Schroeder  <alex@gnu.org>

	* Makefile (release): Depend on autoloads, and copy erc-auto.el
	into the tarball.

2004-06-14  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-log-irc-protocol): Fixed minor bug where each line
	received from a server was logged as two lines (one with text and
	one blank).

2004-06-08  Brian Palmer  <bpalmer@gmail.com>

	* erc-list.el (erc-chanlist-frame-parameters): Made customizable.
	(erc-chanlist-header-face): Changed to use defface with some
	reasonable defaults instead of make-face, and removed the
	associated -face variable.
	(erc-chanlist-odd-line-face): Ditto.
	(erc-chanlist-even-line-face): Ditto.
	(erc-chanlist-highlight-face): New variable.  Holds a face used for
	highlighting the current line.
	(erc-cmd-LIST): Use erc-member-ignore-case instead of
	member-ignore-case.
	(erc-chanlist-post-command-hook): Change to move the highlight
	overlay instead of refontifying the entire buffer.
	(erc-chanlist-dehighlight-line): Added to detach the highlight
	overlay from the buffer.

2004-05-31  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el: erc-mode-line-format: Add column numbers.

2004-05-31  Adrian Aichner  <adrian@xemacs.org>

	* erc-autojoin.el: Typo fix.

	* erc-dcc.el (erc-dcc-do-GET-command): Use expand-file-name.
	(erc-dcc-get-file): XEmacs set-buffer-multibyte compatibility.

	* erc-log.el: Append `erc-log-setup-logging' to
	`erc-connect-pre-hook' so that `erc-initialize-log-marker' is run
	first (markers are needed by `erc-log-setup-logging').
	(erc-enable-logging): Docstring fix.
	(erc-log-setup-logging): Move `erc-log-insert-log-on-open' to (1-
	(point-max)) when doing `erc-log-insert-log-on-open'.  Modified
	version of a patch by Lawrence Mitchell.
	(erc-log-all-but-server-buffers): Do `save-excursion' as well.
	(erc-current-logfile): Pass buffer name as target
	argument to `erc-generate-log-file-name-function' if
	`erc-default-target' is nil.
	(erc-generate-log-file-name-with-date): Use expand-file-name.
	(erc-generate-log-file-name-short): Ditto.
	(erc-save-buffer-in-logs): Do `save-excursion' and test whether
	erc-last-saved-position is a marker.

	* erc-members.el: Avoid miscompiling macro `erc-log' and
	`with-erc-channel-buffer' by requiring 'erc at compile time.

	* erc-sound.el: Use expand-file-name.

	* erc.el (erc-debug-log-file): Ditto.
	(erc-find-file): Ditto.

2004-05-26  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el, erc-backend.el (erc-cmd-BANLIST): Added a missing "'"
	that was preventing /BANLIST from working.  In erc-backend.el,
	added server response handler for 367 and 368 responses to get
	/BANLIST working.

2004-05-26  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el: Removed an eval-when-compile that was preventing the
	byte-compiled version of this file from loading.

2004-05-26  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el: Undid part of my last change.  I suspect it was wrong.

2004-05-26  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el: Silenced several byte-compiler warnings.

2004-05-26  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-log-irc-protocol): Fixed problem where this function
	misformatted IRC protocol text if multiple lines were received from
	the server at one time.

2004-05-25  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-toggle-debug-irc-protocol): Cosmetic changes to the
	informational text in the *erc-protocol* buffer.

2004-05-24  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-log-irc-protocol, erc-process-filter): Now the lines
	inserted in the *erc-protocol* buffer are prefixed with the name
	of the network to/from which the data is going/coming.  This makes
	reading the *erc-protocol* buffer much easier when connected to
	multiple networks.

2004-05-23  Jeremy Bertram Maitin-Shepard  <jbms@gentoo.org>

	* erc-backend.el: Fixes server message parsing so that command
	arguments specified after the colon are not treated specially.  All
	arguments are added to the `command-args' field, and the
	`contents' points to the last element in the `command-args' list.
	This allows ERC to connect to networks such as Undernet.  Although
	keeping `contents' allows many of the response handlers to
	continue to work as-is, many other are probably broken by this
	patch.

2004-05-20  Lawrence Mitchell  <wence@gmx.li>

	* HACKING: Add comment that C-c C-a can be useful if you write
	ChangeLog entries using Emacs' standard functions.

2004-05-17  Diane Murray  <disumu@x3y2z1.net>

	* erc-speedbar.el: Ignore errors when attempting to require dframe
	(there are a couple implementations of speedbar, one of which uses
	of dframe).
	(erc-speedbar-version): New.
	(erc-speedbar-goto-buffer): Use dframe functions if dframe is
	available.

2004-05-17  Diane Murray  <disumu@x3y2z1.net>

	* erc-autojoin.el: Added local variables for this file.
	(erc-autojoin-add): The channel name is in `erc-response.contents'.

2004-05-17  Mario Lang  <mlang@delysid.org>

	* erc-log.el: Don't autoload a define-key statement, erc-mode-map
	might not be known yet

2004-05-16  Lawrence Mitchell  <wence@gmx.li>

	* erc-backend.el (erc-parse-server-response): Revert to original
	`erc-parse-line-from-server' version, since new version breaks for
	a number of edge cases.

2004-05-14  Diane Murray  <disumu@x3y2z1.net>

	* erc-backend.el (erc-handle-unknown-server-response): New
	function.  Added to `erc-default-server-functions'.  Display
	unknown responses to the user.
	(221): Don't show nickname in modes list.
	(254): Fixed to use 's254.
	(303): Added docstring.
	(315, 318, 323, 369): Ignored responses grouped together.
	(391): New.
	(406, 432): Use ?n, not ?c in `erc-display-message'.
	(431, 445, 446, 451, 462, 463, 464, 465, 481, 483, 485, 491, 501,
	502): All error responses with no arguments grouped together.

2004-05-14  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-message-type-member): Use `erc-response.command'.
	`erc-track-exclude-types' should be respected again.
	(erc-cmd-TIME): Fixed to work with and without server given as
	argument.
	(erc-define-catalog): Added, s391, s431, s445, s446, s451, s462,
	s463, s464, s465, s483, s484, s485, s491, s501, s502.

2004-05-14  Lawrence Mitchell  <wence@gmx.li>

	* HACKING: Typo fix.

2004-05-14  Lawrence Mitchell  <wence@gmx.li>

	* Makefile (erc-auto.el): Pass -f flag to rm so that we don't fail
	if erc-auto.elc doesn't exist.

2004-05-14  Lawrence Mitchell  <wence@gmx.li>

	* erc-backend.el (erc-with-buffer): Autoload.
	(erc-parse-server-response): XEmacs' `replace-match' only replaces
	subexpressions when operating on buffers, not strings, work around
	it.
	(461): Command with invalid arguments is `second', not `third'.

2004-05-14  Diane Murray  <disumu@x3y2z1.net>

	* erc-notify.el (erc-notify-NICK): Use `erc-response.contents' to
	get nickname.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-track.el: Indentation fixes.
	(track-when-inactive): Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-notify.el (notify): Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.
	(erc-notify-timer, erc-notify-JOIN, erc-notify-NICK)
	(erc-notify-QUIT): Use new accessors for PARSED argument.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-nickserv.el (services, erc-nickserv-identify-mode): Use
	`erc-server-FOO-functions', not `erc-server-FOO-hook.
	(erc-nickserv-identify-autodetect): Use new accessors for PARSED
	argument.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-netsplit.el (netsplit): Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.
	(erc-netsplit-JOIN, erc-netsplit-MODE, erc-netsplit-QUIT): Use new
	accessors for PARSED argument.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-nets.el: Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-menu.el (erc-menu-definition): Only allow listing of
	channels if `erc-cmd-LIST' is fboundp.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-match.el: Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.
	(erc-get-parsed-vector-nick, erc-get-parsed-vector-type): Use new
	accessors for PARSED argument.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-list.el (erc-chanlist, erc-chanlist-322): Use new accessors
	for PARSED argument.  Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-ezbounce.el (erc-ezb-notice-autodetect): Use new accessors
	for PARSED argument.
	(erc-ezb-initialize): Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-dcc.el: Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.
	(erc-dcc-no-such-nick): Use new accessors for PARSED argument.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-bbdb.el (erc-bbdb-whois, erc-bbdb-JOIN, erc-bbdb-NICK): Use
	new accessors for PARSED argument.
	(BBDB): Use `erc-server-FOO-functions', not `erc-server-FOO-hook.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-autojoin.el (autojoin): Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.
	(erc-autojoin-add, erc-autojoin-remove): Use new accessors for
	PARSED argument.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-autoaway.el (autoaway): Use `erc-server-FOO-functions', not
	`erc-server-FOO-hook.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-backend): Require.
	(erc-disconnected-hook, erc-join-hook, erc-quit-hook)
	(erc-part-hook, erc-kick-hook): Docstring fix, we now use
	`erc-server-FOO-functions', rather than `erc-server-FOO-hook'.
	(erc-event-to-hook-name, erc-event-to-hook): Remove.
	(erc-once-with-server-event)
	(erc-once-with-server-event-global): Use `erc-get-hook'
	(erc-process-filter): Use `erc-parse-server-response'.
	(erc-cmd-IDLE, erc-cmd-BANLIST, erc-cmd-MASSUNBAN): New accessors
	for PARSED argument.  Rename all `erc-server-FOO-hook' to
	`erc-server-FOO-functions'.
	(erc-server-364-hook, erc-server-365-hook, erc-server-367-hook)
	(erc-server-368-hook, erc-server-KILL-hook)
	(erc-server-PONG-hook, erc-server-200-hook, erc-server-201-hook)
	(erc-server-202-hook, erc-server-203-hook, erc-server-204-hook)
	(erc-server-205-hook, erc-server-206-hook, erc-server-208-hook)
	(erc-server-209-hook, erc-server-211-hook, erc-server-212-hook)
	(erc-server-213-hook, erc-server-214-hook, erc-server-215-hook)
	(erc-server-216-hook, erc-server-217-hook, erc-server-218-hook)
	(erc-server-219-hook, erc-server-241-hook, erc-server-242-hook)
	(erc-server-243-hook, erc-server-244-hook, erc-server-249-hook)
	(erc-server-261-hook, erc-server-262-hook, erc-server-302-hook)
	(erc-server-323-hook, erc-server-342-hook, erc-server-351-hook)
	(erc-server-381-hook, erc-server-382-hook, erc-server-391-hook)
	(erc-server-392-hook, erc-server-393-hook, erc-server-394-hook)
	(erc-server-395-hook, erc-server-402-hook, erc-server-404-hook)
	(erc-server-407-hook, erc-server-409-hook, erc-server-411-hook)
	(erc-server-413-hook, erc-server-414-hook, erc-server-415-hook)
	(erc-server-422-hook, erc-server-423-hook, erc-server-424-hook)
	(erc-server-431-hook, erc-server-436-hook, erc-server-437-hook)
	(erc-server-441-hook, erc-server-443-hook, erc-server-444-hook)
	(erc-server-445-hook, erc-server-446-hook, erc-server-451-hook)
	(erc-server-462-hook, erc-server-463-hook, erc-server-464-hook)
	(erc-server-465-hook, erc-server-467-hook, erc-server-471-hook)
	(erc-server-472-hook, erc-server-473-hook, erc-server-483-hook)
	(erc-server-491-hook, erc-server-502-hook): Remove.
	(erc-call-hooks, erc-parse-line-from-server): Remove
	(erc-server-hook-list): Remove.  Remove top-level call too.
	(erc-server-ERROR, erc-server-INVITE, erc-server-JOIN)
	(erc-server-KICK, erc-server-MODE, erc-server-NICK)
	(erc-server-PART, erc-server-PING, erc-server-PONG)
	(erc-server-PRIVMSG-or-NOTICE, erc-server-QUIT)
	(erc-server-TOPIC, erc-server-WALLOPS, erc-server-001)
	(erc-server-004, erc-server-005, erc-server-221, erc-server-252)
	(erc-server-253, erc-server-254, erc-server-301, erc-server-303)
	(erc-server-305, erc-server-306, erc-server-311-or-314)
	(erc-server-312, erc-server-313, erc-server-317, erc-server-319)
	(erc-server-320, erc-server-321, erc-server-322, erc-server-324)
	(erc-server-329, erc-server-330, erc-server-331, erc-server-332)
	(erc-server-333, erc-server-341, erc-server-352, erc-server-353)
	(erc-server-366, erc-server-MOTD, erc-server-379)
	(erc-server-401, erc-server-403, erc-server-405, erc-server-406)
	(erc-server-412, erc-server-421, erc-server-432, erc-server-433)
	(erc-server-437, erc-server-442, erc-server-461, erc-server-474)
	(erc-server-475, erc-server-477, erc-server-481, erc-server-482)
	(erc-server-501): Move to erc-backend.el
	(erc-auto-query, erc-banlist-store, erc-banlist-finished)
	(erc-banlist-update, erc-connection-established)
	(erc-process-ctcp-query, erc-display-server-message): Use new
	accessors for PARSED argument.

2004-05-13  Lawrence Mitchell  <wence@gmx.li>

	* erc-backend.el (erc-parse-server-response)
	(erc-handle-parsed-server-response, erc-get-hook)
	(define-erc-response-handler): New functions.
	(erc-response): New struct for server responses.
	(erc-server-responses): New variable.
	(erc-call-hooks): Move from erc.el and rework.
	(ERROR, INVITE, JOIN, KICK, MODE, NICK, PART, PING, PONG)
	(PRIVMSG, NOTICE, QUIT, TOPIC, WALLOPS, 001, MOTD, 376, 004)
	(252, 253, 254, 250, 301, 303, 305, 306, 311, 312, 313, 315)
	(317, 318, 319, 320, 321, 322, 324, 329, 330, 331, 332, 333)
	(341, 352, 353, 366, 369, 379, 401, 403, 405, 406, 412, 421)
	(432, 433, 437, 442, 461, 474, 477, 481, 482, 501, 323, 221)
	(002, 003, 371, 372, 374, 375, 422, 251, 255, 256, 257, 258)
	(259, 265, 266, 377, 378, 314, 475, 364, 365, 367, 368, 381)
	(382, 391, 392, 393, 394, 395, 200, 201, 202, 203, 204, 205)
	(206, 208, 209, 211, 212, 213, 214, 215, 216, 217, 218, 219)
	(241, 242, 243, 244, 249, 261, 262, 302, 342, 351, 402, 404)
	(407, 409, 411, 413, 414, 415, 423, 424, 431, 436, 441, 443)
	(444, 445, 446, 451, 462, 463, 464, 465, 467, 471, 472, 473)
	(483, 491, 502, 005, KILL): Move from erc.el and rework using
	`define-erc-response-handler' and erc-response struct.

2004-05-12  Diane Murray  <disumu@x3y2z1.net>

	* erc.el: A few bug fixes to avoid errors after disconnect,
	including the "Selecting deleted buffer" bug.
	(erc-channel-user-op-p, erc-channel-user-voice-p): Make sure NICK
	is non-nil (`erc-current-nick' can return nil).
	(erc-server-buffer): Make sure the buffer isn't a #<killed
	buffer>.
	(erc-server-buffer-live-p): New function.
	(erc-display-line, erc-join-channel, erc-prepare-mode-line-format,
	erc-away-p): Use `erc-server-buffer-live-p' to make sure process
	buffer exists.
	(erc-send-current-line): If there is no server buffer, let the
	user know.

2004-05-12  Diane Murray  <disumu@x3y2z1.net>

	* erc.el, erc-log.el: C-c C-l keybinding now defined in
	erc-log.el.
	(erc-log-version): New.
	(erc-cmd-JOIN): Fix applied for bug where /join -invite causes
	errors when there's no `invitation'.

2004-05-11  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-cmd-JOIN): Make sure `chnl' is non-nil before trying
	to join anything (chnl is not set if /join -invite is used but
	there's no `invitation').

2004-05-10  Diane Murray  <disumu@x3y2z1.net>

	* erc-log.el: Define C-c C-l keybinding outside of `erc-log-mode',
	making it available all the time; autoload definition.
	(erc-log-version): New.

2004-05-09  Diane Murray  <disumu@x3y2z1.net>

	* AUTHORS, CREDITS, Makefile, erc-autoaway.el, erc-autojoin.el,
	erc-button.el, erc-chess.el, erc-dcc.el, erc-ezbounce.el,
	erc-fill.el, erc-ibuffer.el, erc-imenu.el, erc-lang.el,
	erc-list.el, erc-log.el, erc-macs.el, erc-match.el, erc-members.el,
	erc-menu.el, erc-nets.el, erc-netsplit.el, erc-nickserv.el,
	erc-notify.el, erc-page.el, erc-ring.el, erc-speak.el,
	erc-speedbar.el, erc-stamp.el, erc-track.el, erc-truncate.el,
	erc-xdcc.el, erc.el: Applied all relevant bug fixes and code
	cleanup made between the time of the ERC_4_0_RELEASE tag until now.

2004-05-09  Diane Murray  <disumu@x3y2z1.net>

	* erc-menu.el: Updated copyright years.

2004-05-09  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-update-channel-info-buffer): Correct bug in sorting
	of channel users.  Tiny change from Andreas Schwab
	<schwab@suse.de>.

2004-05-09  Lawrence Mitchell  <wence@gmx.li>

	* erc-fill.el (erc-fill-variable): Fix docstring.

2004-05-09  Lawrence Mitchell  <wence@gmx.li>

	* erc-button.el (erc-button-add-button): Use 'keymap
	text-property, rather than 'local-map, since it's cross-emacs
	compatible.  Pass :mouse-down-action into `widget-convert-button'
	as 'erc-button-click-button, to make XEmacs happy.  Replace bogus
	reference to erc-widget-press-button with erc-button-press-button.
	(erc-button-click-button): New (ignored) first argument, to make
	XEmacs behave when pressing buttons.
	(erc-button-press-button): New (ignored) &rest argument.

2004-05-09  Adrian Aichner  <adrian@xemacs.org>

	* erc-log.el (erc-conditional-save-buffer): Fix docstring
	reference to erc-save-queries-on-quit.
	(erc-conditional-save-queries): Ditto.

2004-05-06  Diane Murray  <disumu@x3y2z1.net>

	* erc-speedbar.el: Updated copyright years.  Added local variables
	for this file; fixed indenting.
	(erc-speedbar): New group.
	(erc-speedbar-sort-users-type): New variable.
	(erc-speedbar-buttons): Handle query buffers (fixes a bug where an
	error would be thrown if the current buffer was a query).  Ignore
	unknown buffers.
	(erc-speedbar-expand-channel): Show limit and key with channel
	modes.  Sort users according to `erc-speedbar-sort-users-type'.
	(erc-speedbar-insert-user): Fixed bug where only nicks with more
	info were being listed, and those were shown twice.
	(erc-speedbar-goto-buffer): Don't use dframe functions, as dframe
	isn't available with the default speedbar.

2004-05-06  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-sort-channel-users-alphabetically): New function.
	(erc-server-412, erc-server-432, erc-server-475): New functions.
	(erc-server-412-hook, erc-server-432-hook, erc-server-475-hook):
	Use them.
	(erc-server-401, erc-server-403, erc-server-405)
	(erc-server-421, erc-server-474, erc-server-481): Use catalog
	messages.
	(erc-define-catalog): Added s401, s403, s405, s412, s421, s432,
	s474, s475, and s481.

2004-05-06  Diane Murray  <disumu@x3y2z1.net>

	* erc-nickserv.el: Added documentation to Commentary, Usage.
	Removed `outline-mode' from file local variables.
	(erc-services-mode): Use `erc-nickserv-identify-mode' to add
	hooks.
	(erc-nickserv-identify-mode): New function.
	(erc-nickserv-identify-mode): New variable.
	(erc-prompt-for-nickserv-password, erc-nickserv-passwords):
	Changed docstring.
	(erc-nickserv-identify-autodetect): Use
	`erc-nickserv-call-identify-function'.  Docstring change.
	(erc-nickserv-identify-on-connect,
	erc-nickserv-identify-on-nick-change,
	erc-nickserv-call-identify-function): New functions.
	(erc-nickserv-identify): PASSWORD is not optional.  Autoload
	function.

2004-05-05  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-join-hook, erc-quit-hook, erc-part-hook,
	erc-kick-hook, erc-connect-pre-hook): Now customizable.
	(erc-nick-changed-functions): New hook.
	(erc-server-NICK): Run `erc-nick-changed-functions' with the
	arguments NEW-NICK and OLD-NICK.
	(erc-channel-user-voice-p, erc-channel-user-voice-p): Shortened
	docstring.

2004-05-05  Lawrence Mitchell  <wence@gmx.li>

	* HACKING: New section on function/variable naming and coding
	conventions.

2004-05-05  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-wash-quit-reason): Quote regexp special characters
	in NICK, LOGIN and HOST.

2004-05-04  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-server-parameters): Typo fix in docstring.
	(erc-input-line-position): `:type' is now a choice between integer
	and nil.  (erc-mode-map): Bind `erc-get-channel-mode-from-keypress'
	to C-c C-o instead of C-c RET (C-c C-m).  (erc-cmd-GQUIT): Use
	REASON as argument when calling `erc-cmd-QUIT'.

2004-05-03  Lawrence Mitchell  <wence@gmx.li>

	* erc-nicklist.el: Initial version.

2004-04-28  Diane Murray  <disumu@x3y2z1.net>

	* erc-menu.el: Added local variables for file, fixed indenting.
	(erc-menu-version): New variable.
	(erc-menu-definition): "List channels": New.  "Join channel": Use
	`erc-connected' as test.  "Start a query": New.  "List channel
	operators": New.  "Input action": Moved up.  "Set topic": Fixed
	test so it's only active in channels.  "Leave this channel": Moved
	down.  "Track hidden channel buffers": Removed.  "Enable/Disable
	ERC Modules": New.

2004-04-28  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-mode-map): Removed binding for
	`erc-save-buffer-in-logs' (moved to erc-log.el).
	(erc-cmd-QUERY, erc-cmd-OPS): Now interactive.

2004-04-28  Diane Murray  <disumu@x3y2z1.net>

	* erc-log.el: Added local variables for this file.
	(erc-log-channels-directory): Added directory as a choice in
	`:type'.
	(define-erc-module): Define and undefine key binding (C-c
	C-l) for `erc-save-buffer-in-logs' here.

2004-04-28  Diane Murray  <disumu@x3y2z1.net>

	* erc-nets.el: Added local variables for this file.
	(erc-networks-alist): Fixed `:type' to work better in
	customization.

2004-04-28  Diane Murray  <disumu@x3y2z1.net>

	* erc-match.el: Added local variables for file.  (erc-keywords):
	Use `list' instead of `cons' in `:type'.  Fixes bug where mismatch
	was shown in customization.  (erc-current-nick-highlight-type):
	Escape parentheses in docstring.  Added keyword, nick-or-keyword as
	options in `:type'.

2004-04-28  Diane Murray  <disumu@x3y2z1.net>

	* erc-stamp.el: Added local variables for file.
	(erc-away-timestamp-format): Allow nil as a choice in `:type'.
	(erc-timestamp-intangible): Changed `:type' to boolean.
	(erc-timestamp-right-column): Added `:group' and `:type'.

2004-04-28  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-modules): Added bbdb, log, match, sound, and stamp
	as `:type' options; changed documentation for autojoin, fill,
	pcomplete, track.  (erc-prompt-for-channel-key): New variable.
	(erc-join-channel): Only prompt for key if
	`erc-prompt-for-channel-key' is non-nil.  (erc-format-my-nick): New
	function.  (erc-send-message, erc-send-current-line): Use it.

2004-04-24  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-track.el (erc-track-modified-channels): Fix indentation.

2004-04-24  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-match.el (erc-hide-fools): Docstring fix.
	(erc-log-matches-types-alist): Added `current-nick' to valid
	choices.

2004-04-20  Diane Murray  <disumu@x3y2z1.net>

	* erc-page.el, erc-ezbounce.el, erc-speak.el, erc-match.el,
	erc-track.el (erc-ezbounce, erc-page, erc-speak): Groups defined.
	(erc-match, erc-track): `erc' is parent group.
	(erc-ezb-regexp, erc-ezb-login-alist): Added `:group'.

2004-04-20  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-fill.el: Fixed erc-fill-static so it breaks the lines at the
	right column and respects timestamps.  Patch by Simon Siegler
	<simon@trz-kril.de>
	(erc-fill-static): Major rewrite and split up into some functions.
	(erc-count-lines): Removed.
	(erc-fill-regarding-timestamp): New function.
	(erc-timestamp-offset): New function.
	(erc-restore-text-properties): New function.
	(erc-fill-variable): Respect leftbound timestamp.  This is still
	broken if someone has both erc-timestamp-only-if-changed-flag set
	and erc-insert-timestamp-function set to
	'erc-insert-timestamp-left, but otherwise it works now.

2004-04-20  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-cmd-SV): Show features gtk, mac-carbon, multi-tty.
	Fixed so that arguments fit the format (build date was not being
	shown).

2004-04-19  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-update-channel-topic): Error if `channel-topic' is
	unbound.  Remove %-sign substitution.
	(erc-update-mode-line-buffer): Escape %-signs in `channel-topic'
	here.

2004-04-19  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-send-action, erc-ctcp-query-ACTION,
	erc-ctcp-reply-ECHO-hook): Let `erc-display-message-highlight'
	propertize the message.
	(erc-display-message-highlight): Allow for any erc-TYPE-face.
	(erc-cmd-JOIN): Display error message instead of throwing an error
	if there's no `invitation'.
	(erc-cmd-PART): Allow for no reason if channel is provided.  Fixes
	bug where user would part the current channel with the other
	channel's name as reason when no reason was given.
	(erc-server-vectors, erc-debug-missing-hooks): Added docstring.
	(erc-server-JOIN): Moved `erc-join-hook' to JOIN-you section.
	`erc-join-hook' called by `run-hook-with-args', sending the ARGS
	`chnl' and the channel's buffer.  Changed an instance of if
	without else to when.
	(erc-server-477): New function.
	(erc-server-477-hook): Use `erc-server-477'.
	(erc-define-catalog): Added `no-invitation'.

2004-04-14  Diane Murray  <disumu@x3y2z1.net>

	* erc-nickserv.el: Local variables for file added.
	(erc-nickserv-passwords): Customization: Network symbols updated
	to reflect `erc-nickserv-alist'.  Allow user to type in network
	symbol.
	(erc-nickserv-alist): Now customizable variable.

2004-04-09  Diane Murray  <disumu@x3y2z1.net>

	* erc-autoaway.el (erc-autoaway-reset-idletime): Make sure `line'
	is a string to avoid errors upon startup.

2004-04-06  Diane Murray  <disumu@x3y2z1.net>

	* erc-autoaway.el (erc-autoaway-version): New variable.
	(erc-auto-discard-away): Updated docstring.
	(erc-autoaway-no-auto-back-regexp): New variable.
	(erc-autoaway-reset-idletime): Use it.  Hopefully a better solution
	which allows for aliases to "/away" and any other text that the
	user wants to ignore when `erc-auto-discard-away' is non-nil.

2004-04-06  Diane Murray  <disumu@x3y2z1.net>

	* erc-autoaway.el (erc-autoaway-reset-idletime): Forgot /gaway in
	regexp.

2004-04-06  Diane Murray  <disumu@x3y2z1.net>

	* erc-autoaway.el (erc-autoaway-reset-idletime): If the user sends
	an "/away" command, don't call `erc-autoaway-set-back', fixes bug
	where ERC would send "/away" when user was already away and sent an
	"/away reason".  Changed `l' to `line' for better understanding.
	(erc-autoaway-set-back): Changed `l' to `line' for better
	understanding.

2004-04-05  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-set-channel-key): Now able to remove key.
	(erc-set-channel-limit): Now able to remove limit.
	(erc-get-channel-mode-from-keypress): Fixed docstring.

2004-04-04  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-join-channel): Allow for optional channel key.
	(erc-set-modes): Need to set `channel-key' to nil in case of mode
	changes during split.
	(erc-show-channel-key-p): New variable.
	(erc-prepare-mode-line-format): Only show key if
	`erc-show-channel-key-p' is non-nil.

2004-04-04  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (channel-key): New variable.
	(erc-update-channel-key): New function.
	(erc-set-modes, erc-parse-modes, erc-update-modes, erc,
	erc-update-channel-info-buffer): Deal with channel keys.
	(erc-prepare-mode-line-format): Show channel key in header-line.
	(erc-server-NICK): Show nick change in server buffer as well.
	(erc, erc-send-command, erc-banlist-store, erc-banlist-update,
	erc-load-irc-script-lines,
	erc-arrange-session-in-multiple-windows, erc-handle-login,
	erc-find-channel-info-buffer): Changed when not to unless.
	(erc-server-MODE): Changed if without else to when.

2004-03-27  Adrian Aichner  <adrian@xemacs.org>

	* erc.el (erc-cmd-BANLIST): Use `truncate-string-to-width'
	instead of `truncate-string' alias.
	(erc-nickname-in-use): Ditto.

2004-03-27  Francis Litterio  <franl@users.sourceforge.net>

	* erc-list.el (erc-cmd-list): Fixed error caused by erc-cmd-LIST
	passing a non-sequence to erc-chanlist.

2004-03-22  Jeremy Bertram Maitin-Shepard  <jbms@gentoo.org>

	* erc.el: Add new hook `erc-join-hook', which is run when we join a
	channel.

2004-03-22  Jeremy Bertram Maitin-Shepard  <jbms@gentoo.org>

	* erc.el: Replaced existing notice user notification system and
	the configuration options, which consisted of
	`erc-echo-notices-in-minibuffer-flag' and
	`erc-echo-notices-in-current-buffer' with two new hooks,
	`erc-echo-notice-hook' and `erc-echo-notice-always-hook'.

	When user notification is needed, `erc-echo-notice-always-hook' is
	first run using `run-hook-with-args', then `erc-echo-notice-hook'
	is run using `run-hook-with-args-until-success'.

	In addition to these hooks, a large number of functions, which are
	described in the documentation strings of those hooks, were added
	which can be used to achieve a large variety of different
	behaviors.

	The current default behavior, which is identical to the existing
	default behavior, is for `erc-echo-notice-always-hook' to be set to
	`(erc-echo-notice-in-default-buffer).

2004-03-21  Diane Murray  <disumu@x3y2z1.net>

	* erc-track.el (erc-modified-channels-display): Added a space
	before opening bracket.

2004-03-21  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-format-query-as-channel-p): New variable.
	(erc-server-PRIVMSG-or-NOTICE): If `erc-format-query-as-channel-p'
	is nil, messages in the query buffer are formatted like private
	messages.

	(erc-server-252-hook, erc-server-253-hook, erc-server-254-hook,
	erc-server-256-hook, erc-server-257-hook, erc-server-258-hook,
	erc-server-259-hook, erc-server-371-hook, erc-server-372-hook,
	erc-server-374-hook, erc-server-374-hook, erc-server-442-hook,
	erc-server-477-hook): Removed, now defined in
	`erc-server-hook-list'.
	(erc-display-server-message): New function.
	(erc-server-252, erc-server-253, erc-server-254, erc-server-442):
	New functions.
	(erc-server-hook-list): Added 250, 256, 257, 258, 259, 265, 266,
	377, 378, 477 - using `erc-display-server-message'.  251, 255 now
	use `erc-display-server-message'.  Added 252, 253, 254, 442 -
	using respective erc-server-* functions.  371, 372, 374, 375 now
	defined here.
	(erc-define-catalog): Added s252, s253, s254, s442.
	(erc-server-001, erc-server-004, erc-server-005): Fixed
	documentation.

2004-03-20  Diane Murray  <disumu@x3y2z1.net>

	* erc-stamp.el: Commentary: Changed `erc-stamp-mode' to
	`erc-timestamp-mode'.
	(erc-insert-timestamp-left): Use `erc-timestamp-face' on filler
	spaces as well.

2004-03-19  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-send-action): Use `erc-input-face'.
	(erc-display-message-highlight): If the requested highlighting
	type doesn't match, just display the string with no highlighting
	and warn about it with `erc-log'.
	(erc-cmd-JOIN): If user is already on the requested channel,
	switch to that channel's buffer.
	(erc-ctcp-query-ACTION): Use `erc-action-face' for nick as well.
	(erc-header-line-use-help-echo-p): New variable.
	(erc-update-mode-line-buffer): Use `help-echo' for header-line if
	`erc-header-line-use-help-echo-p' is non-nil.

2004-03-18  Adrian Aichner  <adrian@xemacs.org>

	* erc-nets.el: Use two arguments version of `make-obsolete', if
	third argument is not supported (for XEmacs).

2004-03-18  Andreas Fuchs  <asf@void.at>

	* CREDITS: added CREDITS entry for Adrian Aichner

2004-03-18  Andreas Fuchs  <asf@void.at>

	* erc-xdcc.el, erc.el, erc-autoaway.el, erc-autojoin.el,
	erc-button.el, erc-dcc.el, erc-ezbounce.el, erc-imenu.el,
	erc-list.el, erc-log.el, erc-match.el, erc-members.el,
	erc-menu.el, erc-netsplit.el, erc-notify.el, erc-speedbar.el,
	erc-stamp.el, erc-track.el, erc-truncate.el:
	(erc-coding-sytem-for-target): Removed.
	(erc-coding-system-for-target): New.
	(erc-autoaway-use-emacs-idle): Typo fix.
	(erc-auto-set-away): Ditto.
	(erc-auto-discard-away): Ditto.
	(autojoin): Ditto.
	(erc-button-alist): Ditto.
	(erc-dcc-auto-masks): Ditto.
	(erc-dcc-chat-send-input-line): Ditto.
	(erc-ezb-get-login): Ditto.
	(erc-unfill-notice): Ditto.
	(erc-save-buffer-in-logs): Ditto.
	(match): Ditto.
	(erc-log-matches-types-alist): Ditto.
	(erc-match-directed-at-fool-p): Ditto.
	(erc-match-message): Ditto.
	(erc-update-member): Ditto.
	(erc-ignored-reply-p): Ditto.
	(erc-menu-definition): Ditto.
	(erc-netsplit-QUIT): Ditto.
	(erc-notify-list): Ditto.
	(erc-speedbar-update-channel): Ditto.
	(erc-speedbar-item-info): Ditto.
	(erc-stamp): Ditto.
	(erc-timestamp-intangible): Ditto.
	(erc-add-timestamp): Ditto.
	(erc-timestamp-only-if-changed-flag): Ditto.
	(erc-show-timestamps): Ditto.
	(erc-track-priority-faces-only): Ditto.
	(erc-modified-channels-alist): Ditto.
	(erc-unique-substrings): Ditto.
	(erc-find-parsed-property): Ditto.
	(erc-track-switch-direction): Ditto.
	(erc-truncate-buffer-to-size): Ditto.
	(erc-xdcc): Ditto.
	(erc-auto-reconnect): Ditto.
	(erc-startup-file-list): Ditto.
	(erc-once-with-server-event): Ditto.
	(erc-once-with-server-event-global): Ditto.
	(erc-mode): Ditto.
	(erc-generate-new-buffer-name): Ditto.
	(erc): Ditto.
	(erc-open-ssl-stream): Ditto.
	(erc-default-coding-system): Ditto.
	(erc-encode-string-for-target): Ditto.
	(erc-decode-string-from-target): Ditto.
	(erc-scroll-to-bottom): Ditto.
	(erc-decode-controls): Ditto.
	(erc-channel-members-changed-hook): Ditto.
	(erc-put-text-property): Ditto.
	(erc-add-default-channel): Ditto.

2004-03-17  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-process-sentinel): Cancel ping timer upon
	disconnect.
	(erc-cmd-PART): Use same regexp as `erc-cmd-QUIT' when no #channel
	is provided.
	(erc-nick-uniquifier, erc-manual-set-nick-on-bad-nick-p): `:group'
	was missing, added.
	(erc-part-reason-zippy, erc-part-reason-zippy): Removed FIXME
	comments.  I see no problem allowing typed in reasons.

2004-03-16  Diane Murray  <disumu@x3y2z1.net>

	* erc-stamp.el (erc-insert-timestamp-left): Added support for
	`erc-timestamp-only-if-changed-flag' and added docstring.
	(erc-timestamp-only-if-changed-flag): Updated documentation.

2004-03-13  Francis Litterio  <franl@users.sourceforge.net>

	* erc-nets.el (erc-network-name): No longer marked as obsolete.
	Why was this function made obsolete?  There is no other function
	that performs this task.  Some of us use these functions in our
	personal ERC configs.

2004-03-12  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-buffer-filter): Use `with-current-buffer'.
	(erc-process-input-line): Append newline to documentation.  Fixes a
	bug whereby the prompt would be put on the same line as the output.
	(erc-cmd-GQUIT): Only try and send QUIT if the process is alive.

2004-03-12  Lawrence Mitchell  <wence@gmx.li>

	* erc-log.el: Only add top-level hooks if `erc-enable-logging' is
	non-nil.

2004-03-10  Damien Elmes  <erc@repose.cx>

	* erc-nets.el: From Adrian Aichner (adrian /at/ xemacs /dot/ org)
	* erc-nets.el: XEmacs make-obsolete only takes two arguments.

2004-03-10  Diane Murray  <disumu@x3y2z1.net>

	* erc-nets.el (erc-determine-network): Use `erc-session-server' if
	`erc-announced-server' is nil to avoid error if server does not
	send 004 (RPL_MYINFO) message.

2004-03-10  Lawrence Mitchell  <wence@gmx.li>

	* erc-nets.el (erc-server-alistm erc-settings): Use lowercase
	"freenode", as in `erc-networks-alist'.

2004-03-10  Lawrence Mitchell  <wence@gmx.li>

	* erc-nickserv.el (erc-nickserv-alist): Use lowercase "freenode",
	as in `erc-networks-alist'.

2004-03-10  Lawrence Mitchell  <wence@gmx.li>

	* erc-dcc.el (pcomplete/erc-mode/DCC): Append "send" as a list.

2004-03-10  Francis Litterio  <franl@users.sourceforge.net>

	* erc-nets.el (erc-networks-alist): Changed "Freenode" to
	"freenode".

2004-03-10  Francis Litterio  <franl@users.sourceforge.net>

	* erc-list.el (erc-cmd-LIST): Improved the docstring.  Made
	message to user more accurate depending on whether a single
	channel is being listed or not.

2004-03-10  Lawrence Mitchell  <wence@gmx.li>

	* erc-nets.el (erc-determine-network): Make matching logic simpler
	(suggested by Damian Elmes).
	(erc-current-network, erc-network-name): Add `make-obsolete' form.
	(erc-set-network-name): Indentation fix.
	(erc-ports-list): Add docstring.  Rework function body to use
	`nconc'.

2004-03-09  Diane Murray  <disumu@x3y2z1.net>

	* erc-list.el, erc-notify.el (require 'erc-nets): Added.

2004-03-08  Diane Murray  <disumu@x3y2z1.net>

	* erc.el (erc-network-name): Function definition moved to
	erc-nets.el.  The functions `erc-determine-network' and
	`erc-network' in erc-nets.el do what this did before.  Deprecated.
	Use (erc-network) instead.

2004-03-08  Diane Murray  <disumu@x3y2z1.net>

	* erc-nickserv.el: Changed copyright notice.  Now require
	erc-nets.  erc-nets.el now takes care of network-related functions
	and variables.
	(erc-nickserv-alist): Changed network symbols to match those in
	`erc-networks-alist' in erc-nets.el.
	(erc-nickserv-identify-autodetect): Use `erc-network'.
	(erc-nickserv-identify): Use `erc-network'.  Changed wording for
	interactive use, now shows current nick.
	(erc-networks): Removed.  Use `erc-networks-alist' as defined in
	erc-nets.el.
	(erc-current-network): Function definition moved to erc-nets.el.
	The functions `erc-determine-network' and `erc-network' in
	erc-nets.el do what this did before.  Deprecated.  Use
	(erc-network) instead.

2004-03-08  Diane Murray  <disumu@x3y2z1.net>

	* erc-nets.el: Added commentary, `erc-nets-version'.
	(erc-server-alist): Changed Brasnet to BRASnet.
	(erc-networks-alist): All networks (except EFnet and IRCnet) now
	have a MATCHER.  (erc-network): New variable.
	(erc-determine-network): New function.  Determine the network the
	user is on.  Use the server parameter NETWORK, if provided, else
	parse the server name and search for a match (regexp and loop by
	wencem) in `erc-networks-alist'.  Return the name of the network
	or "Unknown" as a symbol.
	(erc-network): New function.  Returns value of `erc-network'.  Use
	this when the current buffer is not the server process buffer.
	(erc-current-network): Returns the value of `erc-network' as
	expected by users who used the function as it was defined in
	erc-nickserv.el.  Deprecated.
	(erc-network-name): Returns the value of `erc-network' as expected
	by users who used the function as it was defined in erc.el.
	Deprecated.
	(erc-set-network-name): New function.  Added to
	`erc-server-375-hook' and `erc-server-422-hook'.
	(erc-unset-network-name): New function.  Added to
	`erc-disconnected-hook'.
	(erc-server-select): Small documentation word change.

2004-03-07  Diane Murray  <disumu@x3y2z1.net>

	* AUTHORS, CREDITS: disumu info updated

2004-03-06  Lawrence Mitchell  <wence@gmx.li>

	* erc-list.el (erc-cmd-LIST): Take &rest rather than &optional
	arguments.
	(erc-chanlist): Construct correct LIST command from list of
	channels.

2004-03-06  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-update-mode-line-buffer): Add 'help-echo property to
	header-line text.  This allows header lines longer than the width
	of the current window to be seen.

2004-03-06  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-match.el (erc-match-directed-at-fool-p): Also check for
	"FOOL, "

2004-03-06  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-match.el (erc-match-message): Only use nick-or-keyword if
	we're matching our nick.

2004-03-06  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-match.el: The highlight type for the current nickname can
	now also be 'nick-or-keyword, to highlight the nick of the sender
	if that is available, but fall back to highlighting your nickname
	in the whole message otherwise.
	(erc-current-nick-highlight-type): Adapted docstring accordingly.
	(erc-match-message): Added new condition.  Also added some comments
	to this monster of a function.

2004-03-06  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-is-valid-nick-p): Don't check for length less or
	equal to 9.

2004-03-06  Damien Elmes  <erc@repose.cx>

	* erc-nickserv.el (erc-current-network): the last change resulted
	in this function failing when a network identifies itself as
	anything other than var.netname.com, so for instance
	'vic.au.austnet.org' fails.  This version is only a marginal
	improvement over the original, but if we want to be more flexible
	we'll probably have to do the iteration ourselves instead of using
	assoc.

2004-03-05  Diane Murray  <disumu@x3y2z1.net>

	* erc.el: Added erc-server-001 which runs when the server sends
	its welcome message.  It sets the current-nick to reflect the
	server's settings.  This fixes a bug where nicks that were too long
	and got truncated by the server were still set to the old value.
	(nickname-in-use): If user wants to try again manually, let user
	know that the nick is taken.  If not, go through erc-default-nicks
	until none are left, and then try one last time with
	erc-nick-uniquifier.  If it's still a bad-nick, make the user
	change nick manually.  When applying uniquifier, use NICKLEN if
	it's in the server parameters, otherwise use what RFC 2812 says is
	the max nick length (9 chars).  Added custom variable
	erc-manual-set-nick-on-bad-nick-p, which is set to nil and
	erc-nick-change-attempt-count.  Reset erc-default-nicks and
	erc-nick-change-attempt-count when the nick has been changed
	successfully.  This fixes the bug where ERC would get caught in a
	neverending loop of trying to set the same nick if the nick was
	too long and the uniquified nick was not available.

	* added erc-cmd-WHOAMI

	* added custom variable erc-mode-line-away-status-format, use this
	instead of the previous hard-coded setting

	* erc-server-315|318|369-hook defvar lines removed - they're
	already defined in erc-server-hook-list

2004-03-04  Lawrence Mitchell  <wence@gmx.li>

	* HACKING: Initial commit.  Some thoughts on coding standards.

2004-03-03  Diane Murray  <disumu@x3y2z1.net>

	* erc-track.el: added the variable erc-track-priority-faces-only
	which adds the option to ignore changes in a channel unless there
	are faces from the erc-track-faces-priority-list in the message
	options are nil, 'all, or a list of channel name strings

2004-03-01  Diane Murray  <disumu@x3y2z1.net>

	* erc.el, erc-ibuffer.el, erc-menu.el: Changed erc-is-channel-op
	and erc-is-channel-voice to erc-channel-user-op-p and
	erc-channel-user-voice-p to better match erc-channel-user
	structure (and emacs lisp usage)

2004-03-01  Diane Murray  <disumu@x3y2z1.net>

	* erc.el, erc-ibuffer.el, erc-menu.el:
	erc-track-modified-channels-mode is now erc-track-mode

2004-02-29  Diane Murray  <disumu@x3y2z1.net>

	* erc-match.el: Added 'keyword option to
	erc-current-nick-highlight-type highlights all instances of
	current-nick in the message ('nickname option in cvs revisions 1.9
	- 1.11 had same effect)

2004-02-28  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-button.el: Add Lisp: prefix for the EmacsWiki Elisp area.
	(erc-button-alist): Added Lisp: prefix.
	(erc-emacswiki-lisp-url): New variable.
	(erc-browse-emacswiki-lisp): New function.

2004-02-27  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-get-arglist): Use `substitute-command-keys', rather
	than hard-coding C-h f for `describe-function'.

2004-02-26  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-log.el (erc-save-buffer-in-logs): bind `inhibit-read-only'
	to t around call to `erase-buffer'.

2004-02-23  Theresa O'Connor  <ted@oconnor.cx>

	* erc-chess.el, erc-dcc.el, erc-ezbounce.el, erc-list.el,
	erc-macs.el, erc-ring.el, erc-stamp.el, erc.el: Normalized buffer
	local variable creation.

2004-02-17  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-scroll-to-bottom, erc-add-scroll-to-bottom): Mention
	`erc-input-line-position' in docstring.

2004-02-13  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-kick-hook): Typo fix.

2004-02-13  Jeremy Bertram Maitin-Shepard  <jbms@gentoo.org>

	* erc.el: Added `erc-kick-hook', which is called when the local
	user is kicked from a channel.  Fixed a bug in `erc-cmd-OPS', such
	that the command now works.  Added `erc-remove-channel-users', in
	order to fix a number of significant bugs relating to channel
	parting.

2004-02-12  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-display-prompt): Remove last change.  This caused a
	lot of trouble :(

2004-02-12  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-display-prompt): Also set 'field property, so C-j
	works on an empty prompt.

2004-02-12  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-update-channel-topic): Ensure that `channel-topic'
	does not contain any bare format controls.

2004-02-10  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-stamp.el (erc-timestamp-intangible): New variable (user
	feature request)
	(erc-format-timestamp): Use erc-timestamp-intangible.

2004-02-07  Jeremy Bertram Maitin-Shepard  <jbms@gentoo.org>

	* erc-button.el: Fixed bug related to nickname buttonizing and text
	fields due to erc-stamp.

2004-02-07  Jeremy Bertram Maitin-Shepard  <jbms@gentoo.org>

	* CREDITS: Added mention of my change of ERC to use hash tables.

2004-02-07  Jeremy Bertram Maitin-Shepard  <jbms@gentoo.org>

	* AUTHORS: Added myself to the list.

2004-02-05  Lawrence Mitchell  <wence@gmx.li>

	* erc.el: From Jeremy Maitin-Shepard <jbms@attbi.com>:
	(erc-remove-channel-user): Use `delq' not `delete'.
	(erc-get-buffer): Pass PROC through to `erc-buffer-filter'.
	(erc-process-sentinel): Use `erc' rather than `erc-reconnect' for
	auto-reconnection.

2004-02-02  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-buffer-list-with-nick): Apply `erc-downcase' NICK.

2004-01-30  Alex Schroeder  <alex@gnu.org>

	* erc.el (erc-get-buffer): Use erc-buffer-filter.

2004-01-30  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el: From jbms:
	(erc-get-channel-nickname-list): New function.
	(erc-get-server-nickname-list): New function.
	(erc-get-server-nickname-alist): New function.
	(erc-get-channel-nickname-alist): New function.

2004-01-30  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-match.el (erc-add-entry-to-list,
	erc-remove-entry-from-list): Use `erc-member-ignore-case' to
	compare entries.
	(erc-add-pal, erc-add-fool): Fix type bug.  Use
	`erc-get-server-nickname-alist'.

2004-01-29  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el: From jbms: Adds xemacs compatibility to hash table
	channel-members patch.

2004-01-29  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc.el (erc-update-undo-list): Rewritten.  Update
	buffer-undo-list in place.  Deal with XEmacsesque
	entries (extents) in the list.
	(erc-channel-users): Fix unescaped open-paren in left column in
	docstring.

2004-01-29  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-ring.el (erc-replace-current-command): Exclude the prompt
	from the deleted region and don't redisplay the prompt (because
	`erc-display-prompt' flushes `buffer-undo-list').

2004-01-29  Johan Bockgård  <bojohan@users.sourceforge.net>

	* erc-match.el (erc-add-entry-to-list): Use `symbol-value' instead
	of `eval'.

2004-01-28  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-kill-buffer-function): maphash was missing an
	argument.

2004-01-28  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* Makefile, erc-autoaway.el, erc-button.el, erc-ibuffer.el,
	erc-lang.el, erc-list.el, erc-match.el, erc-menu.el, erc-page.el,
	erc-pcomplete.el, erc-speedbar.el, erc.el: HUGE change by jbms.
	This makes channel-members a hash, erc-channel-users.

	Modified files: Makefile erc-autoaway.el erc-button.el
	erc-ibuffer.el erc-lang.el erc-list.el erc-match.el erc-menu.el
	erc-page.el erc-pcomplete.el erc-speedbar.el erc.el

	The changes are too numerous to document properly.  Have fun with
	the breakage.

2004-01-27  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-send-input-line): Add a space to empty lines so the
	server likes them.

2004-01-25  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el: erc-send-whitespace-lines: New variable.
	(erc-send-current-line): Use erc-send-whitespace-lines.  Also,
	removed superfluous test for empty line in the mapc, since the
	blank line test should find all.  I do like to be able to send an
	empty line when i want to!
	(erc-send-current-line): Check for point being in input line
	before checking for blank lines.

2004-01-21  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-display-line-1): Move `erc-update-undo-list' outside
	`save-restriction'.  Removing need for temporary variable.
	(erc-send-current-line): Fix bug introduced by last change, remove
	complement in blank line regexp.

2004-01-20  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-update-undo-list): Add logic to catch the case when
	`buffer-undo-list' is t, indentation cleanup.
	(erc-send-current-line): Reverse logic for matching blank lines.

2004-01-20  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-input-line-position): New variable.  If non-nil,
	specifies the argument to `recenter' in `erc-scroll-to-bottom'.
	(erc-scroll-to-bottom): Use it.

2004-01-20  Lawrence Mitchell  <wence@gmx.li>

	* erc.el: From Johan Bockgård <bojohan+news@dd.chalmers.se>:
	(erc-update-undo-list): New function.  Update `buffer-undo-list'
	so that calling `undo' in an ERC buffer doesn't mess up the
	existing text.
	(erc-display-line-1): Use it.

2004-01-19  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-beg-of-input-line): Use `forward-line' rather than
	`beginning-of-line'.  Docstring fix.
	(erc-end-of-input-line): Docstring fix.

2004-01-13  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-display-prompt): Remove the undo list after
	displaying the prompt, so the user can't undo ERC changes, which
	breaks some stuff anyways.  This way the user can still undo his
	editing, but not ours.

2004-01-12  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el (erc-scroll-to-bottom): Should recenter on the bottom
	line, not the second-to-last one.

2004-01-12  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-bol): Fix bug introduced in my changes from 2004-01-11.

2004-01-12  Lawrence Mitchell  <wence@gmx.li>

	* erc.el: From Brian Palmer <bpalmer@gmail.com>
	(erc-cmd-JOIN): Use `erc-member-ignore-case', rather than
	`member-ignore-case'.

2004-01-12  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el: There was an inconsistency where the values of op and
	voice in channel-names could be 'on or 'off after an update, t and
	nil before.  The intended version was to have t or nil, so i fixed
	it to do so.
	(channel-names): Updated docstring.
	(erc-update-current-channel-member): Clarified docstring, fixed so
	it sets t or nil on an update as well, not only on an add.
	(erc-cmd-OPS): Updated not to check for 'on (the only function that
	did this!)

2004-01-12  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-part-reason-various-alist,
	erc-update-mode-line-buffer): Fix docstring

2004-01-11  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-update-mode-line): Fix typo.

2004-01-11  Lawrence Mitchell  <wence@gmx.li>

	* erc.el (erc-prompt-interactive-input): Removed.
	(erc-display-prompt): Removed `erc-prompt-interactive-input'
	option.  (erc-interactive-input-map): Removed.

	Major docstring fixes.

2004-01-07  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-cmd-OPS): Added this function.
	(erc-cmd-IDLE): Switched from using erc-display-message-highlight
	to erc-make-notice.

2004-01-07  Francis Litterio  <franl@users.sourceforge.net>

	* erc-list.el (erc-cmd-LIST): Switched from using
	erc-display-message-highlight to erc-make-notice.

2004-01-07  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-once-with-server-event): Added a sentence to the
	docstring.  Now returns the uninterned symbol that is added to the
	server hook.
	(erc-cmd-IDLE): Changed to use erc-once-with-server-event instead
	of erc-once-with-server-event-global.

2004-01-06  Francis Litterio  <franl@users.sourceforge.net>

	* erc-list.el (erc-chanlist-hide-modeline): New variable.
	(erc-chanlist): Now displays message as a notice.  Also hides the
	modeline if erc-chanlist-hide-modeline is non-nil.

2004-01-05  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-server-PRIVMSG-or-NOTICE): Now nicks appear as
	<nick> in query buffers, instead of as *nick*.

2004-01-03  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-once-with-server-event-global): Changed to return
	the uninterned symbol that it creates.
	(erc-cmd-LIST): Changed to clean up hooks that don't run.

2004-01-03  Francis Litterio  <franl@users.sourceforge.net>

	* erc-pcomplete.el (pcomplete/erc-mode/IDLE): Added to support new
	/IDLE command.

2004-01-03  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el (erc-once-with-server-event-global): New function.  Like
	erc-once-with-server-event, except it modifies the global value of
	the event hook.
	(erc-cmd-IDLE): New function.  Implements the new /IDLE command.
	Usage: /IDLE NICK (erc-seconds-to-string): New function.  Converts
	a number of seconds to an English phrase.

2004-01-02  Francis Litterio  <franl@users.sourceforge.net>

	* erc-list.el: Added variable erc-chanlist-mode-hook.

2003-12-30  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-cmd-HELP):
	Changed to prefer giving help for erc-cmd-* functions over
	   similarly-named Elisp functions (e.g., erc-cmd-LIST vs. list).

2003-12-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-query-buffer-p): Added this function.

2003-12-28  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el(erc-cmd-SV): Use erc-emacs-build-time.

	* erc-compat.el: erc-emacs-build-time: New variable.

	* erc.el(erc-cmd-SAY):
	Reintroduced the feature where the spaces between
	"/SAY" and the rest of the line were being sent with the message.

2003-12-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-server-buffer-p):
	Fixed a bug where this function sometimes would return
	    nil when it should return t.

2003-12-27  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-generate-new-buffer-name):
	Really fixed a bug where ERC would reuse
	    a connected server buffer when erc-reuse-buffers is non-nil.
	(erc-cmd-JOIN): Now we tell the user when he attempts to join the same
	    channel twice on the same server.

	* erc.el(erc-generate-new-buffer-name):
	Fixed a bug where ERC would reuse a connected server buffer when erc-reuse-buffers is non-nil.

	* erc.el(erc-cmd-SAY):
	Fixed a bug where the spaces between "/SAY" and the rest of the
	    line were being sent with the message.

	* erc-list.el: Fixed another typo.

	* erc-list.el: Fixed a typo.

	* erc-list.el:
	Added text to the top of the channel list buffer describing the keybinding for
	function erc-chanlist-join-channel.

	* erc-list.el: Minor appearance changes.  No functional change.

	* erc-list.el:
	Implemented function erc-chanlist-join-channel.  Added variable
	erc-chanlist-channel-line-regexp.  Got rid of function
	erc-chanlist-pre-command-hook.  Changed the logic for how channel lines are
	highlighted.

2003-12-26  Francis Litterio  <franl@users.sourceforge.net>

	* erc-list.el:
	Removed a bunch of unused code.  No semantic change.

	* erc-list.el: Added lots of functionality.

2003-12-15  Mario Lang  <mlang@delysid.org>

	* erc-track.el, erc.el:
	New custom type erc-message-type, use it in erc-hide-list and erc-track-exclude-types

2003-12-14  Alex Schroeder  <alex@gnu.org>

	* erc-track.el(track-when-inactive): New module.
	(erc-track-visibility): New option.
	(erc-buffer-activity): New variable.
	(erc-buffer-activity-timeout): New variable.
	(erc-user-is-active): New function.
	(erc-buffer-visible): New function.
	(erc-modified-channels-update): Replace get-buffer-window call
	with call to erc-buffer-visible.
	(erc-track-modified-channels): Ditto.

2003-12-14  Lawrence Mitchell  <wence@gmx.li>

	* erc-track.el(erc-modified-channels-update):
	Force update of modeline.  Makes sure
	that the tracked channels disappear in other buffers too.

2003-12-06  Lawrence Mitchell  <wence@gmx.li>

	* erc.el(define-erc-module):
	New optional argument LOCAL-P.  If non-nil, then
	mode will be created as buffer-local rather than a global mode.
	(erc-cmd-CTCP): Fix indentation from last commit.

	* erc-compat.el(erc-define-minor-mode):
	Deal with :global and :group keywords.

	* erc-nickserv.el(erc-current-network):
	Make server regex more permissive.

	* erc.el(erc-cmd-CTCP):
	Don't add a space to end of command when ARGS are
	empty.  This fixes a bug whereby requests of the form "VERSION " were
	being sent, and ignored.

2003-11-27  Lawrence Mitchell  <wence@gmx.li>

	* erc-log.el: From Adrian Aichner <adrian@xemacs.org>
	* erc-log.el (erc-log-file-coding-system): Use 'binary
	coding-system under XEmacs (instead of 'emacs-mule).
	* erc-log.el (erc-w32-invalid-file-characters): Removed as no
	longer needed.
	* erc-log.el (erc-generate-log-file-name-long): Use
	`convert-standard-filename', which exists in XEmacs too.

2003-11-16  Mario Lang  <mlang@delysid.org>

	* erc-identd.el: Code provided by johnw, thanks!

2003-11-09  Lawrence Mitchell  <wence@gmx.li>

	* erc.el(erc-latest-version): Clean up docstring.
	Remove requirement for w3, wrap REQUIRE statement in IGNORE-ERRORS.
	Update viewcvs url to correct location.
	(erc-ediff-latest-version): Make sure that we find the uncompiled
	erc.el, error if not.

2003-11-07  Mario Lang  <mlang@delysid.org>

	* erc.el: Add more info to /sv

2003-11-06  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el: Added optional argument BUFFER to erc-server-buffer-p.

2003-11-04  Mario Lang  <mlang@delysid.org>

	* AUTHORS: Add sachac

2003-11-02  Lawrence Mitchell  <wence@gmx.li>

	* erc.el(erc-server-366):
	chnl is 4th element of parsed, not fifth.
	(erc-channel-end-receiving-names): Pass correct number of arguments
	to delete-if-not.

	* erc.el(erc-update-current-channel-member):
	Use erc-downcase when comparing
	nick entries.  Cleanup indentation.

2003-11-01  Lawrence Mitchell  <wence@gmx.li>

	* erc-sound.el: Added a (provide 'erc-sound) line.

	* erc.el(erc-cmd-NAMES): send to TGT, not CHANNEL.

2003-10-29  Sandra Jean Chua  <sacha@free.net.ph>

	* erc-pcomplete.el, erc.el, CREDITS:
	Merged Jeremy Maitin-Shepard's patch for time-sensitive nick completion.

2003-10-27  Mario Lang  <mlang@delysid.org>

	* Makefile, debian/changelog:
	New Debian package 4.0.cvs.20031027

2003-10-25  Mario Lang  <mlang@delysid.org>

	* erc.el: Fix typo tuncate->truncate

2003-10-24  Mario Lang  <mlang@delysid.org>

	* erc-dcc.el: From Stephan Stahl <stl@isogmbh.de>:
	(erc-dcc-send-block): Kill buffer if transfer completed correctly.

2003-10-22  Mario Lang  <mlang@delysid.org>

	* erc-track.el(erc-track-disable):
	Do not deactivate all advices for `switch-to-buffer',
	just disable the erc specific one. (Bug#217022).

2003-10-18  Lawrence Mitchell  <wence@gmx.li>

	* erc-log.el(erc-log-file-coding-system): New variable.
	(erc-save-buffer-in-logs): Use it.

2003-10-17  Mario Lang  <mlang@delysid.org>

	* erc.el(erc-interpret-mirc-color): New boolean defcustom

	* erc.el: Do not use -nowait on darwin (thanks johnw)

2003-10-15  Lawrence Mitchell  <wence@gmx.li>

	* erc.el(define-erc-module):
	Set erc-FOO-mode appropriately in erc-FOO-enable
	and erc-FOO-disable.

2003-10-12  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-autoaway.el(erc-mode):
	Reset idletime on connect. Fixes an annoying bug which
	flooded the server with always on reconnect.
	(erc-autoway-reset-idletime): Accept optional args so we can hook it
	onto erc-server-001-hook.

2003-10-10  Mario Lang  <mlang@delysid.org>

	* erc.el(erc-hide-list): Add a nice defcustom type

2003-10-08  Mario Lang  <mlang@delysid.org>

	* Makefile, debian/changelog, debian/control:
	Debian snapshot 20031008

	* erc-speedbar.el:
	Patch from Eric M. Ludlam <eric@siege-engine.com>:
	 - (erc-install-speedbar-variables): Add functions list (needs new speedbar?)
	 - (erc-speedbar-buttons): Add doc.  Clear the buffer
	 - (erc-speedbar-sort-channel-members): New function.
	 - (erc-speedbar-expand-channel): Call new sort function.  Change some visuals.
	 - (erc-speedbar-insert-user): Change some visuals based on channel data.
	 - (erc-speedbar-line-text, erc-speedbar-item-info): New functions
	Add proper elisp file header.

2003-10-02  Lawrence Mitchell  <wence@gmx.li>

	* erc-match.el(erc-match-syntax-table): New variable.
	(erc-match-current-nick-p): Use it.

	* erc.el(erc-quit-reason-zippy, erc-part-reason-zippy): Use
	`erc-replace-regexp-in-string' rather than
	`replace-regexp-in-string'.
	(erc-command-indicator-face): New face, used to show commands if
	`erc-hide-prompt' is nil and `erc-command-indicator' is non-nil.
	(erc-command-indicator): Clean up doc-string.
	(erc-display-prompt): New optional argument FACE, use this rather
	than `erc-prompt-face' to fontify the prompt if non-nil.
	(erc-send-current-line): Pass in `erc-command-indicator-face' to
	`erc-display-prompt'.

	* erc-compat.el(erc-replace-regexp-in-string): New function.
	Alias for `replace-regexp-in-string' on Emacs 21.
	Argument massaging for `replace-in-string' for XEmacs.

2003-09-28  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el(erc-keywords): Removed. Wasn't used by anything.

2003-09-25  Lawrence Mitchell  <wence@gmx.li>

	* erc.el: ERC-HIDE-PROMPT: add custom group
	ERC-COMMAND-INDICATOR: new variable.
	ERC-COMMAND-INDICATOR: new function.
	ERC-DISPLAY-PROMPT: new argument, PROMPT, used to override default
	prompt.
	ERC-SEND-CURRENT-LINE: pass ERC-COMMAND-INDICATOR to ERC-DISPLAY-PROMPT.

2003-09-24  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el(erc-parse-line-from-server):
	Ignore empty lines as required by RFC.

2003-09-17  Mario Lang  <mlang@delysid.org>

	* erc.el: Add lag time calculation

2003-09-13  Mario Lang  <mlang@delysid.org>

	* Makefile, debian/README.Debian, debian/changelog:
	New debian release

	* erc-notify.el:
	Call erc-notify-install-message-catalogs on load, not on module init

	* erc.el(erc-update-modules):
	Use `load' instead of `require'.  XEmacs appears
	to have the NOERROR arg only sometimes... Strange

	* erc.el: No fboundp if we have a defvar

	* erc.el: Properly defvar erc-ping-handler

2003-09-11  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-setup-periodical-server-ping):
	check if erc-ping-handler is
	    bound before referencing it

2003-09-10  Mario Lang  <mlang@delysid.org>

	* erc.el(erc-cmd-NICK):
	Warn about exceeded NICKLEN if we know it.

	* erc.el: Make erc-server-PONG obey erc-verbose-server-ping.
	Cancel old `erc-ping-handler' timer when restablishing connection in the same
	buffer.

	* debian/changelog, Makefile: New debian snapshot

	* erc-dcc.el, erc-xdcc.el:
	Use new function erc-dcc-file-to-name to convert spaces to underscores

	* erc-xdcc.el: Add autoload for erc-xdcc-add-file

2003-09-08  Mario Lang  <mlang@delysid.org>

	* erc-dcc.el: indent fixes and copyright update

	* erc.el:
	erc-send-ping-interval: New defcustom which defaults to 60.
	Every 60 seconds, we send PING now.
	This should fix the "connection silently lost" bug.
	Please test this change extensively, and report problems.

2003-09-07  Alex Schroeder  <alex@gnu.org>

	* erc.el(erc-default-coding-system):
	Test for undecided and utf-8
	before setting.

2003-09-01  Mario Lang  <mlang@delysid.org>

	* erc.el(erc-modules): Add some more symbols to the set

	* erc.el(erc-modules): Add :greedy t to the set in

	* erc-dcc.el:
	More autoloads which make dcc autoload upon ctcp dcc query received.

	* erc-dcc.el(erc-cmd-DCC): Add Autoload.
	(pcomplete/erc-mode/DCC): Ditto, makes DCC autoloadable just by using
	completion.
	Also only offer "send" if fboundp make-network-process.

	* erc-autojoin.el: Update copyright

	* erc-autojoin.el(erc-autojoin-add):
	Only add the channel if it is not already there.

	* erc-notify.el:
	Use `define-erc-module' instead of old `erc-notify-initialize'.
	Now defines the global minor mode erc-notify-mode, and should also
	be controllable via `erc-modules' with symbol `notify'.

	* erc.el(erc-modules):
	Fix paren-in-column-zero bug in docstring.
	Add a sort of bogus, but still better :type.
	Add autojoin and netsplit by default.
	(erc-update-modules): Don't barf with an error if `require' fails.
	We can still error out if the mode is not defined.

2003-08-31  Andreas Fuchs  <asf@void.at>

	* erc.el:
	* make 353 (NAMES reply) output go into the appropriate channel buffer
	  (if it exists) or into the active erc buffer (if not).

2003-08-29  Marcelo Toledo  <mtoledo@confusibombus>

	* erc.el:
	Added the variable erc-echo-notices-in-current-buffer to make possible display notices in the current buffer (queries to nickserv/chanserv/memoserv). Defaults to nil so nothing changes from what we have today.

2003-08-29  Mario Lang  <mlang@delysid.org>

	* erc.el: Fix typo in varname which led to a compiler warning

	* AUTHORS: Added lawrence

2003-08-27  Mario Lang  <mlang@delysid.org>

	* erc-dcc.el:
	Set process and file-coding system to 'binary (for Windows)

	* erc-stamp.el: Rename custom group erc-timestamp to erc-stamp.

2003-08-07  Lawrence Mitchell  <wence@gmx.li>

	* erc-fill.el(erc-fill-disable):
	Remove erc-fill, not erc-fill-static from
	erc-insert-modify-hook.

2003-08-05  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-send-current-line):
	Now we display the prompt for previously entered commands
	    based on the value of customization variable erc-hide-prompt.  This change is
	    closely related to the immediate previous version by wencem.

2003-08-04  Lawrence Mitchell  <wence@gmx.li>

	* erc.el(erc-send-current-line):
	If we're sending a command, don't display
	the prompt.

2003-08-04  Damien Elmes  <erc@repose.cx>

	* erc-track.el: patch from David Edmondson (dme AT dme DOT org)

	This patch makes button 3 on the erc-track buffer names in the
	modeline show the selected buffer in another window. It's analogous to
	button 2 which shows the buffer in the current window.

2003-07-31  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-display-line-1):
	Fixed bad indentation on one line.  No semantic change.

2003-07-29  Lawrence Mitchell  <wence@gmx.li>

	* erc-match.el:
	Quote open paren in docstring of erc-text-matched-hook

	* erc.el: Anchor match only at beginning in erc-ignored-user-p.

	* erc-button.el: New variable erc-button-wrap-long-urls.
	Modified erc-button-add-buttons:
	  New optional argument REGEXP.
	  If we're buttonizing a URL and erc-button-wrap-long-urls is
	  non-nil, try and wrap them

	Modified erc-button-add-buttons-1:
	  Pass regexp to erc-button-add-buttons.

2003-07-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-network-name):
	Improved docstring.  Removed an unnecessary call to erc-server-buffer.

2003-07-28  Mario Lang  <mlang@delysid.org>

	* erc.el: By lawrence:
	(erc-ignored-user-p): Use anchored regexp.
	(smiley): Fix missing quote in `remove-hook' call.

2003-07-26  Francis Litterio  <franl@users.sourceforge.net>

	* erc-nets.el, erc-nickserv.el, erc.el:
	Changed all references to Openprojects into references to Freenode.

2003-07-25  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el:
	Now variable erc-debug-irc-protocol is defvar'ed instead of defcustom'ed.
	Made the docstring clearer too.

	* erc.el: Fixed a wrong-type-argument error from window-live-p.

2003-07-15  Damien Elmes  <erc@repose.cx>

	* erc-log.el(erc-log-setup-logging):
	set buffer-file-name to "", as (basic-save-buffer)
	    will prompt for a buffer name before invoking hooks. the buffer-file-name
	    will be overridden by (erc-save-buffer-in-logs) anyway - the main danger
	    of doing this is write-file-contents hooks. Let's see if anyone complains.
	(erc-save-buffer-in-logs): return t, so that further write hooks are not run

2003-07-09  Damien Elmes  <erc@repose.cx>

	* erc-dcc.el(erc-dcc-open-network-stream):
	-nowait still crashes emacs cvs - disable for now

2003-07-02  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc): Minor docstring modification.

2003-07-01  Damien Elmes  <erc@repose.cx>

	* erc-match.el(erc-match-current-nick-p):
	match only on word boundaries

	* erc-log.el(erc-log-setup-logging):
	not sure how this crept in again - make sure we set
	    buffer-file-name to nil, since otherwise it is not possible to open
	    previous correspondence in another buffer while a conversation is open

2003-06-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-network-name):
	Now makes some intelligent guesses if the server didn't tell
	    us the network name.

2003-06-28  Alex Schroeder  <alex@gnu.org>

	* erc.el(erc-default-coding-system): Use utf-8 as the default
	encoding for outgoing stuff and undecided as the default for
	incoming stuff.
	(erc-coding-sytem-for-target): New.
	(erc-encode-string-for-target): Use it.
	(erc-decode-string-from-target): Use it.  Removed the flet
	erc-default-target hack and documented the dynamically bound
	variable `target' instead.

2003-06-25  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-log-irc-protocol):
	Now we keep point on the bottom line of the window
	    displaying the *erc-protocol* buffer if it is at the end of the
	    *erc-protocol* buffer.

	* erc.el:
	Added some text to the docstring for variable erc-debug-irc-protocol.

2003-06-23  Francis Litterio  <franl@users.sourceforge.net>

	* erc-dcc.el(erc-dcc-auto-mask-p):
	Fixed a docstring typo that caused a load-time error.

	* erc-dcc.el(erc-dcc-auto-mask-p):
	Changed reference to undefined variable erc-dcc-auto-mask-list
	    to erc-dcc-auto-masks.
	Changed default value of variable erc-dcc-auto-masks to nil and added text to its
	    docstring.

	* erc-notify.el(erc-notify-timer and erc-notify-QUIT):
	Added network name to notify_off message.

	* erc.el(erc-network-name):
	Now returns the name of the IRC server if the network name
	    cannot be determined.

	* erc-notify.el(erc-notify-JOIN and erc-notify-NICK):
	Added argument ?m to call to erc-display-message.

	* erc-dcc.el(erc-dcc-do-LIST-command):
	Fixed a bug where I assumed (plist-get elt :type)
	    returns a string -- it really returns a symbol.

	* erc-notify.el(erc-notify-timer):
	Now we include the network name in the notify_on message.

	* erc.el:
	New function: erc-network-name.  Returns the name of the network that the
	    current buffer is associate with.  Not every server sends the 005 messages
	    that enable the network name to be known.  If the network name is
	    not known, the string "UNKNOWN" is returned.

	* erc-dcc.el(erc-dcc-chat-setup):
	Added a comment.  Fixed a bug where a DCC CHAT buffer has no
	    prompt when it first appears.

	* erc-dcc.el(erc-dcc-chat-parse-output):
	Now a DCC chat buffer displays the nick using
	    erc-nick-default-face just like in a channel buffer.

2003-06-22  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-display-prompt):
	Fixed incorrect indentation.  No semantic change.

	* erc.el(erc-strip-controls):
	Minor change to regexp that matches IRC color control
	    codes.  I was seeing usage as follows: ^C07colored text^C^C04other color.
	    Now we strip a ^C followed by zero, one, or two digits.  Before this change,
	    we stripped a ^C followed by one or two digits.

	* erc-dcc.el(erc-dcc-do-LIST-command):
	Improved format of output of /DCC LIST.  Now the
	    "Size" column for a DCC GET includes the percentage of the file that has
	    been retrieved.
	(erc-dcc-do-GET-command): Now it works if erc-dcc-default-directory is set.

2003-06-19  Damien Elmes  <erc@repose.cx>

	* erc-log.el:
	* added quickstart information to the comments up the top

2003-06-16  Mario Lang  <mlang@delysid.org>

	* erc.el:
	Default to open-network-stream on MS Windows. (thanks lawrence)

2003-06-11  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-process-input-line):
	refactor so that wrong-number-of-arguments is
	    caught when using do-not-parse-args - this lets do-not-parse-args
	    commands display help messages on incorrect syntax in a uniform manner.
	    This no longer raises a bad-syntax error - was this a catch-all to stop a
	    backtrace? Does it belong?
	(erc-cmd-APPENDTOPIC): the correct way to display help when you want to
	    accept an arbitrary string is to (signal 'wrong-number-of-arguments nil).
	    This fixes a bug where people could not /at topics with a space in them.

2003-06-09  Damien Elmes  <erc@repose.cx>

	* erc.el:
	Re-add the last few changes which weren't merged for some reason.

	* erc.el(erc-cmd-APPENDTOPIC): show help when given no arguments

	Patch from MrBump. Fixes problem with erc-set-topic inserting ^C characters
	into the topic. Also removes dependency on CL.

2003-06-08  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el:
	Added comment to explain (eval-after-load "erc" '(erc-update-modules)).

2003-06-01  Mario Lang  <mlang@delysid.org>

	* erc-pcomplete.el: Add completion for /unignore

2003-05-31  Alex Schroeder  <alex@gnu.org>

	* erc-compat.el(erc-encode-coding-string): The default binding,
	if encode-coding-string was not available, must be a defun that
	takes multiple arguments.  Did that.

2003-05-30  Mario Lang  <mlang@delysid.org>

	* erc.el:
	Add handlers for 313 and 330 (by arne@rfc2549.org, thanks)

2003-05-30  Damien Elmes  <erc@repose.cx>

	* erc.el:
	patch from MrBump to make /mode #foo +b work again (erc-cmd-BANLIST only
	temporarily changes them now)

2003-05-29  Alex Schroeder  <alex@gnu.org>

	* erc.el(erc-select):
	server is now defaulted with erc-compute-server.
	A few cosmetic fixes.
	(erc-default-coding-system): Renamed from erc-encoding-default.
	(erc-encoding-default): Renamed to erc-default-coding-system.
	(erc-encoding-coding-alist): Documentation updated to cover regexps.
	(erc-encode-string-for-target): Now considers keys of
	erc-encoding-coding-alist to be regexps.  Rely on erc-compat
	wrt. MULE support.
	(erc-decode-string-from-target): New function.
	(erc-send-current-line): eq -> char-equal fix.
	(erc-server-TOPIC): topic is now decoded with
	erc-decode-string-from-target.
	(erc-parse-line-from-server): Line from server is no longer decoded
	here.
	(erc-server-PRIVMSG-or-NOTICE): Message from a user is decoded here,
	sspec -> sender-spec for clarity.  Cosmetic if -> when fix.
	(erc-server-TOPIC): sspec -> sender-spec
	(erc-server-WALLOPS): Ditto.

	* erc-compat.el(erc-decode-coding-string):
	Now requires coding-system as an argument.

2003-05-15  Mario Lang  <mlang@delysid.org>

	* erc.el:
	erc-part|quit-hook is only run on a part|quit directed to our nick, reflect that in the docstring to avoid confusion

2003-05-01  Andreas Fuchs  <asf@void.at>

	* erc-truncate.el:
	* erc-truncate-buffer-to-size: use fboundp. Scheme takes its toll...

2003-05-01  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-truncate.el: remove require of erc-log
	(erc-truncate-buffer-to-size): use erc-save-buffer-in-logs when it's
	there, else, don't.

2003-04-29  Andreas Fuchs  <asf@void.at>

	* erc-log.el, erc-truncate.el, erc.el: erc.el:
		* erc-cmd-QUIT: Remove references to code in erc-log.el, to
		  not force autoloading of erc-log.el
		* erc-server-PART: ditto.
		* erc-quit-hook: new hook, run when /quit command is
		  processed.
		* erc-cmd-QUIT: use it.
		* erc-part-hook: new hook, run then PART message is
		  processed.
		* erc-cmd-PART: use it.
		* erc-connect-pre-hook: new hook, run before connection to IRC
		  server is started.
		* erc: use it.
		* erc-max-buffer-size: Move truncation variables and functions
		  to erc-truncate.el
		* erc-truncate-buffer-on-save: moved to erc-log.el
		* erc-initialize-log-marker: new function.
	* erc-log.el:
		* erc-truncate-buffer-on-save: New defcust here; from erc.el
		* erc-truncate-buffer-on-save: Put it in group `erc-log'
		* erc-log-channels-directory: Remove trailing slash from
		  default value.
		* Add functions to erc-connect-pre-hook, erc-part-hook and
		  erc-quit-hook to avoid getting autoloaded.

	* erc-truncate.el:
		* Contains the truncation functions and defcusts from erc.el.
		* define-erc-module clause added; new erc-truncate-mode.

2003-04-29  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el(erc):
	Check whether erc-save-buffer-in-logs is bound, too

	* erc.el(erc):
	Check whether erc-logging-enabled is bound before using it - not
	everyone is using erc-log.el!

2003-04-28  Andreas Fuchs  <asf@void.at>

	* erc-log.el:
	* while we're at it, remove the (declare (ignore ignore)) statements.

	* erc-log.el:
	* add autoload statement for erc-log-mode/etc. Sorry for the delay.

	* erc-log.el, erc.el: * erc.el:
		- move variables and functions to erc-log.el:
			 defgroup `erc-log'
	                 defcustom `erc-log-channels-directory'
			 defcustom `erc-log-insert-log-on-open'
			 defcustom `erc-generate-log-file-name-function'
			 defun `erc-save-buffer-in-logs' (autoloads from erc-log.el)
			 defuns `erc-generate-log-file-name-*'
			 defun `erc-current-logfile'
			 defun `erc-logging-enabled' (autoloads from erc-log.el)
		- erc-truncate-buffer-to-size: fix for double-saving bug when
		  writing out truncated buffer contents. Thanks, lawrence mitchell <wence@gmx.li>!
		- erc-remove-text-properties-region: Fix case for read-only text.
		- erc-send-current-line: update insert-marker before calling the hooks.
		                         also, wrap (erc-display-prompt) so that it doesn't toggle
					 buffer-modified-p.
		- erc-interpret-controls: remove /very/ old commented-out function
		- erc-last-saved-position: make it a marker
		- erc: use it.

	* erc-log.el: (thanks, lawrence mitchell <wence@gmx.li>!)
		- Move logging code from erc.el here
		- define-erc-module log: add; minor mode erc-log-mode is the
		  same as adding the `erc-save-buffer-in-logs' to
		  erc-send-post-hook and `erc-insert-post-hook'.
		- erc-w32-invalid-file-characters: add.
		- erc-enable-logging: add.
		- erc-logging-enabled: use it.
		- erc-logging-enabled: autoload.
		- erc-save-buffer-in-logs: fix for truncating saved buffer with read-only text.
		- erc-save-buffer-in-logs: use erc-last-saved-position.
		- erc-save-buffer-in-logs: fix saving half-written messages on
		  the prompt when saving the log file. (simply uses
		  erc-insert-marker as an upper bound for saving).

2003-04-27  Damien Elmes  <erc@repose.cx>

	* erc.el: erc-modules: added

2003-04-27  Alex Schroeder  <alex@gnu.org>

	* Makefile(UNCOMPILED): Added erc-compat.el.
	(clean): Remove .elc files, too.
	Patch by Hynek Schlawack <hynek+erc@hys.in-berlin.de>

2003-04-22  Damien Elmes  <erc@repose.cx>

	* erc-button.el:
	erc-button-keymap: set the parent keymap to erc-mode-map

2003-04-20  Damien Elmes  <erc@repose.cx>

	* erc.el:
	erc-official-location: shouldn't the official location be the base URL of erc?

	* erc.el:
	erc-modules: updated the docstring to make the semantics clearer

2003-04-19  Mario Lang  <mlang@delysid.org>

	* erc.el:
	Fix problem where % in NOTICE produced errors (from mmc)

2003-04-18  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-toggle-debug-irc-protocol):
	moved a reference to 'buf' inside the let
	    statement which defines it. it's difficult to tell what the original
	    intentions were here - at the moment the debug window is displayed when
	    toggling either way.

	* README, erc.el:
	(erc-update-modules: added a condition in for erc-nickserv -> erc-services

	* erc-pcomplete.el:
	- that change to erc-update-modules making it require the modules first means
	  we don't need any special case handling here, so i reverted the previous
	  change

	* erc.el:
	- don't require 'erc-auto, since windows users don't have access to make.
	  instead, we handle it in (erc-update-modules)

2003-04-17  Damien Elmes  <erc@repose.cx>

	* README, Makefile:
	Updated Makefile and documentation to reflect the new release

	* erc.el:
	- note the previous change also updated the release number to erc 4.0!
	(erc-connect): fix a bug introduced by the previous release

	* erc.el:
	fixed about 20 instances of (message (format ...)) which will break if the
	format returns a string with %s in it

	* erc.el: erc-error-face: make it red, not pink

	* erc-pcomplete.el:
	since pcomplete is autoloaded via erc-completion-mode, and completion is in
	erc-modules by default, we remove completion when pcomplete is added

	* erc.el(define-erc-module): no need for delete, use delq

	* erc-members.el(erc-nick-channels):
	(erc-person-channels) takes one arg
	(erc-format-user): again, they all take an arg

	* erc.el:
	- require erc-auto when loading, so the default `erc-modules' can be loaded.
	  this makes erc-auto no longer a convenience but a necessity - all the name
	  of user friendliness.
	(define-erc-module): the enable and disable routines now update erc-modules
	    accordingly
	erc-modules: new variable controlling the modules which erc has loaded/will
	    load. when customizing, it will automatically enable modules. it won't
	    automatically disable modules which are removed, yet.
	(erc-update-modules): enable all modules in `erc-modules'

	* erc-dcc.el(erc-dcc-open-network-stream):
	use the -nowait equiv if available
	erc-dcc-server-port: removed
	erc-dcc-port-range: allows a range of values, so you can have more than one
	    dcc
	(erc-dcc-server): support erc-dcc-port-range
	(erc-dcc-chat): use OCHAT for outgoing chat for now. we need to fix the
	    issues with allowing more than one chat with the same person

	* erc.el:
	erc-log-channels: removed; set the directory to start logging
	(erc-directory-writeable-p): create directory if it doesn't exist, check if
	    it's writable
	(erc-logging-enabled): don't reference erc-log-channels

2003-04-07  Damien Elmes  <erc@repose.cx>

	* erc.el(erc):
	but when inserting the contents of a previous logfile, use the logfile
	    name, not ""!

	* erc.el(erc):
	set buffer-file-name to "", since we have a custom saving function and
	    it's not needed. this enables one to open a log file with previous
	    correspondence, while talking to the person at the same time

2003-03-29  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-prepare-mode-line-format):
	Now strips all text properties from the target before
	    putting it in the mode line.  Keeps the mode line looking consistent.
	(erc-channel-p): Improved docstring.

2003-03-28  Alex Schroeder  <alex@gnu.org>

	* erc.el(erc-generate-log-file-name-with-date): New function.
	(erc-generate-log-file-name-function): Make it available.

2003-03-24  Mario Lang  <mlang@delysid.org>

	* erc.el:
	Fix erc-prompt and erc-user-mode custom :type (Closes: #185794)

2003-03-20  Damien Elmes  <erc@repose.cx>

	* erc.el:
	erc-server-hook-list: correct documentation of ordering of (proc parsed)

2003-03-16  Alex Schroeder  <alex@gnu.org>

	* erc-track.el(erc-modified-channels-string):
	Make it a risky-local-variable.

2003-03-16  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-track.el(erc-track-modified-channels):
	Use (point-min) if we don't find a
	parsed-property, so it won't error out with nil...

2003-03-16  Damien Elmes  <erc@repose.cx>

	* erc-track.el(erc-track-switch-buffer):
	removed call to erc-modified-channels-update, as
	    this is done correctly on buffer switching in both emacs and xemacs now

2003-03-15  Damien Elmes  <erc@repose.cx>

	* erc-track.el(erc-find-parsed-property):
	simplified a little, so it shouldn't return nil anymore

	* erc.el: erc-send-post-hook: document narrowing which occurs

2003-03-14  Alex Schroeder  <alex@gnu.org>

	* erc-track.el(erc-find-parsed-property): New function.
	(erc-track-modified-channels): Use it instead of relying on
	point-min.

2003-03-12  Mario Lang  <mlang@delysid.org>

	* erc.el:
	Fix erc-set-topic to accept a channel name as first word

2003-03-11  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-dcc.el:
	Small patch (<10 lines, also slightly modified by Jorgen Schäfer) from
	David Spreen <netzwurm@debian.org> to add hostmask-authentication to
	DCC auto-accept.

	erc-dcc-auto-mask-list: New variable
	(erc-dcc-handle-ctcp-send): Check erc-dcc-auto-mask-list
	(erc-dcc-auto-mask-p): New function
	erc-dcc-send-request: Docstring now mentions erc-dcc-auto-mask-list

2003-03-10  Francis Litterio  <franl@users.sourceforge.net>

	* erc-ring.el(erc-clear-input-ring):
	New function.  Erases the contents of the input ring for
	   the current ERC buffer.

2003-03-08  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el:
	(erc-display-line-1) and (erc-send-current-line): Now these functions reset erc-insert-this
	    to t as soon as possible after consuming the value of that variable.  See the comments in
	    the code for the strange symptom this fixes.
	(erc-bol): Changed to call point-at-eol instead of line-end-position.  This increases XEmacs
	    portability, since XEmacs doesn't have line-end-position.  Patch suggested by Scott Evans
	    on the ERC mailing list.

2003-03-04  Damien Elmes  <erc@repose.cx>

	* erc.el: banlist*: patch from mrbump to avoid using cl packages

2003-03-04  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el:
	Changed erc-noncommands-list from a constant to variable, so that users can
	    add their own erc-cmd-* functions to the list.  Improved the docstring too.

2003-03-02  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-server-353):
	Now the output of "/NAMES #channel" appears in the currently
	    active ERC buffer, even if the user is not a member of #channel.

	* erc.el(erc-cmd-DEOP):
	Fixed a syntax error: invalid read syntax ")" caused by my last change.

2003-03-01  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-cmd-DEOP):
	Fixed a wrong-type-argument error caused by calling split-string
	    on a list instead of on a string.  Removed the call to split-string entirely,
	    because it wasn't needed.

	* erc.el(erc-cmd-HELP):
	Changed to use intern-soft instead of intern.  Now "/HELP floob"
	    doesn't create a void function symbol erc-cmd-FLOOB.

2003-02-25  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-cmd-SERVER):
	remove erroneous references to line, use server instead

2003-02-23  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-toggle-debug-irc-protocol):
	Fixed a bug where the global value of
	    kill-buffer-hook was being modified instead of the buffer-local value.

2003-02-22  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-cmd-KICK):
	Now supports any number of words in the REASON string.  Examples
	    of the /KICK command are:
	      /KICK franl You don't belong here
	      /KICK franl Bye
	      /KICK franl
	      /KICK #channel franl Go away now
	      /KICK #channel franl Bye
	      /KICK #channel franl

2003-02-16  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-stamp.el(erc-insert-timestamp-right):
	Make the timestamp rear-nonsticky, so
	C-e works at the beginning of the next line.

2003-02-16  Andreas Fuchs  <asf@void.at>

	* erc-stamp.el:
	* s/choose/choice/ in customize options, as kensanata requested.

2003-02-15  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-toggle-debug-irc-protocol):
	Now if the *erc-protocol* buffer is killed,
	    logging is turned off.  Prior to this change, the buffer would come back
	    into existence (generally unbeknownst to the user) after being killed.

2003-02-11  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-send-current-line):
	we can't inhibit everything here when not connected,
	    as the user will expect commands like /server still to work. the
	    erc-cmd-handler should recover from errors instead

2003-02-10  Damien Elmes  <erc@repose.cx>

	* erc.el:
	* we now run erc-after-connect on 422 (no motd) messages as well as the motd
	  messages
	(erc-login): revert the previous change

	* erc.el(erc-login): register that we're connected

2003-02-10  Mario Lang  <mlang@delysid.org>

	* erc-members.el: * Provide erc-members
	* Fix excessive )
	* Comment out broken self-tests

2003-02-07  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-connect):
	notify the user we're trying to connect when using asych
	    connections

	* erc.el(erc-connect): support an asynchronous connection
	(erc-process-sentinel): ditto

	* erc-track.el:
	* advise switch-to-buffer in the case of xemacs, since it doesn't have
	  window-configuration-change-hook

	* erc.el(erc-send-current-line):
	if not connected, refuse to send either a message or
	    a command

	* erc.el: (erc-save-buffer-in-logs):
	    - check for a sensible region before saving the buffer. if the
	      connection process is killed early on, there is not a sensible region
	      to save
	    - don't set buffer-file-name on save. we don't need it, and it means we
	      can now find-file a log while an existing query is open with that
	      user

	* erc.el(erc-process-input-line):
	when displaying the help for a function, if no
	    documentation exists, don't fall over
	(erc-cmd-SAY): new function for quoting lines beginning with /
	(erc-server-NICK):
	    - fix a bug where the "is now known as" message doesn't appear on newly
	      created /query buffers
	    - when a user changes their nick, update the query to point to the new
	      nick

	* erc.el(erc-send-current-command):
	don't reject multi-line commands. since
	    multiline-p is used as the no-command arg to erc-process-current-line,
	    multi-line text is never interpreted as a command. i believe this is the
	    correct behavior - it allows people to post the output of things like df
	    (sans header). if you want to change this, please provide a rationale
	    in the changelog

	* erc.el(erc-send-current-line):
	only match the first line when determining if a
	    multi-line command is allowed

2003-02-07  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc-bbdb.el(erc-bbdb-highlight-record):
	Use alternate strings, not character
	classes to split the nick-field.

2003-02-06  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-process-sentinel):
	Now we set erc-connected to nil every time we disconnect
	    from a server, not just when an unexpected disconnect happens.

	* erc.el(erc-connected):
	Removed redundant defvar of this variable.  Improved the
	    docstring.
	(erc-login): Changed to send a correct RFC2812 USER message (see section
	    3.1.3 of RFC2812 for the documentation of the semantics of each argument
	    of the USER message.

2003-02-02  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-cmd-NOTICE): fix from mrbump

2003-01-31  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-cmd-JOIN):
	Now we only send one JOIN command to the server when a channel
	    key is provided.

2003-01-30  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-remove-channel-member):
	Fixed so that it runs erc-channel-members-changed-hook
	    with the channel buffer current, as is documented in the docstring for variable
	    erc-channel-members-changed-hook: "The buffer where the change happened is
	    current while this hook is called."

2003-01-28  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el:
	(erc-ignored-user-p),(erc-cmd-IGNORE),(erc-cmd-UNIGNORE): Now nicks are ignored
	    on a per-server basis.  Now, erc-ignore-list is only valid in server
	    buffers!  Do not reference it in channel buffers.

	* erc.el(erc-cmd-IGNORE):
	Now says "Ignore list is empty" if it erc-ignore-list is empty
	    instead of showing an empty list.

2003-01-25  Alex Schroeder  <alex@gnu.org>

	* erc-nickserv.el(services): Defined a module

2003-01-25  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el(erc-process-ctcp-query):
	Display recipient of CTCP query if it's not
	our current nick.

	* erc.el(erc-cmd-WHOIS):
	Accept an optional second argument SERVER.

2003-01-25  Alex Schroeder  <alex@gnu.org>

	* erc-stamp.el(stamp): erc-add-timestamp must always be added
	with the APPEND parameter -- not only when adding it on the right.

2003-01-24  Alex Schroeder  <alex@gnu.org>

	* erc-members.el(erc-channel-members-changed-hook): Obsolete, use
	erc-members-changed-hook instead.  When it is set, add its content
	to erc-members-changed-hook.
	(erc-update-channel-member): Obsolete, use erc-update-member
	instead.  Defalias to that effect.
	(erc-remove-channel-member): New and already obsolete.  Use
	erc-remove-nick-from-channel instead.
	(erc-update-channel-info-buffer): Obsolete, use ignore instead.
	Yes, these have to go.
	(erc-channel-member-to-user-spec): Obsolete, use erc-format-user
	instead.
	(erc-format-user): New.
	(erc-ignored-reply-p): New, use it.

	* erc-members.el:
	Further along the way.  Any function from erc.el that uses
	channel-members should end up in this file, rewritten to use
	erc-members.

	(erc-person): Call erc-downcase before getting
	something from the hash.
	(erc-nick-in-channel): Checking whether erc-process must be used is
	unnecessary -- this will be done in erc-person.
	(erc-nick-channels): New.
	(erc-add-nick-to-channel, erc-update-member): Call erc-downcase
	before putting something into the hash.
	(erc-buffer-list-with-nick): New.
	(erc-format-nick, erc-format-@nick): New, backwards incompatible.
	Must check for other places that call these!
	(erc-server-PRIVMSG-or-NOTICE): Use the new version.

	* erc-compat.el(view-mode-enter): defalias to view-mode, if
	view-mode-enter is not fboundp and view-mode is -- as is the case
	in XEmacs.  We need view-mode-enter in erc-match.el.

2003-01-23  Francis Litterio  <franl@users.sourceforge.net>

	* erc.el(erc-default-server-handler):
	Minor performance improvement: allow the lambda
	    expression to be byte-compiled.

2003-01-23  Damien Elmes  <erc@repose.cx>

	* erc.el(erc-cmd-BANLIST):
	in the absence of a fill-column, use the screen width

2003-01-22  Damien Elmes  <erc@repose.cx>

	* erc.el:
	patch from MrBump to delay fetching the banlist until /bl is run, so we don't
	fetch it when joining a channel anymore

	* erc-ring.el:
	* instead of adjusting hooks when loaded, provide (erc-ring-mode). you'll
	  need to run (erc-ring-mode 1) now to get the ring
	* (erc-previous-command), (erc-next-command):
	    - check if the ring exists and create it if necessary
	    - don't do anything if the ring is empty

	* erc-pcomplete.el:
	Put "how to use" documentation in the comments up the top

2003-01-21  Alex Schroeder  <alex@gnu.org>

	* erc-autojoin.el(erc-autojoin-version): New.

	* erc-autojoin.el(erc-autojoin-add): Added body.
	(erc-autojoin-remove): Added body.
	(erc-autojoin): Provide it.

2003-01-21  Damien Elmes  <erc@repose.cx>

	* erc.el: erc-cmd-*: removed a bunch of references to force

2003-01-21  Alex Schroeder  <alex@gnu.org>

	* erc-autojoin.el(erc-autojoin-channels-alist): More doc.

2003-01-20  Alex Schroeder  <alex@gnu.org>

	* erc-autojoin.el:
	new, based on resolve's mail, and the stuff on the wiki

	* erc-members.el: new

2003-01-19  Mario Lang  <mlang@delysid.org>

	* debian/README.Debian, debian/changelog, debian/scripts/install,
	  debian/scripts/startup.erc, Makefile:
	Prepare for 20030119 debian package

	* erc-dcc.el: <rant>
	* (erc-decimal-to-ip): Since XEmacs decides that return a completely
	and utterly wrong number from string-to-number if it is larger than
	the integer boundary, instead of sanely converting the thing to
	a float, we now (concat dec ".0").
	</rant>

	* erc.el:
	* (erc-log-irc-protocol): Use erc-propertize, not propertize

2003-01-19  Alex Schroeder  <alex@gnu.org>

	* erc-button.el(erc-button-add-buttons): Added regexp-quote for
	the list case, too.

2003-01-19  Damien Elmes  <erc@repose.cx>

	* erc-dcc.el(erc-dcc-member): fix for case where a prop is nil

	* erc-dcc.el(erc-dcc-member):
	fix for xemacs's version of plist-member

2003-01-19  Mario Lang  <mlang@delysid.org>

	* erc-notify.el: Delete empty strings from the ison-list

	* erc-track.el:
	* (erc-track-switch-buffer): Call erc-modified-channels-update here.

	* erc-track.el: * toplevel: require 'erc-match

	* erc-track.el: * (erc-track-mode): Make autoload interactive

	* erc-button.el: * (button): Make the autoload interactive

	* erc.el:
	* (erc-mode): Comment out the case-table stuff, breaks xemacs
	* (erc-downcase): Revert.

	* erc-dcc.el:
	* (erc-dcc-handle-ctcp-send): Use erc-decimal-to-ip on the ip we get...

	* erc-speak.el:
	Eliminate reference to erc-nick-regexp, which no longer exists

2003-01-19  Alex Schroeder  <alex@gnu.org>

	* erc-stamp.el(erc-timestamp-right-column): New, default nil.
	(erc-insert-timestamp-right): Use it, if non-nil.  Verbose
	doc string.

2003-01-18  Jorgen Schaefer  <forcer@users.sourceforge.net>

	* erc.el(erc-downcase): Use the old behavior in non-CVS Emacs.

	* erc.el(erc-cmd-QUIT): Remove &rest. The correct fix follows.
	(erc-cmd-GQUIT): Pass "" to erc-cmd-QUIT.
	(erc-mode): Use the case-table only in CVS Emacs. See comment.

	* erc.el(erc-cmd-QUIT): make reason optional.

	* erc.el(erc-cmd-GQUIT): Fixed typo.

2003-01-17  Mario Lang  <mlang@delysid.org>

	* erc.el:
	* (erc-current-logfile): call expand-file-name, so that downcase doesn't mess up ~

	* erc.el: * (erc-mode): Define a proper case-table.
	* (erc-downcase): just call downcase for now, let's see if the case-table is portable, if yes, we'll remove all erc-downcase references anyway...

	* erc-button.el: * (erc-button-add-buttons): regex-quote the nick

2003-01-17  Alex Schroeder  <alex@gnu.org>

	* erc-button.el(button): erc-channel-members-changed-hook no
	longer has erc-recompute-nick-regexp.
	(erc-button-alist): Use channel-members instead of
	erc-nick-regexp.
	(erc-button-add-buttons): Split some code into
